<?php
/**
 * $Id: config.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
class CommunityControllerConfig extends JController
{
	var $config = "";
	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'apply', 'save' );
		JRequest::setVar( 'view', 'config' );
	}
	function save()
	{
		$post = JRequest::get('post');
		$post['params']['groups::sections'] =  serialize($post['params']['groups::sections']);
		$params = new JParameter('');
		$params->bind($post['params']);

		jimport('joomla.filesystem.file');
		if (!JFile::write(JPATH_COMPONENT_ADMINISTRATOR.DS.'config.ini', $params->toString('INI')))
		{
			JError::raiseNotice(100, JText::_("Could not Save Configurations"));
		}
		else
		{
			$link = 'index.php?option=com_community';
			if (JRequest::getVar('task') == 'apply')
			$link = 'index.php?option=com_community&controller=config';

			$msg = JText::_( 'Saved Configuration' );
			$this->setRedirect( $link, $msg );
		}
	}
	function cancel()
	{
		$link = 'index.php?option=com_community';
		$this->setRedirect( $link );
	}
	function initialyze()
	{
		jimport('joomla.filesystem.file');
		$array = array();
		$ini = "";
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'config.ini'))
		{
			$ini = JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'config.ini');
		}
		else
		{
			return;
		}

		$params = new JParameter($ini);
		
		$params->def('general::profile_itemid', JRequest::getInt('Itemid'));
		$params->def('general::group_itemid', JRequest::getInt('Itemid'));
		$params->def('general::groups_itemid', JRequest::getInt('Itemid'));
		$params->def('general::list_itemid', JRequest::getInt('Itemid'));
		$params->def('general::activity_itemid', JRequest::getInt('Itemid'));
		
		$array = $params->toArray();
		foreach($array AS $key=> $row)
		{
			$key = explode("::", $key);
			if (!isset($key[1]))
			{
				continue;
			}
			//$key[0] = str_replace("_", " ",$key[0]);

			$name = sprintf('community_%s_%s', $key[0], $key[1]);
			if (is_array($row))
			{
				$row = implode('|', $row);
			}
			defined(strtoupper($name)) or define(strtoupper($name), $row, true);

			/*echo strtoupper($name."  ");
			 echo ($row).'<br>';*/

		}
		$defaultTmpl = CommunityControllerConfig::getDefaultTemplate('list');
		$name = sprintf('community_%s_%s', "GENERAL", "LIST_TEMPLATE");
		defined(strtoupper($name)) or define(strtoupper($name), @$defaultTmpl->template, true);
		$defaultTmpl = CommunityControllerConfig::getDefaultTemplate('profile');
		$name = sprintf('community_%s_%s', "GENERAL", "DEFAULT_PROFILE_TEMPLATE");
		defined(strtoupper($name)) or define(strtoupper($name), @$defaultTmpl->template, true);
		$defaultTmpl = CommunityControllerConfig::getDefaultTemplate('customlist');
		$name = sprintf('community_%s_%s', "GENERAL", "DEFAULT_CUSTOMLIST_TEMPLATE");
		defined(strtoupper($name)) or define(strtoupper($name), @$defaultTmpl->template, true);
		$defaultTmpl = CommunityControllerConfig::getDefaultTemplate('group');
		$name = sprintf('community_%s_%s', "GENERAL", "DEFAULT_GROUP_TEMPLATE");
		defined(strtoupper($name)) or define(strtoupper($name), @$defaultTmpl->template, true);
		$defaultTmpl = CommunityControllerConfig::getDefaultTemplate('groups_list');
		$name = sprintf('community_%s_%s', "GENERAL", "DEFAULT_GROUPS_LIST_TEMPLATE");
		defined(strtoupper($name)) or define(strtoupper($name), @$defaultTmpl->template, true);
	}

	function getDefaultTemplate($type= 'list')
	{
		$db = &JFactory::getDBO();
		$db->setQuery('SELECT * FROM #__community_templates WHERE `type` = "'.$type.'"');
		$template = $db->loadObject();
		if (empty($template))
		{
			$template = new StdClass();
			$template->template = 'default';
		}
		return $template;
	}


}
?>