<?php
/**
 * $Id: subtmpls.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');
jimport('joomla.client.helper');

class CommunityControllerSubtmpls extends CommunityController {

	function __construct()
	{
		parent::__construct();
		$this->registerTask('default', 'setDefault');

	}

	function display( )
	{
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'subtmpls.php');
		if(!JRequest::getVar('view')) JRequest::setVar( 'view'  , 'subtmpls');
		parent::display();
	}

	function doInstall()
	{
		global $mainframe;

		JRequest::checkToken() or die( 'Invalid Token' );

		$model	= &$this->getModel( 'Subtmplsinstall', 'CommunityModel' );

		if ($model->install()) {
			$cache = &JFactory::getCache('mod_menu');
			$cache->clean();

			$mainframe->enqueueMessage(JText::_('Templates has been installed successfully.'));
		}

		$mainframe->redirect( 'index.php?option=com_community&controller=subtmpls&view=subtmpls' );
		$this->display();
	}

	function doUninstall()
	{
		global $mainframe;
		JRequest::checkToken() or die( 'Invalid Token' );

		$tmpls = JRequest::getVar('cid');

		foreach( $tmpls as $tmpl ) {
			$matches = Array();
			preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

			if( $matches[1] == 'default' ){
				JError::raiseWarning( 500, JText::_('Default template you can copy only') );
				$this->display();
				return;
			}
		}

		$model = &$this->getModel( 'Subtmplsuninstall', 'CommunityModel' );

		$model->uninstall( $tmpls );

		$mainframe->redirect( 'index.php?option=com_community&controller=subtmpls&view=subtmpls', JText::_( 'Templates has been uninstalled successfully.' ) );

		$this->display();
	}

	function renameTmpl()
	{
		global $mainframe;
		JRequest::checkToken() or die( 'Invalid Token' );

		$tmpls    = JRequest::getVar('cid');

		$matches = Array();
		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpls[0], $matches );

		if( $matches[1] == 'default' ){
			JError::raiseWarning( 500, JText::_('Default template you can copy only') );
		} else {

			$new_name = JRequest::getVar('tmplname');
			while(strstr($new_name, "__"))
				$new_name = str_replace("__", "_", $new_name);
			if(!$new_name || ($new_name == '_'))
			{
				JError::raiseWarning(403, JText::_('Not valid template name'));
				$this->display();
				return;
			}

			$model = &$this->getModel( 'Subtmplscopyrename', 'CommunityModel' );
			if( $model->rename( $tmpls[0], $new_name ) ){
				$mainframe->redirect( 'index.php?option=com_community&controller=subtmpls&view=subtmpls', JText::_('Templates has been renamed successfully.' ) );
			}
		}
		$this->display();
	}

	function copyTmpl()
	{
		global $mainframe;

		JRequest::checkToken() or die( 'Invalid Token' );

		$new_name = JRequest::getVar('tmplname');
		while(strstr($new_name, "__"))
			$new_name = str_replace("__", "_", $new_name);
		if(!$new_name || ($new_name == '_'))
		{
			JError::raiseWarning(403, JText::_('Not valid template name'));
			$this->display();
			return;
		}
		$tmpls    = JRequest::getVar('cid');

		$model = &$this->getModel( 'Subtmplscopyrename', 'CommunityModel' );

		if( $model->copy( $tmpls[0], $new_name ) ){
			$mainframe->redirect( 'index.php?option=com_community&controller=subtmpls&view=subtmpls', JText::_('Templates has been copied successfully.' ) );
		}

		$this->display();
	}

	function apply()
	{
		$this->save();
	}

	function cancel()
	{
		global $mainframe;
		$mainframe->redirect( 'index.php?option=com_community&controller=subtmpls&view=subtmpls' );
	}

	function save()
	{
		global $mainframe;


		$task = JRequest::getCmd( 'task' );

		foreach ($_POST['params'] as $var => $val) {
			if( is_array( $val ) ) $_POST['params'][$var] = serialize($val);
		}
		$type = JRequest::getVar('type');

		$name = JRequest::getVar('name');
		$layouts_path = CommunitySubTemplate::getTmplPath( $type );

		$file_name = CommunitySubTemplate::getTmplFile( $type, $name );

		$params = new JParameter( $_POST['params'], $file_name.'.xml' );
		$params->bind( $_POST['params'] );
		$ini = $params->toString();

		JFile::write( $file_name.'.ini', $ini);

		$msg = JText::_( 'Successfully Saved Configuration' );

		switch ( $task ) {
			case 'apply':
				$mainframe->redirect( 'index.php?option=com_community&controller=subtmpls&view=subtmpls&layout=form&cid[]=['.$name.'],['.$type.']', $msg );
				break;
			case 'save':
			default:
				$mainframe->redirect( 'index.php?option=com_community&controller=subtmpls&view=subtmpls', $msg );
				break;
		}
	}

	function setDefault()
	{
		$db = &JFactory::getDBO();

		$cid = JRequest::getVar('cid', array());
		$cid = $cid[0];
		$cid  = explode(",", $cid);
		$cid = str_replace(array('[', ']'),'' ,$cid);
		$cid[1] = CommunitySubTemplate::getTmplTrueName($cid[1]);
		/*print "<pre>";
		 print_r($cid);
		 print "</pre>";*/
		$model = &JModel::getInstance('SubTmpls', 'CommunityModel');
		if ($model->setDefault(array('type'=>$cid[1], 'template'=>$cid[0])))
		{
			$msg = JText::_("Default Template Changed");
		}
		else
		{
			$msg = JText::_("Error Changing Default Template");
		}
		$this->setRedirect('index.php?option=com_community&controller=subtmpls', $msg);
	}


}
?>