<?php
/**
 * $Id: subtmpls.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');
class CommunitySubTemplate
{

	function getTmplPath( $type )
	{

		switch( $type ){
			case 'itemlist':
				$tmpl_path = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'list'.DS.'tmpl';
				break;
			case 'profile':
				$tmpl_path = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'profile'.DS.'tmpl';
				break;
			case 'custom':
				$tmpl_path = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'customlist'.DS.'tmpl';
				break;
			case 'groups_list':
			case 'group':
				$tmpl_path = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'groups'.DS.'tmpl';
				break;
		}
		return $tmpl_path;

	}

	function getTmplImgSrc( $type, $name )
	{
		$img_path = '';
		switch ( $type ) {
			case 'itemlist':
				$view = 'list';
				$name     = 'default_subtmpl_'.$name.'.png';
				$img_path = JURI::root().'components/com_community/views/'.$view.'/tmpl/'.$name;
				break;
			case 'profile':
				$view = 'profile';
				$name     = 'default_profile_'.$name.'.png';
				$img_path = JURI::root().'components/com_community/views/'.$view.'/tmpl/'.$name;
				break;
			case 'custom':
				$view = 'customlist';
				$name     = 'default_customlist_'.$name.'.png';
				$img_path = JURI::root().'components/com_community/views/'.$view.'/tmpl/'.$name;
				break;
			case 'groups_list':
				$view = 'groups';
				$name     = 'default_groups_'.$name.'.png';
				$img_path = JURI::root().'components/com_community/views/'.$view.'/tmpl/'.$name;
				break;
			case 'group':
				$view = 'groups';
				$name     = 'group_groups_'.$name.'.png';
				$img_path = JURI::root().'components/com_community/views/'.$view.'/tmpl/'.$name;
				break;
		}

		return $img_path;
	}

	function getTmplFile( $type, $name )
	{
		$layouts_path = CommunitySubTemplate::getTmplPath( $type );
		$result='';

		switch ( $type ) {
			case 'itemlist':
				$result = $layouts_path.DS.'default_list_'.$name;
				break;
			case 'profile':
				$result = $layouts_path.DS.'default_profile_'.$name;
				break;
			case 'custom':
				$result = $layouts_path.DS.'default_customlist_'.$name;
				break;
			case 'groups_list':
				$result = $layouts_path.DS.'default_groups_'.$name;
				break;
			case 'group':
				$result = $layouts_path.DS.'group_groups_'.$name;
				break;
		}

		return $result;
	}

	function getTmplMask( $type, $name = '.*' )
	{

		$result = Array();

		switch( $type ){
			case 'itemlist':
				$result['index_file'] = '^default_list_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_list_)/", "/(\..{3})$/" );
				break;
			case 'profile':
				$result['index_file'] = '^default_profile_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_profile_)/", "/(\..{3})$/" );
				break;
			case 'custom':
				$result['index_file'] = '^default_customlist_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_customlist_)/", "/(\..{3})$/" );
				break;
			case 'groups_list':
				$result['index_file'] = '^default_groups_'.$name.'\.xml$';
				$result['ident']      = array( "/^(default_groups_)/", "/(\..{3})$/" );
				break;
			case 'group':
				$result['index_file'] = '^group_groups_'.$name.'\.xml$';
				$result['ident']      = array( "/^(group_groups_)/", "/(\..{3})$/" );
				break;

		}


		return $result;
	}

	function getTmplFullMask( $type, $name = '.*' )
	{

		$result = Array();

		switch( $type ){
			case 'itemlist':
				$result['index_file'] = '^default_list_'.$name.'\..{3}$';
				$result['title']      = array( "/^(default_list_)/", "/(\..{3})$/" );
				break;

			case 'profile':
				$result['index_file'] = '^default_profile_'.$name.'\..{3}$';
				$result['title']      = array( "/^(default_profile_)/", "/(\..{3})$/" );
				break;
			case 'custom':
				$result['index_file'] = '^default_customlist_'.$name.'\..{3}$';
				$result['title']      = array( "/^(default_customlist_)/", "/(\..{3})$/" );
				break;
			case 'groups_list':
				$result['index_file'] = '^default_groups_'.$name.'\..{3}$';
				$result['ident']      = array( "/^(default_groups_)/", "/(\..{3})$/" );
				break;
			case 'group':
				$result['index_file'] = '^group_groups_'.$name.'\..{3}$';
				$result['ident']      = array( "/^(group_groups_)/", "/(\..{3})$/" );
				break;
		}


		return $result;
	}


	function getTmplTrueName($type)
	{
		switch ($type)
		{
			case 'itemlist':
				return 'list';
			break;

			case 'profile':
				return 'profile';
			break;
			case 'custom':
				return 'customlist';
			break;
			case 'groups_list':
				return 'groups_list';
			break;
			case 'group':
				return 'group';
			break;
		}

	}
	
}

?>