<?php 
/**
 * $Id: categories.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access'); 
jimport('joomla.application.component.model');
class CommunityModelCategories extends JModel
{
	var $_id           = null;
	var $_parent_id    = null;
	var $_data         = null;
	var $_pagination   = null;
	var $_total        = null;

	function __construct()
	{
		global $mainframe, $option;
		parent::__construct();
		$limit	    = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.categories.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit',      $limit);
		$this->setState('limitstart', $limitstart);
		//$this->_setId();
	}
	function _setId($id = null)
	{
		if (empty($id))
		{
			$array = JRequest::getVar('cid', array(0), '', 'array');
			$this->_id = $array[0];
		}
	}


	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
			$this->_addInfo();
		}

		return $this->_data;
	}

	/**
	 * Method to get the total number of weblink items
	 *
	 * @access public
	 * @return integer
	 */
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	/**
	 * Method to get a pagination object for the weblinks
	 *
	 * @access public
	 * @return integer
	 */
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function _buildQuery()
	{
		$where = $this->_buildWhere();
		$orderby = $this->_buildOrderBy();
		$sql = "SELECT a.*,  g.name AS groupname FROM #__community_group_categories AS a "
				. "\n LEFT JOIN #__groups AS g ON g.id = a.access "
				."\n WHERE 1".$where
				."\n ".$orderby;

		return $sql;
	}

	function _buildWhere()
	{
		global $mainframe, $option;
		$search	= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search	= JString::strtolower( $search );
		return "";


	}

	function _buildOrderBy()
	{
		global $mainframe, $option;

		$filter_order		  = $mainframe->getUserStateFromRequest( $option.'.fields.filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	  = $mainframe->getUserStateFromRequest( $option.'.fields.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY  a.ordering '.$filter_order_Dir;
		} else {
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , a.ordering ';
		}
		return $orderby;


	}

	function _addInfo()
	{
		for($i = 0; $i < count($this->_data); $i++)
		{
			$item = &$this->_data[$i];
			$sql = "SELECT COUNT(*) FROM #__community_communities WHERE catid = {$item->id} AND published > 0";
			$this->_db->setQuery($sql);
			$item->numGroups = $this->_db->loadResult();

		}

	}


	/**************************************************************************/
	/**************************************************************************/
	/**************************************************************************/
	/**************************************************************************/
	/**************************************************************************/

	function changePublish($state, $id)
	{

		$tCategories = &JTable::getInstance("Categories", 'CommunityTable');
		if ($tCategories->load($id))
		{
			$tCategories->set('published', $state);
			return $tCategories->store();
		}
		return false;
	}

	function move($direction)
	{
		$row =& $this->getTable('Categories', 'CommunityTable');
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction, ' published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	function saveorder($cid = array(), $order)
	{
		$row =& $this->getTable('Categories', "CommunityTable");


		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group

		$row->reorder();


		return true;
	}

	/**************************************************************************/
	/**************************************************************************/
	/**************************************************************************/
	/**************************************************************************/
	/**************************************************************************/


	function store(&$post)
	{
		$id = (int)@$post['cid'][0];


		$post['access_create'] = @implode("|", @$post['access_create']);
		/*print "<pre>";
		print_r($post);
		print "</pre>";*/
		$params = new JParameter('');

		$params->bind(@$post['params']);
		$post['params'] = $params->toString();
		unset($post['cid']);
		unset($post['params']);
		$tCategories = &JTable::getInstance('Categories', 'CommunityTable');
		if ($id > 0)
		{
			$tCategories->load($id);
		}
		$tCategories->bind($post);
		if (!$tCategories->store())
		{
			JError::raiseNotice(500, JText::_("Category could not be saved"));
			return false;
		}
/*		print "<pre>";
		print_r($tCategories);
		print "</pre>";
		exit;
*/		return $tCategories->id;

	}

}
?>