<?php
/**
 * $Id: subtmpls.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.filesystem.file');

class CommunityModelSubtmpls extends JModel
{

	var $_data          = null;
	var $_fullData      = null;
	var $_total         = null;
	var $_pagination    = null;
	var $_error         = false;

	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		$limit		    = $mainframe->getUserStateFromRequest( 'global.list.limit',             'limit',        $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	  = $mainframe->getUserStateFromRequest( $option.'.users.limitstart',     'limitstart',   0,                                'int' );
		$filter_types = $mainframe->getUserStateFromRequest( $option.'category.filter_types', 'filter_types', '',                               'word' );

		$this->setState( 'limit',        $limit );
		$this->setState( 'limitstart',   $limitstart );
		$this->setState( 'filter_types', $filter_types );
	}

	function getData()
	{

		if( $this->_data ){
			return $this->_data;
		}

		$this->_data = new stdClass();

		$this->_data->itemlist = $this->getTmplObjectList( 'itemlist' );
		$this->_data->profile  = $this->getTmplObjectList( 'profile' );
		$this->_data->custom  = $this->getTmplObjectList( 'custom' );
		$this->_data->groups_list  = $this->getTmplObjectList( 'groups_list' );
		$this->_data->group  = $this->getTmplObjectList( 'group' );


		/*$this->_fullData = array_merge( $this->_data->itemlist, $this->_data->rating, $this->_data->comments, $this->_data->article );

		if( $this->getState( 'limit' ) == 0 ){
		$this->_data = $this->_fullData;
		} else {
		$this->_data = array_slice( $this->_fullData, $this->getState('limitstart'), $this->getState('limit') );
		}*/

		//print_r( $this->_data ); exit;

		return $this->_data;
	}

	function getTotal()
	{

		if( !$this->_fullData ){
			$this->getData();
		}

		$this->_total = count( $this->_fullData );

		return $this->_total;
	}

	function getPagination()
	{
		if ( empty( $this->_pagination ) ) {
			jimport( 'joomla.html.pagination' );
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function getTmplObjectList( $type )
	{
		$result = array();

		if( $this->getState('filter_types') && $this->getState('filter_types') != $type ){
			return $result;
		}

		$layouts_path = CommunitySubTemplate::getTmplPath( $type );
		$tmpl_mask    = CommunitySubTemplate::getTmplMask( $type );


		$files = JFolder::files( $layouts_path, $tmpl_mask['index_file'] );
		foreach( $files as $key => $file ){
			$result[$key]        = new stdClass();
			$result[$key]->ident = preg_replace ( $tmpl_mask['ident'], '', $file );
			$result[$key]->type  = $type;

			$xmlfile = CommunitySubTemplate::getTmplFile( $type, $result[$key]->ident.'.xml' );

			$tmplXMLdata = $this->parseXMLTemplateFile($xmlfile);

			if ($tmplXMLdata) {
				foreach($tmplXMLdata as $xmlkey => $value) {
					$result[$key]->$xmlkey = $value;
				}
			}

		}

		return $result;
	}

	function parseXMLTemplateFile($path)
	{
		// Read the file to see if it's a valid component XML file
		$xml = & JFactory::getXMLParser('Simple');

		if (!$xml->loadFile($path)) {
			unset($xml);
			return false;
		}

		/*
		* Check for a valid XML root tag.
		*
		* Should be 'install', but for backward compatability we will accept 'mosinstall'.
		*/
		if ( !is_object($xml->document) || $xml->document->name() != "joomsuitesubtmpl" ) {
			unset($xml);
			return false;
		}

		$data = array();

		$element = & $xml->document->name[0];
		$data['name'] = $element ? $element->data() : '';

		$element = & $xml->document->creationDate[0];
		$data['creationdate'] = $element ? $element->data() : 'Unknown';

		$element = & $xml->document->author[0];
		$data['author'] = $element ? $element->data() : 'Unknown';

		$element = & $xml->document->copyright[0];
		$data['copyright'] = $element ? $element->data() : '';

		$element = & $xml->document->authorEmail[0];
		$data['authorEmail'] = $element ? $element->data() : '';

		$element = & $xml->document->authorUrl[0];
		$data['authorUrl'] = $element ? $element->data() : '';

		$element = & $xml->document->version[0];
		$data['version'] = $element ? $element->data() : '';

		$element = & $xml->document->description[0];
		$data['description'] = $element ? $element->data() : '';

		$element = & $xml->document->group[0];
		$data['group'] = $element ? $element->data() : '';

		//var_dump( $xml->document );print'<br><br>';

		return $data;
	}

	function setDefault($array= array())
	{
		$table = &$this->getTable('Templates', 'CommunityTable');
		if ($array['type'])


		if(!$table->load($array['type']))
		{
			$table->type = $array['type'];
			$table->template = $array['template'];
			$this->_db->setQuery("INSERT INTO #__community_templates VALUES ('{$array['type']}', '{$array['template']}') ");
			$this->_db->query();
			return true;

		}
		else
		{
			$table->bind($array);

			if($table->store())
			{
				return true;
			}
		}
	}
	function getDefault($type = 'list')
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT * FROM #__community_templates WHERE `type` = '{$type}'";
		$db->setQuery($sql);
		$result = new stdClass();
		$result = $db->loadObject();
		if (!@$result->template || @$result->template=='')
		{
			$result->type = $type;
			$result->template = 'default';
		}
		return $result;
	}

}
?>
