<?php 
/**
 * $Id: subtmplscopyrename.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access'); 

jimport( 'joomla.application.component.model' );
jimport( 'joomla.filesystem.file' );

class CommunityModelSubtmplscopyrename extends JModel
{
	/** @var object JTable object */
	var $_table = null;

	/** @var object JTable object */
	var $_url = null;

	/**
   * Overridden constructor
   * @access  protected
   */
	function __construct()
	{
		parent::__construct();
	}

	function rename( $tmpl, $new_name )
	{
		global $mainframe;
		
		$title = ucfirst( $new_name );
		
		$new_name = ereg_replace("[^a-zA-Z]", '_', $new_name);

		$matches = array();

		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

		$layouts_path = CommunitySubTemplate::getTmplPath( $matches[2] );

		switch( $matches[2] ){
			case 'itemlist':
				$index_file_name    = "default_list_".$new_name.".xml";
				$file_filter        = "^default_list_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_list_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'profile':
				$index_file_name    = "default_profile_".$new_name.".xml";
				$file_filter        = "^default_profile_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_profile_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'custom':
				$index_file_name    = "default_customlist_".$new_name.".xml";
				$file_filter        = "^default_customlist_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_customlist_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'groups_list':
				$index_file_name    = "default_groups_".$new_name.".xml";
				$file_filter        = "^default_groups_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_groups_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'group':
				$index_file_name    = "group_groups_".$new_name.".xml";
				$file_filter        = "^group_groups_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(group_groups_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
		}

		if( JFile::exists($layouts_path.DS.$index_file_name) ){
			JError::raiseWarning( 500, JText::_('Can`t rename template. This name already exist.') );
			return false;
		}

		$files = JFolder::files( $layouts_path, $file_filter );

		foreach( $files as $file ){
			JFile::move($layouts_path.DS.$file, $layouts_path.DS.preg_replace ($file_new_tmpl_name[0], $file_new_tmpl_name[1], $file ) );
		}
		
		//write normal title in xml file for display in group form on site normal name without _
		
		$xml = new JSimpleXML();
		$xml->loadFile($layouts_path.DS.$index_file_name);
		$xml->document->_children[0]->setData($title);
		JFile::write($layouts_path.DS.$index_file_name, $xml->document->toString());
		
		return true;
	}

	function copy( $tmpl, $new_name )
	{
		global $mainframe;
		
		$title = ucfirst( $new_name );
		
		$new_name = ereg_replace("[^a-zA-Z]", '_', $new_name);

		$matches = array();

		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

		$layouts_path = CommunitySubTemplate::getTmplPath( $matches[2] );

		switch( $matches[2] ){
			case 'itemlist':
				$index_file_name    = "default_list_".$new_name.".xml";
				$file_filter        = "^default_list_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_list_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'profile':
				$index_file_name    = "default_profile_".$new_name.".xml";
				$file_filter        = "^default_profile_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_profile_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'custom':
				$index_file_name    = "default_customlist_".$new_name.".xml";
				$file_filter        = "^default_customlist_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_customlist_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'groups_list':
				$index_file_name    = "default_groups_".$new_name.".xml";
				$file_filter        = "^default_groups_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(default_groups_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
			case 'group':
				$index_file_name    = "group_groups_".$new_name.".xml";
				$file_filter        = "^group_groups_".$matches[1]."\..{3}$";
				$file_new_tmpl_name = Array( "/^(group_groups_).*(\..{3})$/", "\\1".$new_name."\\2" );
				break;
		}

		if( !$new_name ){
			$new_name = $matches[1].'_copy';
			while( JFile::exists($layouts_path.DS.sprintf($index_file_name, $new_name) ) ) {
				JError::raiseWarning( 500, JText::_('Can`t copy template. This name already exist.') );
				$new_name = $new_name.'_copy';
			}
		} else if( JFile::exists($layouts_path.DS.sprintf($index_file_name, $new_name)) ) {
			JError::raiseWarning( 500, JText::_('Can`t copy template. This name already exist.') );
			return false;
		}

		$files = JFolder::files( $layouts_path, $file_filter );

		foreach( $files as $file ){
			$original_file = $layouts_path.DS.$file;
			$new_file      = $layouts_path.DS.preg_replace ($file_new_tmpl_name[0], sprintf($file_new_tmpl_name[1], $new_name), $file );
			JFile::copy($original_file, $new_file);
		}
		
		//write normal title in xml file for display in group form on site normal name without _
		
		$xml = new JSimpleXML();
		$xml->loadFile($layouts_path.DS.$index_file_name);
		$xml->document->_children[0]->setData($title);
		JFile::write($layouts_path.DS.$index_file_name, $xml->document->toString());
		
		return true;
	}
}
?>