<?php 
/**
 * $Id: subtmplsinstall.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access'); 

jimport( 'joomla.application.component.model' );
jimport( 'joomla.installer.installer' );
jimport( 'joomla.installer.helper' );

class CommunityModelSubtmplsinstall extends JModel
{

  function __construct()
  {
    parent::__construct();
  }

  function install()
  {
    global $mainframe;

    $package = $this->_getPackageFromUpload();


    // Was the package unpacked?
    if (!$package) {
      $this->setState('message', JText::_('Unable to find install package'));
      return false;
    }

    $config =& JFactory::getConfig();

    // Cleanup the install files
    if (!is_file($package['packagefile'])) {
      $package['packagefile'] = $config->getValue('config.tmp_path').DS.$package['packagefile'];
    }

    if (is_file($package['packagefile'])) {
			JFile::delete($package['packagefile']);
		} elseif (is_file(JPath::clean($config->getValue('config.tmp_path').DS.$package['packagefile']))) {
			// It might also be just a base filename
			JFile::delete(JPath::clean($config->getValue('config.tmp_path').DS.$package['packagefile']));
		}

    return true;
  }

  function _getPackageFromUpload()
  {
    // Get the uploaded file information
    $userfile = JRequest::getVar('install_package', null, 'files', 'array' );

    // Make sure that file uploads are enabled in php
    if (!(bool) ini_get('file_uploads')) {
      JError::raiseWarning('SOME_ERROR_CODE', JText::_('The installer cannot continue until file uploads are enabled for the server.'));
      return false;
    }

    // Make sure that zlib is loaded so that the package can be unpacked
    if (!extension_loaded('zlib')) {
      JError::raiseWarning('SOME_ERROR_CODE', JText::_('The installer cannot continue until Zlib is installed.'));
      return false;
    }

    // If there is no uploaded file, we have a problem...
    if (!is_array($userfile) ) {
      JError::raiseWarning('SOME_ERROR_CODE', JText::_('No file selected'));
      return false;
    }

    // Check if there was a problem uploading the file.
    if ( $userfile['error'] || $userfile['size'] < 1 )
    {
      JError::raiseWarning('SOME_ERROR_CODE', JText::_('There was an error uploading this file to the server.'));
      return false;
    }

    // Build the appropriate paths
    $layouts_path = JPATH_COMPONENT_SITE.DS.'views';
    $tmp_src      = $userfile['tmp_name'];

    // Move uploaded file
    jimport('joomla.filesystem.file');
    $config =& JFactory::getConfig();
    $tmp_dest 	= $config->getValue('config.tmp_path').DS.$userfile['name'];
    $uploaded = JFile::upload( $tmp_src, $tmp_dest );

    // Unpack the downloaded package file
    $package = $this->unpack( $tmp_dest, $layouts_path );

    return $package;
  }

  function unpack( $p_filename, $layouts_path )
	{
		// Path to the archive
		$archivename = $p_filename;

		// Clean the paths to use for archive extraction
		$extractdir  = JPath::clean($layouts_path);
		$archivename = JPath::clean($archivename);

		// do the unpacking of the archive
		$result = JArchive::extract( $archivename, $extractdir);

		if ( $result === false ) {
			return false;
		}

		$retval['extractdir']  = $extractdir;
		$retval['packagefile'] = $archivename;

		$dirList = array_merge(JFolder::files($extractdir, ''), JFolder::folders($extractdir, ''));

		if (count($dirList) == 1) {
			if (JFolder::exists($extractdir.DS.$dirList[0])) {
				$extractdir = JPath::clean($extractdir.DS.$dirList[0]);
			}
		}

		$retval['dir'] = $extractdir;

		return $retval;
	}

}