<?php
/**
 * $Id: api.php 7951 2012-03-14 07:17:02Z kostya $
 * $LastChangedDate: 2012-03-14 13:17:02 +0600 (Wed, 14 Mar 2012) $
 * $LastChangedBy: kostya $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
JHTML::_('behavior.tooltip', '.userMenu', array('fixed' => 1, 'hideDelay' => 1500, 'className' => 'usermenu'));

require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_community'.DS.'controllers'.DS.'config.php');
CommunityControllerConfig::initialyze();

$docuement = &JFactory::getDocument();
$docuement->addStyleSheet(JURI::root().'components/com_community/assets/userdropdownmenu.css');

class JSCommunityApi
{
	/**
	 * Increas user Karma. Add points to main user account. The calculation of the level
	 * user get is done in Configuration
	 *
	 * @param int $user_id ID of the user
	 * @param int $value how many points to add
	 */
	function increaseKarma($user_id, $value)
	{
		//JException::getTraceAsString()
		$db = &JFactory::getDBO();
		$sql = "SELECT id FROM #__community_user_extra WHERE user_id = ".(int)$user_id;
		$db->setQuery($sql);
		$result = $db->loadResult();

		if($result)
		{
			$sql = "UPDATE #__community_user_extra SET carma = carma + {$value} WHERE user_id = ".(int)$user_id;
		}
		else
		{
			$sql = "INSERT INTO #__community_user_extra VALUES (NULL, '$user_id', '$value')";
		}
		$db->setQuery($sql);
		$db->query();
	}

	function getUserCarma($user_id)
	{
		static $carmaTypes = null;
		$userCarma = new stdClass();
		$userCarma->points = 0;
		$userCarma->image  = "";
		if (!intval($user_id))
		{
			$userCarma->points = 0;
			$userCarma->title  = '';
			$userCarma->image  = "";
			return $userCarma;
		}
		if (!defined('COMMUNITY_CARMA_TYPES'))
		{
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_community'.DS.'controllers'.DS.'config.php');
			CommunityControllerConfig::initialyze();
		}
		if (empty($carmaTypes))
		{

			$carmaArray1 = explode("\n", COMMUNITY_CARMA_TYPES);
			foreach ($carmaArray1 as $val)
			{
				$carmaArray2 = explode("::", $val);
				$carmaTypes[$carmaArray2[1]] = ($carmaArray2[0]);
			}
		}
		$db = &JFactory::getDBO();
		$sql = "SELECT * FROM #__community_user_extra WHERE user_id = {$user_id}";
		$db->setQuery($sql);
		$result = $db->loadObject();
		ksort($carmaTypes);
		$total = count($carmaTypes);
		if ($result)
		{
			$counter = 0;

			foreach($carmaTypes as $amount=>$val)
			{

				$counter++;
				if ($result->carma >= $amount)
				{

					if ($counter == $total)
					{
						$userCarma->points = $result->carma;
						$userCarma->title = $val;
						for($i = 0; $i<$counter; $i++)
						{
							$userCarma->image .="<img src=\"".JURI::root()."components/com_community/images/carma/".COMMUNITY_CARMA_ACTIVE_IMAGE."\" />";
						}
					}
				}
				else
				{
					$userCarma->points = $result->carma;
					$userCarma->title = $carmaTypes[$prev_key];

					for($i = 0; $i<$counter-1; $i++)
					{
						$userCarma->image .="<img src=\"".JURI::root()."components/com_community/images/carma/".COMMUNITY_CARMA_ACTIVE_IMAGE."\" />";
					}
					for($i = 0; $i<=($total-$counter); $i++)
					{
						$userCarma->image .="<img src=\"".JURI::root()."components/com_community/images/carma/".COMMUNITY_CARMA_INACTIVE_IMAGE."\" />";
					}
					break;
				}
				$prev_key = $amount;
			}

		}
		else
		{
			$counter = 0;
			foreach($carmaTypes as $amount=>$val)
			{
				if ($counter==0)
				{
					$userCarma->points = 0;
					$userCarma->title = $val;
					for($i = 0; $i<($total); $i++)
					{

						$userCarma->image .="<img src=\"".JURI::root()."components/com_community/images/carma/".COMMUNITY_CARMA_INACTIVE_IMAGE."\" />";
					}
					break;
				}
				$counter++;
			}

		}
		return $userCarma;
	}
	/**
	 * This function allows to get the list of all carma types from the system
	 *
	 * @return array
	 */
	function getCarmaList()
	{
		static $carmaList = null;
		if (!defined('COMMUNITY_CARMA_TYPES'))
		{
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_community'.DS.'controllers'.DS.'config.php');
			CommunityControllerConfig::initialyze();
		}
		if (empty($carmaList))
		{

			$carmaArray1 = explode("\n", COMMUNITY_CARMA_TYPES);

			foreach ($carmaArray1 as $val)
			{
				$carmaArray2 = explode("::", $val);
				$carmaTypes[$carmaArray2[1]]['title'] = $carmaArray2[0];
				$carmaTypes[$carmaArray2[1]]['points'] = intval($carmaArray2[1]);

			}
			ksort($carmaTypes);
			$i = 0;
			foreach($carmaTypes as $carma)
			{
				$carmaList[$i] = $carma;
				$i++;
			}
		}
		/*print "<pre>";
		 print_r($carmaList);
		 print "</pre>";*/
		return $carmaList;

	}

	function cutTheCarma($user, $carmaList)
	{
		$karma_index = $user->get('karmaindex', 0);
		$gid = $user->get('gid');
		if (($gid >= 20 && $gid <= 25))
		{
			return $carmaList;
		}
		else
		{
			return array_slice($carmaList, 0, $karma_index+1);
		}
	}
	/**
	 * Changes the global site template;
	 *
	 * @param string $templateName
	 * @param int $user
	 */
	function setUserTemplate($templateName, $user = null)
	{
		global $mainframe;

		$currentSiteTemplate = @$mainframe->setTemplate;

		if ($currentSiteTemplate != $templateName && $templateName != '')
		{
			$mainframe->setTemplate = $templateName;
		}
	}

	/**
	 * Gets the name of the current global site template
	 *
	 * @param int $user id of the user whose template must be returned
	 */
	function getUserTemplateName($user = null)
	{
		global $mainframe;
		if (empty($user))
		{
			$user = JFactory::getUser();
		}
		else
		{
			$user = JFactory::getUser($user);
		}

		return JSCommunityApi::getParam('profile_site_template',$mainframe->getUserState('setTemplate'), $user->get('id'));
	}
	/**
	 * Set parameter for the specified user
	 * if user is not provided current user will be taken by default
	 *
	 * @param string $key name of the parameter
	 * @param string $value value to put
	 * @param int $user user's id
	 */
	function setParam($key = '', $value = "", $user_id = null)
	{
		jimport('joomla.filesystem.file');

		if ($user_id == null)
		{
			$user = JFactory::getUser();
			$user_id = $user->get('id');
		}
		if ($user_id == 0)
		{
			JError::raiseNotice(100, JText::_('MightyCommunity setParam function: user_id must be specified'));
			return '';
		}
		$file = COMMUNITY_GENERAL_USERCONFIG.DS.$user_id.'.ini';
		$ini = JFile::read($file);
		$params = new JParameter($ini);
		$params->set($key, $value);
		$ini = $params->toStrings();
		return JFile::write($file, $ini);
	}
	/**
	 * Gets parameter of the specified user
	 * if user is not provided, current user is taken by default
	 *
	 * @param stirng $key
	 * @param mixed $default
	 * @param int $user
	 */
	function getParam($key = '', $default = "", $user_id = null)
	{
		jimport('joomla.filesystem.file');

		if ($user_id == null)
		{
			$user = JFactory::getUser();
			$user_id = $user->get('id');
		}

		if ($user_id == 0)
		{
			JError::raiseNotice(100, JText::_('MightyCommunity getParam function: user_id must be specified'));
			return '';
		}
		$ini = '';
		if(JFile::exists(COMMUNITY_GENERAL_USERCONFIG.DS.$user_id.'.ini'));
		{
			$ini = JFile::read(COMMUNITY_GENERAL_USERCONFIG.DS.$user_id.'.ini');
		}
		$params = new JParameter($ini);
		return $params->get($key, $default);
	}

	function getUserAvatar($file, $max_width, $max_height, $quality)
	{
		error_reporting(E_ALL);
		global $mainframe;
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$file = JPath::clean($file);
		//$file = JPATH_ROOT.DS.$file;

		$size = getimagesize($file);


		if(($size[0] > $max_width) && ($size[0] > $size[1]))
		{
			$width  = $max_width;
			$k = $size[0] / $max_width;
			$height = ($size[1] / $k);
		}
		else
		{
			$width  = $size[0];
			$height = $size[1];
		}

		if($height > $max_height)
		{
			$k = $height / $max_height;
			$height = $max_height;
			$width = ($width / $k);
		}



		$width  = round($width);
		$height = round($height);


		require_once JPATH_ROOT.DS.'media'.DS.'mightyextensions'.DS.'libraries'.DS.'image_processing'.DS.'resizeimage.inc.php';

		$resizer = new JS_Image_Resizer($file);

		if ($resizer->error())
		return false;


		@ob_end_clean();
		ob_start();
		$resizer->resize_limitwh($width, $height);
		$resizer->close();
		$picture = ob_get_clean();


		header('Content-type: '.$size['mime']);
		header('Expires: '.date('D, d M Y H:i:s', time() + 86400).' GMT');
		header('Pragma: private');
		echo $picture;
		exit;

	}

	/**
	 * This function creates a slide out menu that is attached to the
	 * element specified in the $htmlcode variable passed to this function
	 *
	 * the $customLinks is array of object that must have the following properties
	 *    ->icon - icon to be displayed before the url
	 *    ->link - the url link
	 *    ->alt  - and the label for the link
	 *
	 * @param int $uid UserId
	 * @param string $htmlcode html to which we need to attach the slide out menu
	 * @param mixed $params
	 * @param mixed $customLinks
	 * @return string
	 */
	function getUserSlideMenu($uid, $htmlcode='', $customLinks = array(),$params = array(), $menu = true)
	{
		Static $users = array();

		if(array_key_exists($uid, $users)) return $users[$uid];

		if ($uid <= 0)
		{
			return JText::_("Anonymous");
		}
		

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		jimport('joomla.application.component.model');
		$uri = &JFactory::getURI();

		if (!isset($params['avatar_height']))	$params['avatar_height'] = 60;
		if (!isset($params['avatar_width'])) 	$params['avatar_width'] = 60;
		if (!isset($params['slide_mode']))	$params['slide_mode'] = 'vertical';
		if (!isset($params['pos_mode']))	$params['pos_mode'] = 'bottom';
		if (!isset($params['avatar']))	$params['avatar'] = true;
		if (!isset($params['width']))	$params['width'] = 350;
		if (!isset($params['cfunc']))	$params['cfunc'] = false; // for cusom calling javascript function popups cards
		if (!isset($params['light']))	$params['light'] = false; // for minimized div output @todo add this parameter as object where could be passed additional settings
		if (!isset($params['name']))	$params['name'] = 'username'; // may be name or username

		$me = &JFactory::getUser();
		$user = &JFactory::getUser($uid);
		$db = &JFactory::getDBO();
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models');
		
		$model = &JModel::getInstance('Profile', 'CommunityModel');
		
		$areFriends = $model->areWeFriends($me->id, $user->id);
		
		$sql = "SELECT COUNT(*) FROM #__session WHERE userid = {$uid} AND `client_id` = 0";
		$db->setQuery($sql);
		$loggedin = $db->loadResult();
		
		$userParams  = new JParameter('');
		JPluginHelper::importPlugin('community');
		require_once('includes'.DS.'helper.php');
		$links = CommunityHelperMenu::getPluginSlideMenu($user, $userParams);
		$links = CommunityHelperGeneral::_cleanArray($links);
		$Name = $user->get($params['name']);

		$coreLinks   = array();
		$coreLinks[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=profile&user_id={$user->id}&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID,
		JText::sprintf("%s Profile", $Name), JURI::root()."components/com_community/images/myprofile.png" );
		if (COMMUNITY_GENERAL_ALLOW_FRIENDS) {
			if ($areFriends == 1) {
				$coreLinks[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=profile&task=removefriend&user_id=".$uid."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID,
				JText::_("End Friendship"), JURI::root()."components/com_community/images/delfriend.png" );
			}elseif($areFriends == 0 && $areFriends != null){
			    $coreLinks[] = CommunityHelperMenu::makeMenuItem("",
				JText::_("Friendship request wait approving"), JURI::root()."components/com_community/images/addfriend.png" );
			}elseif ($me->get('id') <> $uid) {
				$coreLinks[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=profile&layout=friend_request&user_id=".$uid."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID."&return=".base64_encode($uri->toString()),
				JText::_("Make Friends"), JURI::root()."components/com_community/images/addfriend.png" );
			}
		}

		if($me->get('id') != $uid && COMMUNITY_GROUPS_ALLOW_CREATE)
		{
			static $doIHaveGroups = false;
			$doIHaveGroups = CommunityHelperGroups::doesHaveGroup($me->get('id'));
			if ($doIHaveGroups)
			{
				$coreLinks[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=groups&layout=invite&user_id={$uid}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID.'&redirect='.base64_encode($uri->toString()),
				JText::_('Invite to join a group'),
				JURI::root().'components/com_community/images/community.png');
			}
		}

		// -----------------------------   GET VIP STATUS  ------------------------------
		$vipi = "";

		$jcs_exists = JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs');
		defined('COMMUNITY_JSMEMBER_ACTIVE_IMAGE') or define('COMMUNITY_JSMEMBER_ACTIVE_IMAGE', 'vip.png');
		defined('COMMUNITY_JSMEMBER_INACTIVE_IMAGE') or define('COMMUNITY_JSMEMBER_INACTIVE_IMAGE', 'blank.png');
		$vip  = false;
		if($jcs_exists)
		{
			$sql  = "SELECT SUM(price) FROM #__jcs_user_subscr WHERE user_id = $uid AND published = 1";
			$db->setQuery($sql);
			$vip = $db->loadResult();
		}

		if($vip >= (int)COMMUNITY_JSMEMBER_AMOUNT) {
			$vipi = ' <img src="'.JURI::root().'components/com_community/images/jsmember/'.COMMUNITY_JSMEMBER_ACTIVE_IMAGE.'" align="absmiddle" />';
		}
		else {
			$vipi = ' <img src="'.JURI::root().'components/com_community/images/jsmember/'.COMMUNITY_JSMEMBER_INACTIVE_IMAGE.'" align="absmiddle" />';
		}


		// --------------------------   GIFT INTEGRATION -----------------------------------
		$giftshtml = '';
		if ( JComponentHelper::isEnabled('com_community_gifts', true)) {
			// get the duration and limit set for Under Avatar icons
			$cgps = new JParameter(JFile::read(JPATH_ROOT.DS.'components'.DS.'com_community_gifts'.DS.'config.ini'));
			$lim = $cgps->get('UAICONS_LIM', 3);
			$dur = $cgps->get('UAICONS_DURATION', 7);
			$uploads_folder = JURI::root().COMMUNITY_GENERAL_UPLOAD.'/gifts/';
			
			$query = 'SELECT g.*, u.name AS sendername FROM #__community_gifts_sent AS g '
					.'LEFT JOIN #__users AS u ON g.fromuser_id=u.id '
					.'WHERE g.touser_id='.$user->id.' AND SUBDATE(NOW(), INTERVAL '.$dur." DAY) < g.date "
					."AND g.gift LIKE 'uaicons/%' "
					.'ORDER BY g.date DESC LIMIT '.$lim;
			$db->setQuery($query);
			$gifts = $db->loadObjectList();

			// add tooltip
			JHTML::_('behavior.tooltip');
			if (count($gifts)>0)
			foreach ($gifts as $g) {
				if ($me->id==$uid) $giftshtml.= '<span class="hasTip" title="'.JText::_('From').':&nbsp;'.$g->sendername.'::'.$g->body.'">';
				$giftshtml.= '<img src="'.$uploads_folder.$g->gift.'" alt="" />';
				if ($me->id==$uid) $giftshtml.= '</span>';
			}
		}


		$html_avatar = '';
		if($params['avatar'])
		{
			$url = JURI::root().'index2.php?option=com_community&controller=profile&task=avatar&user_id='.$user->id.'&width='.$params['avatar_width'].'&height='.$params['avatar_height'].'&no_ajax=1';
			$carma = JSCommunityApi::getUserCarma($uid);
			$html_avatar = '<td width="1%%" nowrap="nowrap" align="center">%s%s</td>';
			$html_avatar = sprintf($html_avatar, JHTML::image($url, ''),
			(COMMUNITY_CARMA_ENABLE ? sprintf('<br /><b>%s</b> (%d)<br />%s', $carma->title, $carma->points, $carma->image) : '') );
		}
		$mlinks = array();
		foreach($coreLinks as $item)
		{
			$mlinks[] = "<li>".(isset($item->icon) ? '<img border="0" align="absmiddle" src="'.$item->icon.'" /> ' : null).((!empty($item->link)) ? "<a href=\"{$item->link}\">".$item->alt."</a>" : $item->alt)."</li>";
		}
		foreach($customLinks as $item)
		{
			$mlinks[] = "<li>".(isset($item->icon) ? '<img border="0" align="absmiddle" src="'.JURI::root().$item->icon.'" /> ' : null)."<a href=\"{$item->link}\">".$item->alt."</a></li>";
		}
		foreach($links as $item)
		{
			$mlinks[] = "<li>".(isset($item->icon) ? '<img border="0" align="absmiddle" src="'.JURI::root().$item->icon.'" /> ' : null)."<a href=\"{$item->link}\">".$item->alt."</a></li>";
		}

		$html = '<table><tr valign="top">%s<td><ul>%s</ul></td></tr></table>';

		$html = sprintf($html, $html_avatar, implode("", $mlinks));
		$html = addslashes(htmlspecialchars($html));
		ob_start();
		?>

	<span style="white-space: nowrap"> 
	<?php if($loggedin): ?> 
		<img src="<?php echo JURI::root()."components/com_community/images/online.png"; ?>" align="absmiddle" /> 
	<?php else: ?> 
		<img src="<?php echo JURI::root()."components/com_community/images/offline.png"; ?>"	align="absmiddle" /> 
	<?php endif; ?> 
	<?php if($params['cfunc']):?> 
		<a class="userMenu" title="<?php echo JText::sprintf('User %s options', $user->get('username')) ?>::<?php echo $html; ?>"	href="javascript:<?php echo $params['cfunc']; ?>"><?php echo $htmlcode; ?></a>
	<?php else: ?> 
		<a class="userMenu"	title="<?php echo JText::sprintf('User %s options', $user->get('username')) ?>::<?php echo $html; ?>" href="index.php?option=com_community&view=profile&user_id=<?php echo $user->id; ?>&Itemid=<?php echo COMMUNITY_GENERAL_PROFILE_ITEMID ?>"><?php echo $htmlcode; ?></a>
	<?php endif; ?>
	<?php echo $vipi; ?><?php echo $giftshtml; ?> 
	</span>

	<?php
	$content = ob_get_contents();
	ob_end_clean();
	$users[$uid] = $content;
	return $content;
	}


	/**
	 * This function registers event for the events system on the web site
	 *	if $ctime is not given the current date and time will be taken
	 * 	higher $priority can be set in order to show the event first
	 *  provide the component's option into the $component parameter
	 *	proved the $controller and $param for the callback function to be triggered
	 *  	$params will be passed to the callback function
	 * 		the callback function's name must be "event"
	 *
	 * @param string $title
	 * @param string $text
	 * @param int $user_id
	 * @param string $ctime
	 * @param int $priority
	 * @param string $component
	 * @param string $params
	 * @param string $controller
	 */
	function registerEvent($title, $text, $user_id, $ctime=null, $priority = 0,  $component=null, $controller=null, $published=1, $params = '' )
	{
		$db = &JFactory::getDBO();
		$user_id = intval($user_id);
		if ($user_id < 1)
		{
			return false;
		}
		$ctime      = ($ctime == null ? " NOW() " : "'{$ctime}'");
		$component  = ($component == null ? JRequest::getVar('option') : $component);
		$controller = ($controller == null? '': $controller);
		$title   = $db->getEscaped($title);
		$text    = $db->getEscaped($text);
		$params  = $db->getEscaped($params);

		$sql = " INSERT INTO #__community_events (`title`, `text`, `ctime`, `priority`, `user_id`, `component`, `params`, `controller`, `published`) "
		."VALUES ('$title', '$text', $ctime, $priority, $user_id, '$component', '$params', '$controller', $published)";
		$db->setQuery($sql);
		return $db->query();
	}

	function registerActivity($clientId, $text, $user_id,  $icon = '', $client = 'user', $ctime = null, $component = null, $params = '', $type="" )
	{
		$db = &JFactory::getDBO();
		$clientId = intval($clientId);
		$user_id = intval($user_id);

		if ($user_id < 1)
		{
			JError::raiseNotice(405, JText::_('User not given for activity registration.'));
			return false;
		}
		$text 	   = $db->getEscaped($text);
		$ctime     = ($ctime == null ? " NOW() " : "'{$ctime}'");
		$component = ($component == null ? JRequest::getVar('option') : $component);
		$params    = $db->getEscaped($params);

		$sql = " INSERT INTO #__community_activity (`text`, `icon`, `client_id`, `client`, `component`, `ctime`, `params`, `user_id`, `type` ) "
		." VALUES('{$text}', '{$icon}', {$clientId}, '{$client}', '{$component}', {$ctime}, '$params', {$user_id}, '{$type}' )";
		//echo $sql;
		$db->setQuery($sql);
		return $db->query();

	}

	/**
	 * This function returns the current user status set by user.
	 * it is more like the getUserSlideMenu
	 *
	 * @param int $uid
	 * @param boolean $allowEdit
	 * returns string $html with user's status
	 *
	 */
	function getUserStatusMessage($uid, $allowEdit = false, $isRaw = false)
	{
		static $configLoaded = false;
		static $userStatuses = array();

		if((int)$uid < 1)
		{
			return;
		}
		if (!$configLoaded)
		{
			jimport('joomla.filesystem.file');
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_community'.DS.'controllers'.DS.'config.php');
			CommunityControllerConfig::initialyze();
			$configLoaded = true;
		}

		if(!array_key_exists($uid, $userStatuses))
		{
			$userConfigFile = COMMUNITY_GENERAL_USERCONFIG.DS.$uid.'.ini';
			$userConfigFile = JPath::clean($userConfigFile);
			if (JFile::exists($userConfigFile)) {
				$ini = JFile::read($userConfigFile);
			}
			$params = new JParameter(@$ini);

			if($params->get('status') == JText::_('Say Something'))
			{
				$params->set('status', '');
			}
			
			$userStatuses[$uid]['raw'] = $params->get('status');

			$status = " <span id='status_message_{$uid}'>".$params->get('status', ($allowEdit ? JText::_('Say Something') : ''))."</span>";

			if($allowEdit)
			{
				$status .= "<span id='status_image_{$uid}'><a href='javascript:void(0);' onclick='xajax_showEditUserStatus($uid);'>
				<img src='".JURI::root()."components/com_community/images/a.edit.png' align='absmiddle' ></a></span>";
			}
			$userStatuses[$uid]['html'] = "<span id=\"status_container_$uid\">{$status}</span>";
		}
		
		if($isRaw)
		{
			return $userStatuses[$uid]['raw'];
		}
		else 
		{
			return $userStatuses[$uid]['html'];
		}
	}

	function _renderUserStatus($message, $uid, $allowEdit = false)
	{
		$currentUser = &JFactory::getUser();
		if (trim($message) == '')
		{
			$message = JText::_("Status not set yet.");
		}
		$html ="";
		if (!$allowEdit)
		{
			$html.= $message;
		}

		if ($allowEdit && $uid == $currentUser->get("id") && $currentUser->get('id') > 0)
		{
			$html.=JSCommunityApi::_getUserStatusInnerWithControls($uid, $message);
		}
		return $html;

	}
	function _getUserStatusInnerWithControls($uid, $message)
	{
		$html="";
		$html.="<span id='status_message_{$uid}'>$message</span>";
		$js="onclick='xajax_showEditUserStatus($uid);'";
		$html.="<span id='status_image_{$uid}'><a href='javascript:void(0);' $js><img src='".JURI::root()."components/com_community/images/a.edit.png' align='absmiddle' ></a></span>";
		return $html;
	}
}
/**
 * Interface to create tabs for JS PeopleTouch component
 * !!!Important
 * this is used only for plugins
 *
 */

class JSCommunityTab
{
	var $title   = ""; // Title of the tab that will be displayed in the front-end
	var $name    = ""; // unique name of the tab to allow users to swich them off
	var $text    = ""; // and of course the output text to show inside of tab
	var $description = "";

}

/**
 * this class is used to get the lower level information from the
 * MightyCommunity Component, in order to use it somewhere else.
 *
 */
class JSCommunityApiExtern
{
	/**
	 * Gets the friends of the given user
	 *
	 * @param int $user_id
	 * @return  mixed array of user ids
	 */
	function getUserFriends($user_id)
	{
		static $loaded  = false;
		if(!$loaded)
		{
			jimport('joomla.application.component.model');
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models'.DS.'profile.php');

		}
		$model = &JModel::getInstance('Profile', 'CommunityModel');
		$friends = $model->getAllFriends($user_id);
		return $friends;


	}

	/**
	 * Gets the members of a given group
	 *
	 * @param int $user_id
	 * @return  mixed array of users
	 */
	function getGroupMembers($group_id)
	{
		static $loaded  = false;
		if(!$loaded)
		{
			jimport('joomla.application.component.model');
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models'.DS.'groupmembers.php');
		}
		$model = &JModel::getInstance('GroupMembers', 'CommunityModel');
		$members = $model->getGroupMembers($group_id, 'all', false);
		return $members;

	}

	/**
	 * Gets the groups of the given user
	 *
	 * @param int $user_id
	 * @return  mixed array of group ids
	 */
	function getUserMembershipGroups($uid)
	{
		static $loaded  = false;
		if(!$loaded)
		{
			jimport('joomla.application.component.model');
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models'.DS.'groupmembers.php');
		}
		$model = &JModel::getInstance('GroupMembers', 'CommunityModel');
		$groups = $model->getActiveGroupsArray($uid);
		return $groups;


	}

	/**
	 * Special function for the JS Inbox component
	 * that checks whether a given user can send message to the given group members
	 * return true if user can send and false if cannot
	 *
	 * @param int $uid
	 * @param int $gid
	 * return boolean
	 */
	function Inbox_canSendMsgToGroup($uid, $gid)
	{
		if (intval($uid) < 1 || intval($gid) < 1 ){ return false;}
		static $loaded  = false;
		if (!$loaded)
		{
			jimport('joomla.application.component.model');
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'tables'.DS.'groups.php');
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models'.DS.'group.php');
			require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models'.DS.'groupmembers.php');
		}
		$result = false;
		$tGroups = &JTable::getInstance("Groups", "CommunityTable");
		$tGroups->load($gid);
		if (trim($tGroups->get('title', '')) == '' ) {return false;}
		$params = new JParameter($tGroups->get('params', ''));
		$access = $params->get('message_access', 2);
		$karmaLimit = $params->get('message_access_karma_limit', 0);
		$mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
		switch($access)
		{
			case 0: //nobody
				$result = false;
				break;
			case 1: //registered
				$result = true;
				break;
			case 2: //Group Members
				
				$result = $mModel->isGroupMember($gid, $uid, false, false);
				if ($result > 0 )
				{
					$result = true;
					break;
				}
				else
				{
					$result = false;
				}
				
			case 4: //Moderators

				$result = $mModel->isGroupModerator($gid, $uid, false);
				if ($result > 0 )
				{
					$result = true;
					break;
				}
				else
				{
					$result = false;
				}
				
			case 5: //Creator
				if ($tGroups->get('user_id') == $uid)
				{
					$result = true;
				}
				break;
			default:
				break;

		}
//		var_dump($result);exit();
	/*	if(!$result){
			var_dump($result);exit();
			$comm_params = JSCommunityApiExtern::getCommunityParams();
			$allow_groups = $comm_params->get('groups::allow_send_to_all_groups');
			$u = JFactory::getUser($uid);
			var_dump($allow_groups, $u);exit;
			if(in_array($u->get('aid'), $allow_groups))
				$result = true;			
		}*/
		if ($karmaLimit > 0 && $result === true)
		{
			$siteKarmaList = JSCommunityApi::getCarmaList();

			$currentKarma = $siteKarmaList[$karmaLimit];
			if (($access == 1 || $access == 2) && count($siteKarmaList) > 0)
			{

				$userCarma = JSCommunityApi::getUserCarma($uid);
				if ($userCarma->points < $currentKarma['points'])
				{
					$result = false;
				}

			}

		}
		return $result;
	}

	/**
	 * Special function for the JS Inbox component
	 * that get list groups in which he is become a party
	 *
	 * @param int $uid
	 * return multy level array of groups
	 */

	function getUserGroupParty( $uid, $status = null, $only_send_accessible = true )
	{
		$db = & JFactory::getDBO();

		if( $status == "owner" || is_null( $status ) ) {
			$db->setQuery(    "   SELECT gr.title, gr.id"
			."\n     FROM #__community_communities AS gr"
			."\n    WHERE gr.user_id = ".$uid
			."\n ORDER BY gr.title"
			);
			$_result["owner"] = $db->loadObjectList();
		}

		if( $status == "member" || is_null( $status ) ) {
			$db->setQuery(    "     SELECT gr.title, gr.id"
			."\n       FROM #__community_communities AS gr"
			."\n INNER JOIN #__community_user_mapping AS m ON m.group_id = gr.id"
			."\n      WHERE m.user_id = ".$uid." AND m.access_type <> 1 "
			."\n   ORDER BY gr.title"
			);
			$_result["member"] = $db->loadObjectList();
		}

		if( $status == "moderator" || is_null( $status ) ) {
			$db->setQuery(    "     SELECT gr.title, gr.id"
			."\n       FROM #__community_communities AS gr"
			."\n INNER JOIN #__community_user_mapping AS m ON m.group_id = gr.id"
			."\n      WHERE m.user_id = ".$uid." AND m.access_type = 1 "
			."\n   ORDER BY gr.title"
			);
			$_result["moderator"] = $db->loadObjectList();
		}

		if( $only_send_accessible ) {
			$result = array();
			$result["member"] = array();
			$result["owner"] = array();
			$result["moderator"] = array();

			foreach( $_result as $status => $groups ) {
				foreach( $groups as $group ) {
					if( JSCommunityApiExtern::Inbox_canSendMsgToGroup( $uid, $group->id ) ) {
						$result[$status][] = $group;
					}
				}
			}

			return $result;
		} else {
			return $_result;
		}
	}

	function getGroup( $group_id )
	{
		$db = & JFactory::getDBO();

		$db->setQuery(    " SELECT gr.*"
		."\n   FROM #__community_communities AS gr"
		."\n  WHERE gr.id = ".$group_id
		);
		$result = $db->loadObjectList();

		return $result[0];
	}
	
	function getCommunityParams(){
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'config.ini')){
			return new JParameter( JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'config.ini') );
		}else{
			return false;
		}
	}

}
?>