<?php
/**
 * $Id: controller.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

class CommunityController extends JController
{

	function display()
	{
		if (JRequest::getVar('view', '') == '' && JRequest::getVar('controller', '') == '' && JRequest::getVar('task', '') == "")
		{
			JRequest::setVar('view', 'list');
		}
		parent::display();
	}
	function delete_activity()
	{
		global $mainframe;
		
		JRequest::setVar('view', 'history');
		$cid = JRequest::getVar('cid', array(), 'request', 'array');
		$user = & JFactory::getUser();
		
		if($user->get('usertype') != 'Super Administrator')
		{
			JError::raiseWarning(403, JText::_('You need to be at least Super Administrator to delete activities'));
			parent::display();
			return;
		}
		if(!$cid)
		{
			JError::raiseWarning(403, JText::_('No activity selected'));
			parent::display();
			return;
		}
		
		$ids = implode(",", $cid);
		$sql = "DELETE FROM #__community_activity WHERE id IN ({$ids})";
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$db->query();

		$uri = JFactory::getURI();
		$mainframe->redirect($uri->toString(), JText::_('Activity Deleted successfully'));
		
		parent::display();
	}
	function eventer()
	{
		require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
		require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_community'.DS.'controllers'.DS.'config.php';
		CommunityControllerConfig::initialyze();

		jimport('joomla.application.component.model');
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models');
		JTable::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'tables');
		$db = & JFactory::getDBO();
		$group = &JTable::getInstance('Groups', 'CommunityTable');
		$return = '';
		
		$action = JRequest::getInt('event_action');

		// Friend ship confirmation
		$id = JRequest::getInt('friend_request');
		if($id > 0)
		{
			$model = JModel::getInstance('Profile', "CommunityModel");
			$model->confirmFriendShip($id, $action);
		}

		// confirm decline group join invitation
		$gid = JRequest::getInt('id');
		$wid = JRequest::getInt('who_id');
		$jid = JRequest::getInt('join_id');
		if($gid && $wid && !$jid)
		{
			$group->load($gid);
			if($action == 1)
			{
				require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'controllers'.DS.'groups.php';
				$cntrl = new CommunityControllerGroups();
				$cntrl->joinGroup($gid);

				$text = CommunityHelperGeneral::getEventGroupJoinAccept($group);
				JSCommunityApi::registerEvent(JText::_('Group Invitation Accepted'), $text, $wid, NULL, 0, 'com_community');
				$return = JText::_('You Accepted Invitation');
			}
			else
			{
				$text = CommunityHelperGeneral::getEventGroupJoinReject($group);
				JSCommunityApi::registerEvent(JText::_('Group Invitation Rejected'), $text, $wid, NULL, 0, 'com_community');
				$return = JText::_('You Declined Invitation');
			}
		}

		//confirm decline group join request
		
		if($jid && $wid)
		{
		    $mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
			$group->load($jid);
			if($action == 1)
			{
			    if($mModel->isPending($gid, $wid)){
    				$db->setQuery("UPDATE #__community_user_mapping SET `pending` = 0 WHERE `user_id` = {$wid} AND `group_id` = {$group->id}");
    				$db->query();
    				$db->setQuery("UPDATE #__community_communities SET `num_users` = `num_users` + 1 WHERE `id` = {$group->id}");
    				$db->query();
    
    				$text = CommunityHelperGeneral::getEventGroupJoinRequestAccept($group);
    				JSCommunityApi::registerEvent(JText::_('Join Request Accepted'), $text, $wid, NULL, 0, 'com_community');
    				$return = JText::_('You Have Accepted The Request');
			    }else{
			        $return = JText::_('You Already Accepted The Request');
			    }
			}
			elseif($action == 2)
			{
				$db->setQuery("UPDATE #__community_user_mapping SET `pending` = 0, `user_block` = 1  WHERE `user_id` = {$wid} AND `group_id` = {$group->id}");
				$db->query();
				
				if($mModel->isPending($gid, $wid)){
    				$db->setQuery("UPDATE #__community_communities SET `num_users` = `num_users` - 1 WHERE `id` = {$group->id}");
    				$db->query();
				}
				
				$text = CommunityHelperGeneral::getEventGroupJoinRequestBlock($group);
				JSCommunityApi::registerEvent(JText::_('Join Request Rejected'), $text, $wid, NULL, 0, 'com_community');
				$return = JText::_('You Have Declined The Request And Blocked User. To unblock go to group user managment panel');
			}
			else
			{
			    
				$db->setQuery("DELETE FROM #__community_user_mapping WHERE `user_id` = {$wid} AND `group_id` = {$group->id} AND `pending` = 0");
				$db->query();
				
				$text = CommunityHelperGeneral::getEventGroupJoinRequestReject($group);
				JSCommunityApi::registerEvent(JText::_('Join Request Rejected'), $text, $wid, NULL, 0, 'com_community');
				$return = JText::_('You Have Declined The Request');
			}
			$sql = "DELETE FROM #__community_events WHERE params = 'JOIN-REQ-{$wid}-{$jid}' AND id != ".JRequest::getInt('event_id', 0);
			$db->setQuery($sql);
			$db->query();
		}
		return $return;
	}
}
?>