<?php
/**
 * $Id: groups.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 
jimport('joomla.application.component.controller');

class CommunityControllerGroups extends CommunityController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('joingroup', 'joinGroup');
		$this->registerTask('sendJoinRequest', 'sendJoinRequest');
		$this->registerTask('cancel', 'cancel');
		$this->registerTask('remove', 'remove');
		$this->registerTask('leavegroup', 'leavegroup');
		$this->registerTask('groupicon', 'getGroupIcon');
		$this->registerTask('inviteUser', 'inviteUser');
	}

	function save()
	{
		global $Itemid;
		$user = &JFactory::getUser();
		if ($user->get('id', 0) < 1)
		{
			$this->setRedirect("index.php?option=com_user&view=login", JText::_('You must be and logged in, in order to create a group'), 'notice');
		}

		if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
			$return = base64_decode($return);
			if (strpos( $return, 'http' ) !== false && strpos( $return, JURI::base() ) !== 0) {
				$return = '';
			}
		}

		$post  = JRequest::get('post');
		
		$table = &JTable::getInstance('Groups', 'CommunityTable');
		$table->load($post['id']);
		
		$post['description'] = $_REQUEST['description'];
		$model = &JModel::getInstance('Group', 'CommunityModel');
		$isNew = JRequest::getVar("id", 0) == 0? true: false;
		$availableCategories = CommunityHelperGroups::getCategoriesToCreateGroup($user);
		$catid = JRequest::getInt('catid', 0);
		if (!(in_array($catid, $availableCategories)))
		{
			JError::raiseNotice("You have no permission to create a group in this category");
			if ($return)
			{
				$this->setRedirect(JRoute::_($return, false) );
			}
			else
			{
				$this->setRedirect(JRoute::_("index.php?option=com_community&view=groups&category_id={$catid}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false));
			}
		}
		$catid = $post['catid'];

		if (isset($post['friends_access']) && $post['friends_access'])
		{
			$post['access'] = 3;
		}
		if (isset($post['friends_submit_access']) && $post['friends_submit_access'])
		{
			$post['submit_access'] = 3;
		}
		if (isset($post['friends_comment_access']) && $post['friends_comment_access'])
		{
			$post['comments_access'] = 3;
		}
		$params = new JParameter('');
		//$post['params'];
		
		$params->bind($post['params']);
		$post['params'] = $params->toString();

		$files = JRequest::get("FILES");
				
		if (isset($files['icon']) && is_array($files['icon']) && $files['icon']['name'] != '')
		{
			if($table->icon)
			{
				JFile::delete(JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.'groups'.DS.'thumb'.DS.$table->icon);
			}
			$ext = strrchr($files['icon']['name'], '.');
			$image_name = strtoupper(substr(md5(time().$files['icon']['name']), 0, 8).$ext);
			CommunityHelperGeneral::uploadImage($image_name, $files['icon']['tmp_name'],
			COMMUNITY_GROUPS_THUMB_WIDTH,COMMUNITY_GROUPS_THUMB_HEIGHT,
			100, JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.'groups'.DS.'thumb', false);
			$post['icon'] = $image_name;
		}
		
		$newId = $model->save($post);
		if(!$newId)
		{
			JError::raiseNotice(400, JText::_("Could not save the group"));
		}

		if ($isNew && COMMUNITY_REGISTER_NEW_GROUP)
		{
			$str = JText::sprintf('Created the group %s', '<a href="'.JRoute::_("index.php?option=com_community&view=groups&layout=group&id={$newId}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID).'">'.$post['title'].'</a>');
//			JSCommunityApi::registerActivity($user->get("id"), $str , $user->get('id'), 'components/com_community/images/community.png', 'user', null, null, '', 'Groups');
			JSCommunityApi::registerActivity($newId, $str , $user->get('id'), 'components/com_community/images/community.png', 'community', null, null, '', 'Groups');
		}
		if ($return)
		{
			$this->setRedirect(JRoute::_($return, false),JText::_("The group is successfully saved.") );
		}
		else
		{
			$this->setRedirect(JRoute::_("index.php?option=com_community&view=groups&layout=group&id={$newId}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false), JText::_("The group is successfully saved."));
		}
	}

	function publish()
	{
		$this->changepublish(1);
	}

	function unpublish()
	{
		$this->changepublish(0);
	}

	function changepublish($state)
	{
		global $Itemid;
		//$Itemid = JRequest::getInt('Itemid');
		$id = JRequest::getInt('id');
		$model = &JModel::getInstance('Group', "CommunityModel");
		$model->changePublish($state, $id );
		if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
			$return = base64_decode($return);
			if (strpos( $return, 'http' ) !== false && strpos( $return, JURI::base() ) !== 0) {
				$return = '';
			}
		}
		if($return)
		{
			$this->setRedirect(JRoute::_($return, false));
		}
		else
		{
			$this->setRedirect(JRoute::_('index.php?option=com_community&view=groups&layout=default&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false));
		}

	}

	function cancel()
	{
		$id = JRequest::getInt('id');
		$this->setRedirect(JRoute::_("index.php?option=com_community&view=groups&layout=group&id=".$id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false));
	}



	function remove()
	{
		global $Itemid;
		$id = JRequest::getInt('id', 0);
		if($id == 0)
		{
			JError::raiseWarning(404, JText::_("The Group does not exist"));
			$this->setRedirect(JRoute::_('index.php?option=com_community&view=groups&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false));
			return;
		}
		$user = &JFactory::getUser();
		$gid = $user->get('gid');
		if ($user->get('id')<1)
		{
			JError::raiseWarning(404, JText::_("You must be logged in."));
			$this->setRedirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group->id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false));
			return;
		}
		$model = &JModel::getInstance("Group", 'CommunityModel');
		$mModel = &JModel::getInstance("GroupMembers", 'CommunityModel');
		if(!$mModel->isCreator($id, $user->get('id')) && ($gid!=24 && $gid != 25 ))
		{
			JError::raiseWarning(404, JText::_("You are not creator of this group."));
			$this->setRedirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group->id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false));
			return;
		}
		$model->setId($id);
		$group = $model->getData();
		if ($group->get('id'))
		if($model->remove($id))
		{
			$msg = JText::_("The group successfully deleted");
			$this->setRedirect(JRoute::_('index.php?option=com_community&view=groups&category_id='.$group->catid."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false), $msg);
			return;
		}
		else
		{
			JText::raiseNotice(400,"Could not remove the group");
			$this->setRedirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group->id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false));
			return;
		}

	}

	function joinGroup($gid = null)
	{
		global $mainframe, $Itemid;

		$group_id = $gid;
		if(!$group_id) $group_id = JRequest::getInt('id', 0);
		
		$invitedby = JRequest::getInt('invitedby', 0);

		$redirect = JRequest::getVar('redirect');
		if($redirect) $redirect = base64_decode($redirect);

		$uri = & JFactory::getURI();

		if ($group_id == 0)
		{
			JError::raiseWarning(403, JText::_("The group does not exist"));
			if(!$redirect) $redirect = JRoute::_("index.php?option=com_community&view=groups&layout=default&Itemid=".COMMUNITY_GENERAL_GROUPS_ITEMID, false);
			$mainframe->redirect($redirect);
			return JText::_("The group does not exist");
		}

		$user = &JFactory::getUser();
		if  ($user->get('id') < 1)
		{
			JError::raiseWarning(403, JText::_("You need to login first"));
			CommunityHelperGeneral::redirectToLogin();
		}

		$model = &JModel::getInstance('Group', 'CommunityModel');
		$mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
		
		$table = &JTable::getInstance('Groups', "CommunityTable");
		if(!$table->load($group_id))
		{
			JError::raiseWarning(403, JText::_("The group does not exist"));
			if(!$redirect) $redirect = JRoute::_("index.php?option=com_community&view=groups&layout=default&Itemid=".COMMUNITY_GENERAL_GROUPS_ITEMID, false);
			$mainframe->redirect($redirect);
		}

		if ($table->get('join_type', 0) == 1 && $invitedby != $table->user_id)
		{
			JError::raiseNotice(403, JText::_("This group require Join Request to join the group"));
			$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=request&id='.$table->id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID.'&redirect='.base64_encode($uri->toString()), false));
			return;
		}

		if (COMMUNITY_CARMA_ENABLE)
		{
			if (!CommunityHelperGroups::checkGroupCarmaAccess($user, $table->get('id'), $table->get('user_id'), 'karma_join_limit'))
			{
				if(!$redirect) $redirect = JRoute::_("index.php?option=com_community&view=groups&layout=group&id={$group_id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false);
				$mainframe->redirect($redirect, JText::_("Sorry but you do not have enough karma to join this group"), 'notice');
				return;
			}
		}
		if ($table->get('join_type', 0) == 2 && $invitedby != $table->user_id)
		{
			if (!$mModel->isGroupMemberFriend($table->get('id'), $table->user_id, $user->get('id')))
			{
				if(!$redirect) $redirect = JRoute::_('index.php?option=com_community&view=groups&layout=request&id='.$group_id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false);
				$mainframe->redirect($redirect, JText::_("You need to be a creator's friend in order to join this group without Join request"), 'notice');
				return;
			}
		}
		if (!$mModel->joinGroupDirectly($group_id, $user->get('id')))
		{
			if(!$redirect) $redirect = JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group_id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false);
			$mainframe->redirect($redirect, JText::_("Could not join to the group"), 'notice');
			return;
		}

		if(COMMUNITY_REGISTER_JOIN_GROUP)
		{
			$str = JText::sprintf('Joined the group %s', '<a href="'.JRoute::_("index.php?option=com_community&view=groups&layout=group&id={$group_id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID).'">'.$table->title.'</a>');
//			JSCommunityApi::registerActivity($user->get("id"), $str, $user->get('id'), 'components/com_community/images/community.png', 'user', null, null, '', 'Groups');
			JSCommunityApi::registerActivity($group_id, $str, $user->get('id'), 'components/com_community/images/community.png', 'community', null, null, '', 'Groups');
		}

		$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$group_id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false), JText::_("You have successfully joined the group"));
	}
	function sendJoinRequest()
	{
		global $mainframe, $Itemid;
		$id = JRequest::getInt('id');
		$user = &JFactory::getUser();
		$message = JRequest::getVar('message', '');
		$uri = & JFactory::getURI();

		$redirect = JRequest::getVar('redirect');
		if($redirect) $redirect = base64_decode($redirect);

		$model = &JModel::getInstance('Group', 'CommunityModel');
		$mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
		$model->setId($id);
		$data = &$model->getData();

		if ($mModel->sendRequest($id, $user->get('id'), $message))
		{
			$moderators = $mModel->getGroupMembers($id, 'moderators', false);
			$emailMessage = JText::_("JOIN_REQUEST_MSG");
			$emailSubject = JText::_("JOIN_REQUEST_TITLE");
			// message title
			$emailSubject = str_replace(array("[USERNAME]", "[username]"), $user->get('username'), $emailSubject);
			$emailSubject = str_replace(array("[GROUPNAME]", "[groupname]"), $data->title, $emailSubject);

			$sitename       = $mainframe->getCfg( 'sitename' );
			$mailfrom       = $mainframe->getCfg( 'mailfrom' );
			$fromname       = $mainframe->getCfg( 'fromname' );
			//$siteURL        = JURI::root();
			$link = JRoute::_('index.php?option=com_community&view=groups&layout=requests&id='.$data->id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false, -1);

			// the contents of the email message
			$emailMessage = str_replace(array("[GROUPNAME]", "[groupname]"), $data->title, $emailMessage);
			$emailMessage = str_replace(array("[SITEURL]", "[siteurl]"), $siteURL, $emailMessage);
			$emailMessage = str_replace(array("[LINK]", "[link]"), $link, $emailMessage);
			$emailMessage = str_replace(array("[USERNAME]", "[username]"), $user->get('username'), $emailMessage);
			if ($message)
			{
				if (CommunityHelperGeneral::isHtmlMessage($emailMessage))
				{
					$message = nl2br ("\n\n".$message);
				}
				else
				{
					$message = ("\n\n".$message);
				}
				$emailMessage.=$message;

			}
			//Hello [MODERATOR]. \n [USERNAME] wants to join the group [GROUPNAME]
			//and he/she needs to be approved on the [SITEURL]\n. Please follow
			//this link to see the list of users who wants to join the group [LINK].
				
			$text = CommunityHelperGeneral::getEventJoinGroupRequest($user, $data, $message);
			foreach($moderators as $moder)
			{
				$messageToSend = str_replace(array("[MODERATOR]", "[moderator]"), $moder->username, $emailMessage);

				JUtility::sendMail($mailfrom, $fromname, $moder->email, $emailSubject, $messageToSend, CommunityHelperGeneral::isHtmlMessage($emailMessage) );
				JSCommunityApi::registerEvent(JText::_('Group Join Request'), $text, $moder->id, null, 0, 'com_community', 'CommunityController', 1, 'JOIN-REQ-'.$user->id.'-'.$data->id);
			}
			//now getting the creator of the group
			$creator = JFactory::getUser($data->user_id);
			$messageToSend = str_replace(array("[MODERATOR]", "[moderator]"), $creator->username, $emailMessage);
			JUtility::sendMail($mailfrom, $fromname, $creator->email, $emailSubject, $messageToSend, CommunityHelperGeneral::isHtmlMessage($emailMessage) );
			JSCommunityApi::registerEvent(JText::_('Group Join Request'), $text, $creator->id, null, 0, 'com_community', 'CommunityController', 1, 'JOIN-REQ-'.$user->id.'-'.$data->id);
				
		}
		else
		{
			if(!$redirect) $redirect = JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false);
			$this->setRedirect($redirect);
		}

		if(!$redirect) $redirect = JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$data->id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false);
		$this->setRedirect($redirect, JText::_("The request has been sent successfully"));
	}

	function leavegroup()
	{
		global $Itemid;

		$group_id = JRequest::getInt('id', 0);
		$user = &JFactory::getUser();
		
		$mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
		
		$group = &JTable::getInstance('Groups', "CommunityTable");
		$group->load($group_id);
		$text = JText::_('Error: cannot delete member from the group');

		if ($user->get('id') > 0 && $mModel->isGroupMember($group_id, $user->get('id'), true) && $group_id > 0)
		{
			$mModel->removeMember($group_id, $user->get('id'));
			$text = JText::_('You have been successfully deleted from this group members');
		}

		if(COMMUNITY_REGISTER_LEAVE_GROUP)
		{
			$str = JText::sprintf('Left the group %s', '<a href="'.JRoute::_("index.php?option=com_community&view=groups&layout=group&id={$group->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID).'">'.$group->title.'</a>');
//			JSCommunityApi::registerActivity(0, $str, $user->get('id'), 'components/com_community/images/community.png', 'user', null, null, '', 'Groups');
			JSCommunityApi::registerActivity($group_id, $str, $user->get('id'), 'components/com_community/images/community.png', 'community', null, null, '', 'Groups');
		}

		$this->setRedirect(JRoute::_("index.php?option=com_community&view=groups&layout=group&id={$group_id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, false), $text);
	}

	function getGroupIcon()
	{

		$width = JRequest::getInt('width', 128);
		$height = JRequest::getInt('height', 128);
		$id = JRequest::getInt('group_id');
		$table = &JTable::getInstance("Groups", 'CommunityTable');
		$table->load($id);
		$path = JPATH_COMPONENT.DS.'images'.DS.'group_default_128.png';
		if ($table->icon)
		{
			$path = JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.'groups'.DS.'thumb'.DS.$table->icon;
		}
		JSCommunityApi::getUserAvatar($path, $width, $height, 100);
		exit;
	}

	function inviteUser()
	{
		global $mainframe;
		$uid         = JRequest::getInt('user');
		$Itemid      = JRequest::getInt('Itemid');
		$group_id    = JRequest::getInt('group_to_inv', 0);
		$currentUser = JFactory::getUser();
		$user        = &JFactory::getUser($uid);
		$db			 = & JFactory::getDBO();

		$tGroups = &JTable::getInstance('Groups', 'CommunityTable');
		$tGroups->load($group_id);

		$sitename    = $mainframe->getCfg( 'sitename' );
		$mailfrom    = $mainframe->getCfg( 'mailfrom' );
		$fromname    = $mainframe->getCfg( 'fromname' );
		/**
		 * USED PLACEHOLDERS
		 * [NAME] [USERNAME] [SITENAME] [SITEURL] [GROUPNAME] [SENDER_NAME]
		 * [SENDER_USERNAME] [APPROVE_LINK]
		 */
		$appLink = JRoute::_("index.php?option=com_community&controller=groups&task=joingroup&id={$tGroups->id}&invitedby={$currentUser->id}&Itemid={$Itemid}", false, -1);

		$title = JText::_("GROUP_INVITE_TITLE");
		$title = str_replace(array('[NAME]', '[USERNAME]', '[SITENAME]',
								   '[SITEURL]', '[GROUPNAME]', '[SENDER_NAME]',
								   '[SENDER_USERNAME]', '[APPROVE_LINK]'),
		array($user->get('name'), $user->get('username'), $sitename,
		JURI::root(), $tGroups->get('title'), $currentUser->get('name'),
		$currentUser->get('username'), $appLink ),
		$title );

		$message = JText::_("GROUP_INVITE_MESSAGE");
		$message = str_replace(array('[NAME]', '[USERNAME]', '[SITENAME]',
									 '[SITEURL]', '[GROUPNAME]', '[SENDER_NAME]',
									 '[SENDER_USERNAME]', '[APPROVE_LINK]'),
		array($user->get('name'), $user->get('username'), $sitename,
		JURI::root(), $tGroups->get('title'), $currentUser->get('name'),
		$currentUser->get('username'), $appLink ),
		$message );

		JUtility::sendMail($mailfrom, $fromname, $user->get('email'), $title, $message, CommunityHelperGeneral::isHtmlMessage($message));

		$text = CommunityHelperGeneral::getEventInviteToGroup($user, $currentUser, $tGroups);
		JSCommunityApi::registerEvent(JText::_('Invite to join the group'), $text, $user->get('id'), null, 0, null, 'CommunityController');

		$redirect =  JRoute::_("index.php?option=com_community&view=profile&user_id={$user->id}&Itemid={$Itemid}", false);

		if(JRequest::getVar('redirect')) $redirect = base64_decode(JRequest::getVar('redirect'));

		$this->setRedirect($redirect, JText::_("The invintaion is sent"));
	}


}
?>