<?php
/**
 * $Id: profile.php 7361 2011-10-03 05:33:28Z peter $
 * $LastChangedDate: 2011-10-03 11:33:28 +0600 (Mon, 03 Oct 2011) $
 * $LastChangedBy: peter $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class CommunityControllerProfile extends CommunityController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('editprof', 'editProfile');
		$this->registerTask('addfriend', 'addFriend');
		$this->registerTask('myfriends', 'MyFriends');
		$this->registerTask('discartfriend', 'discartFriend');
		$this->registerTask('confirmfriend', 'confirmFriend');
		$this->registerTask('removefriend', 'removeFriend');
		$this->registerTask('avatar', "getAvatars");
		$this->registerTask('savePluginConfig', "savePluginConfig");
		$this->registerTask('invite', "invite");
		$uri  = &JFactory::getURI();
		$user = &JFactory::getUser();
		$tmp_id = JRequest::getVar('user_id', 0);
		if (!COMMUNITY_GENERAL_ALLOW_PUBLIC)
		{

			if (!$user->id)
			{
				$this->setRedirect(JRoute::_('index.php?option=com_community&view=list&Itemid='.COMMUNITY_GENERAL_LIST_ITEMID, false), JText::_("You need to Log-in First"), 'notice');

			}
		}
		else if (!$user->id && !$tmp_id[0])
		{
			$this->setRedirect(JRoute::_('index.php?option=com_community&view=list&Itemid='.COMMUNITY_GENERAL_LIST_ITEMID, false), JText::_("You do not have account yet. Please Register first"), 'notice');

		}
		JRequest::setVar('view', 'profile');

	}

	function display()
	{
		// Set a default view if none exists
		parent::display();
	}

	function editProfile()
	{
		JRequest::setVar('view', 'profile');
		JRequest::setVar('layout', 'edit');
		parent::display();
	}

	function save()
	{
		$user = &JFactory::getUser();
		$post = JRequest::getVar('params', array(), 'default', 'none', 2);
		//first we apply the safe html filter
		$withHtmlFilter = & JFilterInput::getInstance(null, null, 1, 1);
		$post["welcome_msg"] = $withHtmlFilter->clean($post["welcome_msg"]);
		//now we are removing other tags from here
		$noHtmlFilter = & JFilterInput::getInstance(/* $tags, $attr, $tag_method, $attr_method, $xss_auto */);
		$post['status'] = $noHtmlFilter->clean($post['status']);
		$post['restricted_messsge'] = $noHtmlFilter->clean($post['restricted_messsge']);

		$params = new JParameter('');
		$params->bind($post);
		$ini = $params->toString();

		//echo $user->_params->get("editor");
		$user->_params->set('editor', $params->get('user_editor'));
		

		$user->save();
		if(COMMUNITY_REGISTER_DETAILS_CHANGED)
		{
			JSCommunityApi::registerActivity(0, JText::_("Updated profile"), $user->id, 'components/com_community/images/editprofile.png', 'user', null, null, '', 'Profile Update');
		}

		JFile::write(str_replace('\\', '/', COMMUNITY_GENERAL_USERCONFIG.DS.$user->id.'.ini'), $ini);

		$this->setRedirect(JRoute::_('index.php?option=com_community&view=profile&user_id='.$user->id."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID, false));

	}

	function addFriend()
	{
		global $mainframe;
		$uri = JFactory::getURI();
		$host = $uri->toString(array('scheme', 'host', 'port'));
		$return = "";
		if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
			$return = base64_decode($return);
			if (strpos( $return, 'http' ) !== false && strpos( $return, JURI::base() ) !== 0) {
				$return = '';
			}
		}

		$cid = JRequest::getInt('user_id', 0);
		$user = JFactory::getUser();
		$profile = JFactory::getUser($cid);
		$request_msg = JRequest::getVar('message');

		if (!COMMUNITY_GENERAL_ALLOW_FRIENDS)
		{
			JError::raiseNotice(400, JText::_('Friendship is disabled'));
			if ($return)
			{

				$this->setRedirect(JRoute::_($return, false));
			}
			$this->setRedirect(JRoute::_("index.php?option=com_community&view=profile&user_id={$cid}&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID, false));
		}

		$link = "index.php?option=com_community&view=profile&user_id=%d".'&Itemid='.COMMUNITY_GENERAL_PROFILE_ITEMID;

		$link2 = sprintf($link, $user->id);
		$link2 = $host.JRoute::_($link2, true);

		$url_friend_list = $host.JRoute::_('index.php?option=com_community&controller=list&task=myfriends&user_id='.$cid.'&Itemid='.COMMUNITY_GENERAL_PROFILE_ITEMID);
		$default_msg = JText::sprintf("Hello, <p>The user %s wants to become your friend.</p><p>You can accept it in your <a href='%s'>friend list</a></p>",
			"<a href='{$link2}'>{$user->username}</a>", $url_friend_list);
		
		$model = $this->getModel('Profile', 'CommunityModel');
		$msgType = "";
		if($model->addFriend($user->id, $profile->get('id'), $request_msg, $default_msg))
		{
			$mailfrom = $mainframe->getCfg('mailfrom');
			$fromname = $mainframe->getCfg('fromname');
			$mailSubject = JText::sprintf("Friendship request at %s", $fromname);
			
			JUtility::sendMail($mailfrom, $fromname, $profile->get("email"), $mailSubject, $default_msg.'<br /><br />'.$request_msg, 1 );
			$msgType = 'message';
			$msg = JText::_("Request Sent to become a friend");
		}
		else
		{
			$msgType = 'notice';
			$msg = JText::_("User is already in your Friends list");
		}
		if ($return)
		{
			$this->setRedirect(JRoute::_($return, false), $msg, $msgType);
		}
		else
		{
			$this->setRedirect(JRoute::_("index.php?option=com_community&view=profile&user_id={$cid}&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID, false), $msg, $msgType);
		}
	}

	function confirmFriend()
	{
		$this->confdisFriend(1);

	}

	function discartFriend()
	{
		$this->confdisFriend(0);
	}

	function confdisFriend($type = 1)
	{
		$user = &JFactory::getUser();
		if (!$user->get('id'))
		{
			JError::raiseNotice(606, JText::_("You have no access to Confirm or Discard a friend."));

		}
		$model = &$this->getModel('Profile', "CommunityModel");
		$row_id = JRequest::getVar('helper');
		$model->confirmFriendShip($row_id, $type);
		if ($type){	$msg = JText::_("Friend Added");}
		else 			{ $msg = JText::_("Person Discarted");}

		$this->setRedirect(JRoute::_('index.php?option=com_community&controller=list&task=myfriends&user_id='.$user->get('id').'&Itemid='.JRequest::getInt('Itemid'), false), $msg);
	}

	function removeFriend()
	{
		$frd_id = JRequest::getInt('user_id');
		$me = &JFactory::getUser();
		$model = &$this->getModel('Profile', "CommunityModel");
		$model->endFriendship($me->id, $frd_id);
		$text = CommunityHelperGeneral::getFriendShipEndEvent($frd_id, $me->id);
		if(COMMUNITY_REGISTER_END_FRIEND)
		{
			JSCommunityApi::registerActivity($me->id, CommunityHelperGeneral::getFriendShipEndActivity($frd_id), $me->id, 'components/com_community/images/delfriend.png', 'user', null, null, '', "Friendship");
		}
		JSCommunityApi::registerEvent(JText::_("Friendship Ended"), $text, $frd_id);
		$this->setRedirect(JRoute::_('index.php?option=com_community&controller=list&task=myfriends&Itemid='.JRequest::getInt('Itemid'), false), JText::_("Friendship Stopped"), 'notice');
	}

	function getAvatars()
	{
		$user_id = JRequest::getInt('user_id');
		$user = &JFactory::getUser($user_id);
		$width = JRequest::getInt('width', 200);
		$height = JRequest::getInt('height', 200);
		$dispatcher = &JDispatcher::getInstance();
		$user->avatar="";
		$dispatcher->trigger('onRenderAvatar', array(&$user));
		if ($user->avatar == '')
		{
			$user->avatar = "components/com_community/images/default_avatar.png";
		}
		JSCommunityApi::getUserAvatar($user->avatar, $width, $height, 100);
		exit;
	}


	function savePluginConfig()
	{

		$post = JRequest::get('post');
		$title = JRequest::getVar('title', '');
		$params = new JParameter('');
		$params->bind($post['params']);
		$id = (int)$post['block_id'];
		$table = &JTable::getInstance('Blocks', 'CommunityTable');
		$table->load($id);
		$table->set('params', $params->toString());
		$table->set('title', $title);
		$table->set('description', @$post['description']);
		$table->store();
		$this->setRedirect('index.php?option=com_community&controller=profile&layout=config&plgid='.$table->plugin_id."&saved=1&tmpl=component");
	}

	function invite()
	{
		global $mainframe;
		$mailsString = JRequest::getString('emails', '');
		str_replace(array(' ', "\n"), ",", $mailsString);
		$emails = explode(",",$mailsString);
		$sitename       = $mainframe->getCfg( 'sitename' );
		$mailfrom       = $mainframe->getCfg( 'mailfrom' );
		$fromname       = $mainframe->getCfg( 'fromname' );
		$siteURL        = JURI::root();
		$user = &JFactory::getUser();
		$uri = & JFactory::getURI();
		$title = JText::sprintf("Invintation to %s community", $sitename);
		$message = JText::sprintf("SITE_INVINTATION_MESSAGE", $sitename, $siteURL);
		foreach($emails as $mail)
		{
			if (strlen(trim($mail))>0)
			{
				JUtility::sendMail($mailfrom, $fromname, trim($mail),$title , $message, CommunityHelperGeneral::isHtmlMessage($message));
			}

		}

		if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
			$return = base64_decode($return);
			if (strpos( $return, 'http' ) !== false && strpos( $return, JURI::base() ) !== 0) {
				$return = '';
			}
		}

		if ($return)
		{
			$this->setRedirect($return, JText::_("Invintations sent"));
		}
		else
		{
			$this->setRedirect($uri->toString(), JText::_("Invintations sent") );
		}
	}

}
?>