<?php
/**
 * $Id: helper.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 
/**
 * Class to manage profile menus
 *
 */
class CommunityHelperMenu
{
	/**
	 * Function to create core menu items
	 *	exclude contains:
	 *    myprofile
	 *    addfriend
	 *    stopfriendship
	 *    editprofile
	 * @param JUser $user
	 * @param JUser $me
	 * @param boolean $isMe
	 * @param midex $exclude
	 * @return mixed
	 *
	 */
	function getCoreMenus($user, $me,  $isMe, $exclude = array())
	{
		global $Itemid;
		$menuItems = array();
		$model = &JModel::getInstance('Profile', 'CommunityModel');
		if (!$isMe && $me->get('id') > 0)
		{
			/*$menuItems['myprofile'] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=profile&user_id=".$me->get('id')."&Itemid={$Itemid}",
			 JText::_('My Profile'), JURI::root().'components/com_community/images/myprofile.png' );*/
			if (COMMUNITY_GENERAL_ALLOW_FRIENDS)
			{
				$menuItems['friends'] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=list&task=myfriends&user_id={$user->id}&Itemid={$Itemid}",
				JText::_('Friends').((int)$user->get('friends_pending', 0)? "<b>(".$user->get('friends_pending').")</b>": ''),
				JURI::root().'components/com_community/images/myfriends.png' );

				if(!$model->isMyFriend($user->id))
				{
					$menuItems['addfriend'] =CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=profile&layout=friend_request&user_id=".$user->id."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID,
					//$menuItems['addfriend'] =CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=profile&task=addfriend&user_id=".$user->id."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID,
					JText::_('Add a Friend'),
					JURI::root().'components/com_community/images/addfriend.png' );
				}
				else
				{
					$menuItems['stopfriendship'] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=profile&task=removefriend&user_id=".$user->id."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID,
					JText::_('Stop Friendship'), JURI::root().'components/com_community/images/delfriend.png');

				}
			}
		}
		else if(COMMUNITY_GENERAL_ALLOW_FRIENDS)
		{
			$menuItems['friends'] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=list&task=myfriends&user_id={$user->id}&Itemid={$Itemid}",
			JText::_('Friends').($me->get('friends_pending', 0)? "<b>(".$me->get('friends_pending').")</b>": ''),
			JURI::root().'components/com_community/images/myfriends.png' );
		}

		if ($me->get('id')>0 && $me->id == $user->id)
		{
			$menuItems['editprofile'] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=profile&task=editprof&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID,
			JText::_('Edit My Profile'),
			JURI::root().'components/com_community/images/editprofile.png');


		}
		if ($me->get('id') > 0 && $user->id != $me->get('id') && COMMUNITY_GROUPS_ALLOW_CREATE)
		{
			$menuItems['invitetogroup'] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=groups&layout=invite&user_id={$user->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID,
			JText::_('Invite to group'),
			JURI::root().'components/com_community/images/community.png');
		}
		if (count($exclude) > 0)
		{
			foreach  ($exclude as $ex)
			{
				unset($menuItems[$ex]);
			}

		}

		return $menuItems;
	}

	/**
	 * function to get menus created by plugins
	 *
	 * @param unknown_type $user
	 * @return unknown
	 */
	function getPluginMenus($user, $userParams)
	{

		$dispatcher = &JDispatcher::getInstance();
		$menus = array();
		$menus = $dispatcher->trigger('onProfileMenu', array($user));
		return $menus;

	}

	function getPluginSlideMenu($user)
	{
		$dispatcher = &JDispatcher::getInstance();
		$menus = array();
		$menus = $dispatcher->trigger('onUserSlideMenu', array($user));
        //do normalize arrays to one level it makes possible to pass multi links with onUserSlide menu into arrays
        for($i=0; $i<count($menus); $i++){
            $menu = $menus[$i];
            if (is_array($menu)){
                foreach ($menu as $m){
                    $menus[] = $m;
                }
                $menus[$i] = null;
            }
        }
		return $menus;
	}


	/**
	 * Create a link object for the menu
	 *
	 * @param string $link
	 * @param string $alt
	 * @param string $icon
	 * @return stdClass object
	 */
	function makeMenuItem($link = '', $alt='', $icon='', $isRoute = true)
	{
		//@todo separate alt from link title
		$ret = new stdClass();
		if ($isRoute)
		{
			$ret->link = JRoute::_($link);
		}
		else
		{
			$ret->link = $link;
		}
		$ret->text = $alt;
		JFilterOutput::cleanText($alt);
		$ret->alt  = $alt;
		
		$ret->icon = $icon;
		return $ret;
	}

	function getGroupMenuItems($access = array(), $group, $user, $Itemid = null)
	{
		if (empty($Itemid)){$Itemid = JRequest::getInt("Itemid");}
		$menuItems = array();
		$uri = & JFactory::getURI();

		if ($user->get('id') > 0)
		{
			if (!$access['isMember'] && !$access['isCreator'])
			{
				$menuItems[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=groups&task=joingroup&id=".$group->id."&Itemid={$Itemid}",JText::_("Join the Group"), '' );
			}
			else if (!$access['isCreator'])
			{
				$menuItems[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&controller=groups&task=leavegroup&id=".$group->id."&Itemid={$Itemid}",JText::_("Leave the Group"), '' );
			}
		}

		if (($access['isMember'] || $access['isModerator'] || $access['isCreator']) && COMMUNITY_GROUPS_ALLOW_CREATE)
		{
			$menuItems[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=customlist&client=community&view-what=invite&group=".$group->id."&Itemid={$Itemid}",JText::_("Invite Friends to Group"), '' );
		}

		if ($access['isModerator'] || $access['isCreator'])
		{
			$menuItems[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=groups&layout=requests&id={$group->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID.'&redirect='.base64_encode($uri->toString()), JText::_("Manage Group Members"), '' );
		}

		if ($access['isCreator'] || in_array($user->get('gid'), array(23,24,25)))
		{
			$menuItems[] = CommunityHelperMenu::makeMenuItem("index.php?option=com_community&view=groups&layout=create&id={$group->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID, JText::_("Edit the Group"), '', false );
			$menuItems[] = CommunityHelperMenu::makeMenuItem("javascript:removeCommunityGroup();", JText::_("Delete the Group"), '', false );
		}

		if(in_array($user->get('gid'), array(22,23,24,25)))
		{
			if ($group->published)
			{
				$menuItems[] = CommunityHelperMenu::makeMenuItem('index.php?option=com_community&controller=groups&task=unpublish&id='.$group->id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, JText::_("Unpublish Group"), '', false );
			}
			else
			{
				$menuItems[] = CommunityHelperMenu::makeMenuItem('index.php?option=com_community&controller=groups&task=publish&id='.$group->id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, JText::_("Publish Group"), '', false );
			}
		}

		return $menuItems;
	}

}
/**
 * Class to manage user configurations
 *
 */
class CommunityHelperUserConfigs
{
	function getPluginConfigs($userParams)
	{
		$db  = &JFactory::getDBO();
		$sql = "SELECT * FROM #__plugins WHERE `folder` = 'community' AND `published` = 1";
		$db->setQuery($sql);
		$plugins = $db->loadObjectList();
		$params  = array();
		$pathToPlugins = JPATH_ROOT.DS.'plugins'.DS.'community';
		foreach ($plugins as $plg)
		{
			$tmp =  new JParameter($userParams, $pathToPlugins.DS.$plg->element.'.xml');
			$params[$plg->name] = $tmp->render('params', "Custom Parameters");
		}

		return $params;

	}

	/**
	 * Function to get Plugin Custom params for each plugin
	 *
	 * @param JUser Object $user
	 * @param string $userParams in ini format
	 */
	function getBlocks($user)
	{
		defined ('COMMUNITY_BLOCKS_HIDE_CONFIG') or define('COMMUNITY_BLOCKS_HIDE_CONFIG', '');
		$toHideTmp = explode("|",COMMUNITY_BLOCKS_HIDE_CONFIG);
		$tohide = "";
		if ($toHideTmp[0]!= '' && !empty($toHideTmp[0]))
		{
			$tohide = " AND plg.id NOT IN (".implode(" , ", $toHideTmp).") ";
		}
		unset($toHideTmp);
		$db = &JFactory::getDBO();
		$sql = "SELECT plg.element,plg.name AS plugintitle, plg.id AS plgid, plg.name, plg.params as pluginparams, blck.*  FROM #__plugins AS plg "
		."\n LEFT JOIN #__community_blocks AS blck ON blck.plugin_id = plg.id AND blck.user_id = ".$user->id
		."\n WHERE plg.folder = 'community' AND plg.published = 1 {$tohide} ORDER BY blck.ordering ASC, plg.ordering ASC";
		

		$db->setQuery($sql);

		$result = $db->loadObjectList();
		$table = &JTable::getInstance('Blocks', 'CommunityTable');
		$userBlocks = array();
		for ($i = 0; $i < count($result); $i++)
		{
			$to_add = false;
			$item = &$result[$i];
			$element = new StdClass();

			$element = CommunityHelperUserConfigs::userEditBlockCheckBlockExistence($user->id, $item->plgid);
			$table->load($element->id);
			$element = clone($table);

			$element->element = $item->element;
			$element->access = (int)$item->access;
			$element->description = (string)$item->description;
			$element->params = new JParameter((string)$item->params);
			$element->plg_params = new JParameter($item->pluginparams);
			$element->plugintitle = $item->plugintitle;

			$userBlocks[$i] = $element;

		}
		return $userBlocks;

	}

	function getPluginOtherParams($user, $userParams)
	{
		$access = (int) $user->get('aid', 0);
		$db  = &JFactory::getDBO();
		$sql = "SELECT * FROM #__plugins WHERE `folder` = 'community' AND `published` = 1 AND `access` <= {$access}";
		$db->setQuery($sql);
		$plugins = $db->loadObjectList();
		$params = array();
		foreach($plugins as $plg)
		{
			$param = new JParameter($userParams, JPATH_ROOT.DS.'plugins'.DS.'community'.DS.$plg->element.'.xml');
			if (!count($param->renderToArray('params','Custom Parameters')))
			{
				continue;
			}

			$params[$plg->name] = $param->render('params', 'Custom Parameters');
		}
		return $params;
	}

	function loadJParams($file)
	{
		$ini = '';
		if (JFile::exists($file))
		{
			$ini = JFile::read($file);
		}
		return new JParameter($ini);
	}

	function loadIni($file)
	{
		$ini = '';
		if (JFile::exists($file))
		{
			$ini = JFile::read($file);
		}
		return $ini;
	}

	/**********************************************************************/
	// These function  are used by xajax
	//*********************************************************************
	function userEditBlockAddBlock($params = array())
	{
		$table = &JTable::getInstance('Blocks', "CommunityTable");
		$table->bind($params);
		if (!$table->store())
		{
			return 0;
		}
		else
		{
			return $table->id;
		}

	}

	function userEditBlockCheckBlockExistence($uid, $plg_id)
	{
		if((int)$uid == 0 || (int)$plg_id == 0)
		{
			return false;
		}
		$db = &JFactory::getDBO();
		//first we need to check if plugin exists
		$sql = "SELECT blk.id, plg.name, plg.element, plg.params AS pluginparams  FROM #__community_blocks AS blk"
		."\n LEFT JOIN #__plugins AS plg ON blk.plugin_id = plg.id "
		."\n WHERE blk.user_id = $uid AND blk.plugin_id = $plg_id";
		$db->setQuery($sql);

		//$objResponse->assign('ajax_indicator', "innerHTML", $db->_sql);
		$block_id = $db->loadObject();
		if (!(boolean)@$block_id->id)
		{


			$ordering = CommunityHelperUserConfigs::getNextBlockOrdering($uid);
			$sql = "SELECT * FROM #__plugins WHERE id = $plg_id";

			$db->setQuery($sql);
			$plugin = $db->loadObject();
			$pluginParams = new JParameter($plugin->params);
			$block_id->id = CommunityHelperUserConfigs::userEditBlockAddBlock(array("user_id"=>$uid, "plugin_id"=>$plg_id, 'title'=>$plugin->name, 'published'=>$pluginParams->get('default_status', 1), "access"=>$pluginParams->get('default_access', 0), "ordering" => $ordering));
			if(!$block_id->id )
			{
				return false;
			}
		}
		return $block_id;

	}

	function getNextBlockOrdering($uid)
	{
		$db = &JFactory::getDBO();
		//First we need to see how many block does this one have
		$sql = "SELECT COUNT(*) FROM #__community_blocks WHERE user_id = {$uid}";
		$db->setQuery($sql);
		$numOfBlocks = $db->loadResult();
		return $numOfBlocks;
	}

	//***********************************************************************
	//***********************************************************************
	//***********************************************************************

}

class CommunityHelperGeneral
{
	function _cleanArray($array)
	{
		$ret = array();
		foreach ($array as $val)
		{
			if (empty($val))
			{
				continue;
			}
			else
			{
				$ret[] = $val;
			}

		}
		return $ret;
	}

	function uploadImage($name, $file, $max_width, $max_height, $quality, $folder, $type = false)
	{
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$file = JPath::clean($file);
		$folder = JPath::clean($folder);

		if($type) $folder = $folder.DS.$name."_".$type; else $folder = $folder;

		if(!JFolder::exists($folder))
		{
			if(!JFolder::create($folder, 0777))
			{
				JError::raiseWarning(403, JText::_("Cannot Create Folder resizing picture, Please, check upload
    				directory is correct and accessible"));
				return false;
			}
		}

		if(!JFile::exists($file))
		{
			JError::raiseWarning(100 ,JText::_("Not Exists ").$file); //exit();
			return false;
		}

		$size = getimagesize($file);
		//exit;
		if(($size[0] <= $max_width) && ($size[1] <= $max_height))
		{
			JError::raiseNotice(01, "No Resize Needed");
			if(!JFile::exists($folder.DS.$name)) JFile::copy($file, $folder.DS.$name);
			return;
		}

		if(($size[0] > $max_width) && ($size[0] > $size[1]))
		{
			$width  = $max_width;
			$k = $size[0] / $max_width;
			$height = ($size[1] / $k);
		}
		else
		{
			$width  = $size[0];
			$height = $size[1];
		}

		if($height > $max_height)
		{
			$k = $height / $max_height;
			$height = $max_height;
			$width = ($width / $k);
		}


		$width  = round($width);
		$height = round($height);

		switch(strtolower($size['mime']))
		{
			case "image/gif":
				$img = imagecreatefromgif($file);
				break;
			case "image/png":
				$img = imagecreatefrompng($file);
				break;
			case "image/pjpeg":
			case "image/jpeg":
			case "image/jpg":
				$img = imagecreatefromjpeg($file);
				break;
		}
		if(!$img)
		{
			JError::raiseWarning(240, JText::_('Cannot create Image'.$file.$add));
			return ;
		}

		$mini  = imagecreatetruecolor($width, $height);
		$white = imagecolorallocate  ($mini,255,255,255);
		imagecopyresampled($mini,$img,0,0,0,0,$width,$height,$size[0],$size[1]);
		//ob_start();
		imagejpeg($mini, $folder.DS.$name);
		/*$imageContents = ob_get_contents();
		JFile::write( JPATH_ROOT.DS.$folder.DS.$name, $imageContents);
		ob_end_clean();*/
		//echo $folder.DS.$name;
		imagedestroy($mini);
		imagedestroy($img);
	}

	/***************************************************************************
	 * HERE GOES ACTIVITY AND EVENTS
	 */
	function getFriendShipEndEvent($friend_id, $user_id)
	{
		$user = JFactory::getUser($user_id);
		ob_start();
		include JPATH_COMPONENT.DS.'views'.DS.'events'.DS.'end_friend.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}

	function getFriendShipEndActivity( $friend_id)
	{
		$friend = &JFactory::getUser($friend_id);
		$text =JText::sprintf("has stopped friendship with %s", '<a href="'.JRoute::_('index.php?option=com_community&view=profile&user_id='.$friend->id.'&Itemid='.COMMUNITY_GENERAL_PROFILE_ITEMID).'">'.$friend->username.'</a>');
		return $text;
	}


	function getFriendAddedEvent($user_id, $friend_id,  $message = "", $id, $default)
	{
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'add_friend.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
	function getEventConfirmfFiendship($user_id)
	{
		$user = JFactory::getUser($user_id);
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'confirm_friend.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
	function getEventInviteToGroup($whom, $who, $group)
	{
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'invite_group.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
	function getEventJoinGroupRequest($who, $group, $message)
	{
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'join_group_request.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
	function getEventGroupJoinReject($group)
	{
		$user = JFactory::getUser();
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'invite_group_reject.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
	function getEventGroupJoinAccept($group)
	{
		$user = JFactory::getUser();
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'invite_group_accept.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}

	function getEventRejectFriendship($user_id)
	{
		$user = JFactory::getUser($user_id);
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'reject_friend.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
	function getEventGroupJoinRequestReject($group)
	{
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'join_request_reject.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
    function getEventGroupJoinRequestBlock($group)
	{
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'join_request_block.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}
	function getEventGroupJoinRequestAccept($group)
	{
		ob_start();
		include JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'events'.DS.'join_request_accept.php';
		$text = ob_get_contents();
		ob_end_clean();
		return $text;
	}



	/**
	 * ACTIVITY AND EVENTS END HERE.
	 **************************************************************************/
	/**
	 * redirects user to the login page
	 *
	 */
	function redirectToLogin()
	{
		global $mainframe, $Itemid;
		$uri= &JFactory::getURI();

		switch(COMMUNITY_GENERAL_REGISTER)
		{

			case 'com_comprofiler':{
				//@JSTODO: Find the url for the login page for the Community Builder Component
				$mainframe->redirect('index.php?option=com_comprofiler&task=registers&Itemid='.$Itemid);
				break;
			}
			case 'com_user':{
				$mainframe->redirect('index.php?option=com_user&view=login&return='.base64_encode($uri->toString()).'&Itemid='.$Itemid);
				break;
			}
			case 'com_juser':{
				$mainframe->redirect('index.php?option=com_juser&view=user&layout=login&return='.base64_encode($uri->toString()).'&Itemid='.$Itemid);
			}

		}
	}
	/**
	 * check whether the message contains html tags or not.
	 *
	 * @param string $message
	 * @return boolean
	 */
	function isHtmlMessage($message)
	{
		if ( JString::strlen($message) != JString::strlen(strip_tags($message)))
		{
			return 1;
		}
		return 0;

	}


	function getLimitString($limitstart, $limit)
	{
		$limitStr = "";
		if ($limit)
		{
			$limitStr = " LIMIT {$limit}";
		}
		if ($limitstart && $limit)
		{
			$limitStr = " LIMIT {$limitstart}, {$limit}";
		}
		return $limitStr;

	}

}

class CommunityHelperSiteTemplates
{
	function parseXMLTemplateFiles($templateBaseDir)
	{
		// Read the template folder to find templates
		jimport('joomla.filesystem.folder');
		$templateDirs = JFolder::folders($templateBaseDir);

		$rows = array();

		// Check that the directory contains an xml file
		foreach ($templateDirs as $templateDir)
		{
			if(!$data = CommunityHelperSiteTemplates::parseXMLTemplateFile($templateBaseDir, $templateDir)){
				continue;
			} else {
				$rows[] = $data;
			}
		}

		return $rows;
	}

	function parseXMLTemplateFile($templateBaseDir, $templateDir)
	{
		// Check of the xml file exists
		if(!is_file($templateBaseDir.DS.$templateDir.DS.'templateDetails.xml')) {
			return false;
		}

		$xml = JApplicationHelper::parseXMLInstallFile($templateBaseDir.DS.$templateDir.DS.'templateDetails.xml');

		if ($xml['type'] != 'template') {
			return false;
		}

		$data = new StdClass();
		$data->directory = $templateDir;

		foreach($xml as $key => $value) {
			$data->$key = $value;
		}

		$data->checked_out = 0;
		$data->mosname = JString::strtolower(str_replace(' ', '_', $data->name));

		return $data;
	}



}

class CommunityHelperGroups
{
	function checkGroupAccess($user, $group_id, $access, $creator=null, $reiseError = true)
	{
		if ((in_array($user->get('gid'), array(21, 23, 24, 25))) || ($creator && $user->get('id')== $creator))
		{
			return TRUE;
		}

		if($access > 0 && $user->get("id") < 1)
		{
			JError::raiseNotice(403, JText::_("At least registered users can access this group. Please login or register."));
			CommunityHelperGeneral::redirectToLogin();
		}

		$mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
		switch($access)
		{
			case 2;
			if (!$mModel->isGroupMember($group_id, $user->get('id')))
			{
				if($reiseError)
				    JError::raiseNotice(403, JText::_("Only group members can access this group. Please request to join this group."));
				return false;
			}
			break;

			case 3;
			if (!$mModel->isGroupMemberFriend($group_id, $creator, $user->get('id')) && !$mModel->isGroupMember($group_id, $user->get('id')))
			{
			    if($reiseError)
				    JError::raiseNotice(403, JText::_("You should be at least a friend of one of the group member to access this group without being a member. Please request to join this group."));
				return false;
			}
			break;

			case 4;
			if (!$mModel->isGroupModerator($group_id, $user->get('id')))
			{
				$text = JText::_("You need to be a moderator of the group to access it.");
				if (!$mModel->isGroupMember($group_id, $user->get('id')))
				{
				    if($reiseError)
					    JError::raiseNotice(403, $text.' '.JText::_("Please, start with request to join this group."));
					return false;
				}
				else
				{
				    if($reiseError)
					    JError::raiseNotice(403, $text.' '.JText::_("Please, contact group creator and request to be a moderator."));
					return false;
				}
			}
			break;
			case 5;
			if($user->get('id')!= $creator)
			{
			    if($reiseError)
				    JError::raiseNotice(403, $text.' '.JText::_("Only creator have access to this group."));
				return false;
			}
			break;
		}
		return TRUE;
	}

	/**
	 * available types : access_karma_limit
	 * 					 submit_access_karma_limit
	 * 					 comment_access_karma_limit
	 * 					 karma_join_limit
	 *
	 * @param JUser Object $user
	 * @param int $group_id
	 * @param int $creator creator user id
	 * @param string $type
	 * @return boolean
	 */
	function checkGroupCarmaAccess($user, $group_id, $creator, $type='access_karma_limit')
	{
		if ($user->get('aid') == 2 || $user->get('id') == $creator)
		{
			return true;
		}

		$carmaList = JSCommunityApi::getCarmaList();
		$userKarmaIndex = $user->get('karmaindex', 0);

		$table = &JTable::getInstance('Groups', 'CommunityTable');

		$table->load($group_id);
		if ($table->get('id') == 0)
		{
			JError::raiseWarning(500, JText::_("The Group Not Found"));
			return false;
		}
		$params = new JParameter($table->get('params', ''));
		$karmaIndex = $params->get($type, 0);
		if ($userKarmaIndex < $karmaIndex)
		{
			return false;
		}
		return true;


	}

	function canCreateGroup(&$user, $catid = 0)
	{
		if ($catid == 0)
		{
			return true;
		}
		if ($user->get('id') < 1 )
		{
			return false;
		}

		$gid = $user->get('gid');
		$aid = $user->get('aid');
		$db = &JFactory::getDBO();
		$sql = "SELECT id FROM #__community_group_categories WHERE id = $catid AND published = 1 AND access_create LIKE '%{$gid}%' AND access <= $aid";
		$db->setQuery($sql);
		$result = $db->loadResult();
		if ($result)
		{
			return true;
		}

		return false;



	}

	function getCategoriesToCreateGroup(&$user)
	{
		if ($user->get('id') < 1)
		{
			return array();
		}
		$gid = $user->get('gid');
		$aid = $user->get('aid');
		$db  = &JFactory::getDBO();
		$sql = "SELECT id FROM #__community_group_categories WHERE `access_create` LIKE '%{$gid}%' AND `access` <= $aid AND published = 1";
		$db->setQuery($sql);
		return $db->loadResultArray();

	}

	function doesHaveGroup($uid)
	{
		$db = &JFactory::getDBO();
		$result = false;
		$sql = "SELECT COUNT(*) FROM #__community_user_mapping WHERE `user_id` = {$uid} AND `user_block` = 0";
		$db->setQuery($sql);
		$result = $db->loadResult();
		if (!$result)
		{
			$sql = "SELECT COUNT(*) FROM #__community_communities WHERE user_id = {$uid} AND published = 1" ;
			$db->setQuery($sql);
			$result = $db->loadResult();
		}
		return $result;

	}


}


class CommunityHelperResource
{
	function getNumRecords($section, $client, $cliend_id)
	{
		$db = &JFactory::getDBO();
		$client = $db->getEscaped($client);
		$cliend_id = intval($cliend_id);
		$sql = "SELECT COUNT(*) FROM #__js_res_record AS r "
		."\n INNER JOIN #__js_res_record_category AS rc ON r.id = rc.record_id "
		."\n INNER JOIN #__js_res_category AS cc ON rc.catid = cc.id "
		."\n WHERE r.client =  '$client' AND r.client_id = $cliend_id AND (cc.id = $section OR cc.section_id = $section)";
		$db->setQuery($sql);

		return $db->loadResult();
	}

	/**
	 * Returns helper instance.
	 * @return JS_Res_Community_Helper_v1
	 */
	function & getInstance() {
		static $instance = 0;
		if (!$instance)
		$instance = new JS_Res_Community_Helper_v1();

		return $instance;
	}

	function CoomunityHelperResources() {
		$this->_initResourceConfig();
	}
	
	function getUserItems($user, $view_what, $sectionId, $limit , $tag)
	{
		global $mainframe;
		jimport ('joomla.utilities.date');

		require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'view.html.php');
		require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
		require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'helper.php');
		$document = &JFactory::getDocument();
		$db 	  = &JFactory::getDBO();
		$document->addScript( JURI::root().'components/com_resource/helpers/script.js' );
		$document->addScript( JURI::root().'/components/com_resource/helpers/felixrating.js' );
		$me = &JFactory::getUser();
			
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');

		$model = &JModel::getInstance('List','ResModel');
		$view  = new ResViewList();

		$limit = (int)$limit;
		if ($limit <= 0)
		$limit = 99999;

		$mainframe->setUserState('com_resource.filter_order_Dir', 'DESC');
		$model->setState('limit', $limit);
		$params = new JParameter('');
		$params->set('view_what', $view_what);
		//$params->set('ratingtmpl', 'default');
		$params->set('client', 'module');
		//JRequest::setVar('artdet_client', 'module');
		//JRequest::setVar('artdet_params',$params );
		//JRequest::setVar('client', 'resource');
			

		$document	= &JFactory::getDocument();
		$uri 		= &JFactory::getURI();
		$pathway	= &$mainframe->getPathway();
		$itemid		= JRequest::getInt('Itemid');

		$params->set('section_id', $sectionId);
		$sparams	= ResHelper::initListParams($params->get('section_id'));
		$params->merge($sparams);

		$document->addScript(JURI::root().'includes/js/joomla.javascript.js');

		$filter_order_Dir_varName = 'filter_order_dir'.$itemid;
		$model->setState($filter_order_Dir_varName, 'DESC');

		$items 		= $model->getUserData($user->get('id'), $params);
		if (count($items)<1)
		{
			return;
		}

		//JRequest::setVar('Itemid', $theItemid);

		$category = $model->getCategory($params->get('section_id', $sectionId));
		$section = $model->getCategory($sectionId);
		$params->set("generate_user_menu", 0);
		$items = $view->prepareItems($items, $params, $category);

		if ($view_what == 'favorites')
		{
			for($i = 0; $i<count($items); $i++)
			{
				$sql = "SELECT COUNT(*) FROM #__js_res_favorite WHERE `record_id` = {$items[$i]->id}";
				$db->setQuery($sql);
				$items[$i]->total_favourites = $db->loadResult();
			}

		}



		$columns = array();
		$nfields = array();
		$ifields = array();
		$cols = array();
		$cols_additional = array();;
		foreach ($items AS $key => $item)
		{
			$fields[$item->id] = $model->getFields($item->id);
			if(is_array($fields[$item->id]))
			{
				foreach ($fields[$item->id] AS $k => $field)
				{
					$columns[$field->ordering]['title'] = $field->title;
					$columns[$field->ordering]['id'] = $field->fid;

					$columns[$field->ordering]['params'] = new JParameter( $field->params );

					$get = false;
					$field_params = new JParameter($field->params);
					$dispatcher =& JDispatcher::getInstance();
					JPluginHelper::importPlugin( 'joomsuite_content_fields', $field->type );
					$dispatcher->trigger( 'onRenderFieldValue', array (&$get, & $field, $field_params, $field->type, $item->user_id ) );
					if($get)
					{
						if(!$model->_fieldSubscriptionAccess($get, $field_params))
						{
							$model->_fieldGroupAccess($get, $field_params);
						}
						if($get)
						{
							$ifields[$key][$field->title] = $get;
							$ifields[$key][$field->fid] = $get;

						}

					}
					$nfields[$item->id][$field->fid] = $field;
					$nfields[$item->id][$field->fid]->result = $get;
					//					if($get) $ifields[$key][$field->title] = $get;
				}
			}
		}
		$fields = $nfields;
		if(count($columns) > 0)
		{
			ksort($columns);
			foreach ($columns AS $sort => $data)
			{
				$cols[$data['title']] = $data['id'];
				$cols_additional[$data['title']]['params'] = $data['params'];
			}
		}
		$array = array("rated", "favorites", "commented", "last-visited", "created", 'user_category');

		if(!in_array($params->get('view_what'),$array))
		{
			JError::raiseWarning(404, JText::_('Cannot find records, view_what parameter is not correct'));
			$mainframe->redirect(JURI::root());
		}

		$contents = new StdClass();
		$contents->title = JText::_($tag);

		$tpl_array = explode(",", $params->get('tmpl_list'));
		$params->set('tmpl_list', $tpl_array[0]);
		$tmpl_ini = JFile::read(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.ini');
		$tmpl_xml = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.xml';
		$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
		$params->merge($tmpl_params);

		//include_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'view.html.php';
		//ResViewList::prepareItems($items, $params, $category);

		$this->params = $params;
		$this->cols = $cols;
		$this->fields = $fields;
		$this->ifields = $ifields;
		$this->items = $items;
		$this->section = $section;
		$this->category = $category;
		$this->cols_additional = $cols_additional;
		$this->user = $me;



		//$this->assignRef('views', 	$views);

		ob_start();

		include JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.php';


		//$template = new JS_People_Touch_Resource_Section_Template(null, $template);
		//$template->setPluginNameFromViewWhat($view_what);

		//include $template->getTemplatePath();

		$contents->text = ob_get_contents();
		ob_end_clean();

		return $contents;
	}

	
	function getFieldValue($field, $user)
	{
		$model = &JModel::getInstance('List','ResModel');
		return $model->getFieldValue($field, $user);
	}
	function _initResourceConfig() {
		static $isInitialized = 0;

		if (!$isInitialized)
		{
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
			ResControllerConfig::initialyze();

			require_once JPATH_PLUGINS.DS.'community'.DS.'elements'.DS.'sectiontemplate.php';

			$isInitialized = 1;
		}
	}
}
function TcleanGet()
{
	$uri = & JFactory::getURI();

	foreach ($uri->_vars as $key => $var)
	{
		switch ($key)
		{
			case 'activity_type':
			case 'select_type':
				$uri->delVar($key);
				break;
		}
	}
}
?>