<?php
/**
 * $Id: resource_helper.php 7356 2011-09-29 09:39:37Z peter $
 * $LastChangedDate: 2011-09-29 15:39:37 +0600 (Thu, 29 Sep 2011) $
 * $LastChangedBy: peter $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 
class TouchResourceHelper
{
	var $sectionData = null;

	var $pluginData = null;
	
	/**
	 * 
	 * @return TouchResourceHelper
	 */

	function & getInstance() {
		static $instance = 0;
		if (!$instance)
		$instance = new TouchResourceHelper();

		return $instance;
	}

	function TouchResourceHelper() {
		$this->_initResourceConfig();
		if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php'))
		{
			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php';
		}
	}
	
	function onProfileExtra($user, $style, $params, $view_what, $name)
	{
		$sectionParams = $this->convertParams($params);
		usort($sectionParams, array($this, '_sortParamsFunc'));

		$me = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$o = '';
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
		$m = JModel::getInstance('list', 'ResModel');
		JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'tables');
		$section = & JTable::getInstance('category', 'Res');

		$blocks = array();

		$options['view_what'] = $view_what;
		$options['user_id'] = $user->id;
		$options['records_mode'] = 2;
		$options['client'] = 'module';
		
		foreach ($sectionParams as $v) {
			$section->reset();
			$section->load($v['id']);
			$block = new stdClass();
			if($section->published == 0) continue;
			if ($v['show_blocks'] == 'hide') continue;
			if ($v['show_blocks'] == 'owner' && $me->get('id', -12) != $user->get('id', -13)) continue;

			$options['limit'] = $v['limit'];
			if(is_string($v['template'])) $options['template'] = $v['template'];
			$options['category'] = $v['id'];
			$options['list_clients'] = ($v['show_clients'] == 'Yes' ? 1 : 0);

			$block->title = $v['title'];
			$items = MightyResourcesApi::getRecordList($options, array(), array(), $m, $o);
			if(count($items[0]) <= 0) continue;
			$block->html = $items[1];

			if ($v['view_more'] == 'Yes') {
				$link = JRoute::_(MEUrl::link_list($v['id'], array('user_id' => $user->id, 'view_what' => $view_what)));
				$link = JHTML::link($link, JText::sprintf('View all %s in %s', $view_what, $section->name), array('class' => 'readon'));
				$block->html .= sprintf('<br /><div align="right">%s</div><br style="clear:both" />', $link);
			}
				
			$blocks[] = $block;
		}
//		print_r($blocks);

		return $this->prepareForOutput($blocks, $style, $name);
	}

	function prepareForOutput($blocks = array(), $style = 'tabs', $name = "User Resources")
	{
		if (count($blocks) < 1)
		{
			return;
		}
		$block = new JSCommunityTab();

		$block->text .= '';
		switch($style)
		{
			case 'tabs':
			case 'sliders':
				jimport('joomla.html.pane');
				$tabs = &JPane::getInstance($style);
				$block->text .= $tabs->startPane( 'pane-'.rand(1,1000) );

				foreach ($blocks as $key => $blck)
				{
					if ($blck == null){continue;}
					if (!@$blck->html){continue;}
					$block->text.= $tabs->startPanel($blck->title, '-block'.$key);
					$block->text.= $blck->html;
					$block->text.= $tabs->endPanel();
				}
				$block->text.= $tabs->endPane();
				break;
			case 'classic':
			default:
				foreach ($blocks as $key => $blck)
				{
					if ($blck == null){continue;}
					if (!@$blck->html){continue;}
					$block->text.= "<div class='contentheading'>{$blck->title}</div>";
					$block->text.= $blck->html;

				}
				break;
		}
		$block->title = JText::_($name);
		$block->description = "";
		$block->name = "com_resource";

		return $block;
	}

	/**
	 * Generic onProfileMenu for community-resource integration plugins.
	 * @param $user JUser The owner of current profile
	 * @param $pluginName string The name of plugin
	 * @param $pluginType string Plugin type
	 * @param $viewWhat string Resource view_what parameter
	 * @param $params array configuration array
	 *
	 * @return unknown_type
	 */
	function onProfileMenu($profile, $pluginName, $pluginType, $viewWhat, $params)
	{
		$user = & JFactory::getUser();
			
		$obj = $this->getPluginObject($pluginName, $pluginType);
		
		$plugin_params = new JParameter($obj->plugin_params);
		if (!$plugin_params->get('allow_accesschange')){
			$access = $plugin_params->get('default_access ', 0);
		}else{
			$access = $obj->access;
		}

		if ($access == 1)
		{
			if ($user->get('id')<1)
			{
				return null;;
			}

		} else if ($access == 2)
		{
			$model = &JModel::getInstance('Profile', 'CommunityModel');
			if (($user->get('id') != $profile->id) && (count($model->getFriends($user->get('id')))<1 || $user->get('id') < 1))
			{
				return null;;
			}

		} else if ($access == 3 && ($user->get('id') != $profile->id))
		{
			return null;;
		}

		$menu = new stdClass;

		$menu->title = JText::_($obj->name);
		$menu->menuItems = array();

		$sectionParams = $this->convertParams($params);
		foreach ($sectionParams as $k => $v) {
			// skip hidden blocks
			if ($v['show_menu'] != 'Yes')
				continue;

			$menuItem = new stdClass;

			$link = MEUrl::link_list($k, array('user_id' => $profile->id, 'view_what' => $viewWhat));
			$menuItem->link = JRoute::_($link);
			$menuItem->alt 	= $v['title'];
			$menuItem->icon = "plugins/community/icons/".$this->_getIconByViewWhat($viewWhat);

			$menu->menuItems [] = $menuItem;
		}

		if (count($menu->menuItems))
			return $menu;
		return null;
	}

	function getPluginObject($pluginName, $pluginType)
	{
		if (empty($this->pluginData))
		{
			$this->pluginData = array();

			if (empty($this->pluginData[$pluginType]))
			{
				$this->pluginData[$pluginType] = array();
				$db = & JFactory::getDBO();
				$user = & JFactory::getUser();
				$uid = JRequest::getInt('user_id', $user->get('id'));
				
				defined ('COMMUNITY_BLOCKS_HIDE_CONFIG') or define('COMMUNITY_BLOCKS_HIDE_CONFIG', '');
				$toHideTmp = explode("|",COMMUNITY_BLOCKS_HIDE_CONFIG);
				$tohide = "";
				if ($toHideTmp[0]!= '' && !empty($toHideTmp[0]))
				{
					$tohide = " AND plg.id NOT IN (".implode(" , ", $toHideTmp).") ";
				}
				unset($toHideTmp);
				$user = JFactory::getUser();
				$sql = "SELECT blck.*, plg.element, plg.params AS plugin_params, plg.name AS name FROM #__community_blocks AS blck "
				."\n LEFT JOIN #__plugins AS plg ON blck.plugin_id = plg.id"
				."\n WHERE blck.user_id = {$uid} AND plg.published = 1  {$tohide} AND  plg.folder = ".$db->Quote($pluginType)." GROUP BY blck.plugin_id ORDER BY `ordering`";
				;

				$db->setQuery($sql);
				$objects = $db->loadObjectList();
//var_dump($objects);					
				foreach ($objects as $obj) {
					$this->pluginData[$pluginType][ $obj->element ] = $obj;
				}
			}
		}
			
		if (!empty($this->pluginData[$pluginType][$pluginName]))
		return $this->pluginData[$pluginType][$pluginName];


		return null;
	}

	/**
	 * Initializes com_resource settings
	 * @return void
	 */
	function _initResourceConfig() {
		static $isInitialized = 0;

		if (!$isInitialized)
		{
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
			ResControllerConfig::initialyze();

			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'elements'.DS.'sectiontemplate.php';

			$isInitialized = 1;
		}
	}

	/**
	 * Converts one-dimensional array to 2D array, where the keys are section ids.
	 * Use with jsresblockparam2 element data
	 *
	 * @param $value array The array to be converted.
	 * @param $varCount int the size of a configuration row in jsresblockparam2 element
	 * @return array
	 */
	function convertParams($value, $varCount = 9)
	{
		if ($varCount == 9)
		    $names = array('title', 'show_blocks', 'limit', 'order', 'template', 'show_menu', 'view_more', 'show_clients');
		else
		    $names = array('title', 'show_blocks', 'limit', 'order');
			
		$ret = array();
//		print_r($value);
		$i = 0;
		$count = count($value);
		while ($i < $count) {
			@$ret[$value[ $i ]] = array();
			
			for ($j = $i + 1; $j < $i + $varCount; $j++)
			    @$ret[$value[ $i ]][$names[$j - $i - 1]] = $value[ $j ];

			@$ret[$value[ $i ]]['id'] = (int)$value[ $i ];
			$i += $varCount;
		}
			
//		print_r($ret);

		return $ret;
	}

	function cleanArray($array)
	{
		$ret = array();
		foreach ($array as $val)
		{
			if (empty($val))
			{
				continue;
			}
			else
			{
				$ret[] = $val;
			}

		}
		return $ret;
	}

	/**
	 * Returns appropriate icon name for $viewWhat parameter.
	 * @param $viewWhat string What to show [tags, created, visited, etc..]
	 * @return string icon name
	 */
	function _getIconByViewWhat($viewWhat) {
		switch (strtolower($viewWhat)) {
			case 'created':
				return 'created.png';
			case 'favourites':
				return 'favorites.png';
			case 'rated':
				return 'ratings.png';
			case 'commented':
				return 'comments.png';
			case 'last-visited':
				return 'visited.png';
			case 'tags':
				return 'tags.png';
		}

		return 'created.png';
	}

	/**
	 * Sort helper callback function
	 * @param $a
	 * @param $b
	 * @return unknown_type
	 */
	function _sortParamsFunc($a, $b) {
		return (int)$a['order'] - (int)$b['order'];
	}
}

?>