<?php
/**
 * $Id: resource_helper_.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 

if (!class_exists('JS_Res_Community_Helper_v1')) {

	class JS_Res_Community_Helper_v1
	{
		var $sectionData = null;
		
		var $pluginData = null;

		/**
		 * Returns helper instance.
		 * @return JS_Res_Community_Helper_v1
		 */
		function & getInstance() {
			static $instance = 0;
			if (!$instance)
				$instance = new JS_Res_Community_Helper_v1();

			return $instance;
		}

		function JS_Res_Community_Helper_v1() {
			$this->_initResourceConfig();
		}

		/**
		 * Prepares block for output.
		 *
		 * @param $blockName string The name of the block
		 * @param $blocks array the array of blocks
		 * @param $userId int User id of block owner
		 * @param $layoutStyle string The layout style of block items
		 * @param $showIcons boolean Show icons
		 * @param $description string Block description
		 * @return unknown_type
		 */
		function prepareForOutput($blockName, &$blocks, $userId = 0, $layoutStyle, $showIcons, $description = '')
		{
			$blocks = $this->cleanArray($blocks);

			if (count($blocks) < 1)
			{
				return false;
			}
			$block = new JSCommunityTab();


			$block->text.='';
			switch($layoutStyle)
			{
				case 'tabs':
				case 'sliders':
					jimport('joomla.html.pane');
					$tabs = &JPane::getInstance($layoutStyle);
					$block->text.= $tabs->startPane( 'pane' );

					foreach ($blocks as $key => $blck)
					{
						if ($blck == null)
						continue;

						if ($showIcons && @$blck->icon) {
							$blck->title = JHTML::image(JURI::root().'images/icons/'.$userId.'/'.$blck->icon, $blck->title).'<span style="clear: both;display: block;">'.$blck->title.'</span>';
						}

						$block->text .= $tabs->startPanel($blck->title, $blockName.'-block'.$key);
						$block->text .= $blck->text;
						if (!empty($blck->viewMoreLink))
						$block->text .= $blck->viewMoreLink;
						$block->text .= $tabs->endPanel();
					}
					$block->text .= $tabs->endPane();
					break;
				case 'classic':
				default:
					foreach ($blocks as $key => $blck)
					{
						if ($blck == null)
						continue;

						if ($showIcons && !empty($blck->icon)) {
							$blck->title = JHTML::image(JURI::root().'images/icons/'.$userId.'/'.$blck->icon, $blck->title).'<br />'.$blck->title;
						}

						$block->text.= "<div class='contentheading'>{$blck->title}</div>";
						$block->text.= $blck->text;
						if (!empty($blck->viewMoreLink))
						$block->text .= $blck->viewMoreLink.'<br />';

					}
					break;
			}


			$block->title = JText::_("User Resources");
			$block->description = $description;
			$block->name = $blockName;

			return $block;
		}

		/**
		 * Generic onProfileMenu for community-resource integration plugins.
		 * @param $user JUser The owner of current profile
		 * @param $pluginName string The name of plugin
		 * @param $pluginType string Plugin type
		 * @param $viewWhat string Resource view_what parameter
		 * @param $params array configuration array
		 *
		 * @return unknown_type
		 */
		function onProfileMenu($user, $pluginName, $pluginType, $viewWhat, $params)
		{
			$me = & JFactory::getUser();
			
			$name = $this->getPluginName($pluginName, $pluginType);

			$menu = new stdClass;

			$menu->title = JText::_($name);
			$menu->menuItems = array();

			$sectionParams = $this->convertParams($params);

			foreach ($sectionParams as $k => $v) {
				// skip hidden blocks
				if ($v['show_menu'] != 'Yes')
					continue;

				$menuItem = new stdClass;

				$menuItem->link = MEUrl::link_list($k, array('view-what'=>$viewWhat, 'user_id'=>$user->get('id')));
				$menuItem->alt 	= $v['title'];
				$menuItem->icon = JURI::root()."plugins/community/icons/".$this->_getIconByViewWhat($viewWhat);

				$menu->menuItems [] = $menuItem;
			}

			if (count($menu->menuItems))
				return $menu;
			return null;
		}
		
		function getPluginName($pluginName, $pluginType)
		{
			if (empty($this->pluginData))
			{	
				$this->pluginData = array();
				
				if (empty($this->pluginData[$pluginType]))
				{
					$this->pluginData[$pluginType] = array();
					$db = & JFactory::getDBO();
				
					$db->setQuery('SELECT name, element FROM #__plugins WHERE folder = '.$db->Quote($pluginType));
					$names = $db->loadObjectList();
					
					foreach ($names as $name) {
						$this->pluginData[$pluginType][ $name->element ] = $name->name;
					}
				}
			}
			
			if (!empty($this->pluginData[$pluginType][$pluginName]))
				return $this->pluginData[$pluginType][$pluginName];
				
				
			return null;
		}


		function getUserItems($user, $view_what, $sectionId, $limit , $blockTitle, $clients = 'No')
		{
			global $mainframe;
			jimport ('joomla.utilities.date');

			require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'view.html.php');
			require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
			require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'helper.php');
			$document = &JFactory::getDocument();
			$db 	  = &JFactory::getDBO();
			$document->addScript( JURI::root().'components/com_resource/helpers/script.js' );
			$document->addScript( JURI::root().'/components/com_resource/helpers/felixrating.js' );
			$me = &JFactory::getUser();
			
			$this->_initResourceConfig();
			
			JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');

			$model = &JModel::getInstance('List','ResModel');
			$view  = new ResViewList();

			$limit = (int)$limit;
			if ($limit <= 0)
				$limit = 99999;

			$mainframe->setUserState('com_resource.filter_order_Dir', 'DESC');
			$model->setState('limit', $limit);
			$params = new JParameter('');
			$get_view = JRequest::getVar('view');
			$params->set('view_what', $view_what);
			//$params->set('ratingtmpl', 'default');
			$params->set('client', 'module');
			//JRequest::setVar('artdet_client', 'module');
			//JRequest::setVar('artdet_params',$params );
			$oldClient 	= JRequest::setVar('client', 'resource');
			$oldView 	= JRequest::setVar('view', 'list');
			

			$document	= &JFactory::getDocument();
			$uri 		= &JFactory::getURI();
			$pathway	= &$mainframe->getPathway();
			$itemid		= JRequest::getInt('Itemid');

			$params->set('section_id', $sectionId);
			$sparams	= ResHelper::initListParams($params->get('section_id'));
			$sparams->set('list_clients', ($clients == 'No' ? 0 : 1));
			
			$params->merge($sparams);
			
			//echo $params->get('list_clients');
			
			$document->addScript(JURI::root().'includes/js/joomla.javascript.js');

			$filter_order_Dir_varName = 'filter_order_dir'.$itemid;
			$model->setState($filter_order_Dir_varName, 'DESC');
			
			$items = $model->getUserData($user->get('id'), $params);
			
			if (count($items)<1)
			{
				if ($oldClient)
					JRequest::setVar('client', $oldClient);
				if ($oldView)
					JRequest::setVar('view', $oldView);
				return;
			}

			//JRequest::setVar('Itemid', $theItemid);

			$category = $model->getCategory($params->get('section_id', $sectionId));
			$section = $model->getCategory($sectionId);
			$params->set("generate_user_menu", 0);
			$view->prepareItems($items, $params, $category);

			if ($view_what == 'favorites')
			{
				$ids = array();
				for($i = 0, $c = count($items); $i < $c; $i++)
				{
					$ids [] = $items[ $i ]->id;
				}
				
				$sql = "SELECT record_id, COUNT(*) AS total FROM #__js_res_favorite WHERE `record_id` IN (".implode(', ', $ids).') GROUP BY `record_id`';
				$db->setQuery($sql);
				$favorites = $db->loadObjectList('record_id');
				
				
				for($i = 0, $c = count($items); $i < $c; $i++)
				{
					$id = $items[ $i ]->id;
					$items[$i]->total_favourites = empty($favorites[$id]) ? 0 : $favorites[$id];
				}

			}



			$columns = array();
			$nfields = array();
			$ifields = array();
			$cols = array();
			$cols_additional = array();;
			foreach ($items AS $key => $item)
			{
				$fields[$item->id] = $model->getFields($item->id);
				$nfields[$item->id] = array();
				
				if(is_array($fields[$item->id]))
				{
					foreach ($fields[$item->id] AS $k => $field)
					{
						$columns[$field->ordering]['title'] = $field->title;
						$columns[$field->ordering]['id'] = $field->fid;

						$columns[$field->ordering]['params'] = new JParameter( $field->params );

						$get = false;
						$field_params = new JParameter($field->params);
						$dispatcher =& JDispatcher::getInstance();
						JPluginHelper::importPlugin( 'joomsuite_content_fields', $field->type );
						$dispatcher->trigger( 'onRenderFieldValue', array (&$get, & $field, $field_params, $field->type, $item->user_id ) );
						if($get)
						{
							if(!$model->_fieldSubscriptionAccess($get, $field_params))
							{
								$model->_fieldGroupAccess($get, $field_params);
							}
							if($get)
							{
								$ifields[$key][$field->title] = $get;
								$ifields[$key][$field->fid] = $get;

							}

						}
						$nfields[$item->id][$field->fid] = $field;
						$nfields[$item->id][$field->fid]->result = $get;
						//					if($get) $ifields[$key][$field->title] = $get;
					}
				}
			}
			$fields = $nfields;
			if(count($columns) > 0)
			{
				ksort($columns);
				foreach ($columns AS $sort => $data)
				{
					$cols[$data['title']] = $data['id'];
					$cols_additional[$data['title']]['params'] = $data['params'];
				}
			}
			$array = array("rated", "favorites", "commented", "last-visited", "created", 'user_category');

			if(!in_array($params->get('view_what'),$array))
			{
				JError::raiseWarning(404, JText::_('Cannot find records, view_what parameter is not correct'));
				$mainframe->redirect(JURI::root());
			}

			$contents = new StdClass();
			$contents->title = JText::_($blockTitle);

			$tpl_array = explode(",", $params->get('tmpl_list'));
			$params->set('tmpl_list', $tpl_array[0]);
			$tmpl_ini = JFile::read(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.ini');
			$tmpl_xml = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.xml';
			$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
			$params->merge($tmpl_params);

			//include_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'view.html.php';
			//ResViewList::prepareItems($items, $params, $category);

			$this->params = $params;
			$this->cols = $cols;
			$this->fields = $fields;
			$this->ifields = $ifields;
			$this->items = $items;
			$this->section = $section;
			$this->category = $category;
			$this->cols_additional = $cols_additional;
			$this->user = $me;
			
			ob_start();
			include JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$params->get('tmpl_list').'.php';
			$contents->text = ob_get_contents();
			ob_end_clean();
			
			JRequest::setVar('client', 	$oldClient);
			JRequest::setVar('view', 	$oldView);
			return $contents;
		}
		
		function getFieldValue($field, $user)
		{
			$model = &JModel::getInstance('List','ResModel');
			return $model->getFieldValue($field, $user);

		}

		/**
		 * Fetches name and id of the sections = the categories with no parents.
		 * @return array
		 */
		function &getSectionData() {
			if ($this->sectionData == null) {
				$db = & JFactory::getDBO();
				$db->setQuery('SELECT id, name, icon FROM `#__js_res_category` WHERE published = 1 AND section_id = 0');

				$this->sectionData = $db->loadObjectList('id');
			}
			return $this->sectionData;
		}

		/**
		 * Private categories
		 * @var array
		 */
		var  $_pcat = array();


		/**
		 * Fetches the private categories.
		 *
		 * @param $userId UserID of the owner of private categories
		 * @param $sectionIds Section ids, where to look for private categories
		 * @return mixed
		 */
		function &getPrivateCategories($userId, $sectionIds, $order = '')
		{
			JArrayHelper::toInteger($sectionIds);
			$sectionIds = array_unique($sectionIds);

			// Signature.
			$signature = $userId .':'.implode('_', $sectionIds).$order;

			if (empty($this->_pcat[ $signature ]))
			{
				$query = 'SELECT c.id, c.section_id, c.name as title, c.icon, count(r.ucatid) AS nums, c.client, c.client_id '.
					' FROM #__js_res_category_user AS c ' .
					' LEFT JOIN #__js_res_record AS r ON r.ucatid = c.id ' .
					' WHERE '.
					' c.section_id IN ('. implode(', ', $sectionIds). ') '.
					' AND c.published = 1 AND c.user_id = '.(int)$userId. ' '.
					' GROUP BY c.id '.
					' HAVING COUNT(r.id) > 0 '.
					'ORDER BY '.
				(!(empty($order)) ? $order : ' c.ordering ')
				;

				$db = & JFactory::getDBO();

				$db->setQuery( $query );

				$this->_pcat[ $signature ] = $db->loadObjectList();
			}

			return $this->_pcat[ $signature ];
		}

		/**
		 * Initializes com_resource settings
		 * @return void
		 */
		function _initResourceConfig() {
			static $isInitialized = 0;

			if (!$isInitialized)
			{
				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
				ResControllerConfig::initialyze();

				require_once JPATH_PLUGINS.DS.'community'.DS.'elements'.DS.'sectiontemplate.php';

				$isInitialized = 1;
			}
		}

		/**
		 * Converts one-dimensional array to 2D array, where the keys are section ids.
		 * Use with jsresblockparam2 element data
		 *
		 * @param $value array The array to be converted.
		 * @param $varCount int the size of a configuration row in jsresblockparam2 element
		 * @return array
		 */
		function convertParams($value, $varCount = 9)
		{
			if ($varCount == 9)
				$names = array('title', 'show_blocks', 'limit', 'order', 'itemid', 'show_menu', 'view_more', 'show_clients');
			else
				$names = array('title', 'show_blocks', 'limit', 'order', 'itemid', 'template');
			
			$ret = array();
			//print_r($value);
			$i = 0;
			$count = count($value);
			while ($i < $count) {
				@$ret[$value[ $i ]] = array();
				for ($j = $i + 1; $j < $i + $varCount; $j++)
				@$ret[$value[ $i ]][$names[$j - $i - 1]] = $value[ $j ];

				@$ret[$value[ $i ]]['id'] = (int)$value[ $i ];
				$i += $varCount;
			}
			
			//print_r($ret);

			return $ret;
		}

		function cleanArray($array)
		{
			$ret = array();
			foreach ($array as $val)
			{
				if (empty($val))
				{
					continue;
				}
				else
				{
					$ret[] = $val;
				}

			}
			return $ret;
		}

		/**
		 * Returns appropriate icon name for $viewWhat parameter.
		 * @param $viewWhat string What to show [tags, created, visited, etc..]
		 * @return string icon name
		 */
		function _getIconByViewWhat($viewWhat) {
			switch (strtolower($viewWhat)) {
				case 'created':
					return 'created.png';
				case 'favourites':
					return 'favorites.png';
				case 'rated':
					return 'ratings.png';
				case 'commented':
					return 'comments.png';
				case 'last-visited':
					return 'visited.png';
				case 'tags':
					return 'tags.png';
			}

			return 'created.png';
		}

		/**
		 * Sort helper callback function
		 * @param $a
		 * @param $b
		 * @return unknown_type
		 */
		function _sortParamsFunc($a, $b) {
			return (int)$a['order'] - (int)$b['order'];
		}
	}

}
?>