<?php
/**
 * $Id: group.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 
jimport('joomla.application.component.model');
class CommunityModelGroup extends JModel
{

	var $_id = 0;
	var $_activity = null;

	function __construct()
	{
		parent::__construct();
		$this->setId();
		global $mainframe, $option;
	}

	function setId($id = null)
	{
		if ($id == null)
		{
			$this->_id = JRequest::getInt('id', 0);
		}
		else
		{
			$this->_id = $id;
		}
	}
	function getSections($sections)
	{
		If(!JFile::exists(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'config.ini'))
		{
			return array();
		}
		require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php';
		settype($sections, 'array');
		$sec_params = unserialize(COMMUNITY_GROUPS_SECTIONS);
		$group = &JTable::getInstance('Groups', 'CommunityTable');
		$group->load($this->_id);
		$m=''; $o='';
		
		if (count($sections) && is_array($sections))
		{
			$helper = new CommunityHelperResource();
			$catid 	= JRequest::getVar('category_id');
			$view 	= JRequest::getVar('view');
			
			foreach ($sections as $section)
			{
				//echo $sec_params[$section];
				if(@$sec_params[$section]['enable'])
				{
					$out[$section] = $sec_params[$section];
					$params = ResHelper::initListParams($section);
					$options = array(
						'category' => $section,
						'limit' => $sec_params[$section]['limit'],
						'records_mode' => 2,
						'client' => 'module',
//						'list_clients' => 0,
						'group_id' => $group->id,
						'group_name' => $group->title
					);
					$items = MightyResourcesApi::getRecordList($options, array(), array(), $m, $o);
					
					//$out[$section]['text'] = $helper->getGroupItems($group->id, $group->title,  $section, $sec_params[$section]['limit']);
					$out[$section]['text'] = $items[1];
					$out[$section]['client'] = $group->title;
					
					$type = explode(',',$params->get('type'));
					$out[$section]['types'] = $type;
				}
			}
			
			JRequest::setVar('category_id', $catid);
			JRequest::setVar('view', $view);
		}
		return @$out;
	}

	function &getData()
	{
		$table = &JTable::getInstance('Groups', 'CommunityTable');
		if ($this->_id == 0)
		{
			return $table;
		}
		else
		{
			$table->load($this->_id);
		}
		$this->_db->setQuery("SELECT `title` FROM #__community_group_categories WHERE `id` = {$table->catid}");
		$table->category = $this->_db->loadResult();
		return $table;
	}

	function getCategories()
	{
		$user = &JFactory::getUser();
		$aid = (int)$user->get('aid', 0);
		$availableCategories = CommunityHelperGroups::getCategoriesToCreateGroup($user);
		if(!count($availableCategories)){return array();}
		$sql = "SELECT * FROM #__community_group_categories "
		."\n WHERE id IN (".implode(" , ",$availableCategories).") ORDER BY `ordering`";
		
		$this->_db->setQuery($sql);
		$categories = $this->_db->loadObjectList();
		return $categories;
	}

	function save($data = array())
	{
		$table = &JTable::getInstance('Groups', "CommunityTable");
		$user = &JFactory::getUser();
		$remove_icon = 0;
		$oldName = "";
		if ($data['id']>0)
		{
			$table->load($data['id']);
			$oldName = $table->get('title');
			$remove_icon = (int)@$data['remove_icon'];
			unset($data['remove_icon']);
			if ($oldName != $data['title'])
			{
				$oldName = $this->_db->getEscaped($oldName);
				$newName = $this->_db->getEscaped(stripslashes($data['title']));
				$sql = "UPDATE #__js_res_record SET `client` = '{$newName}' WHERE `client` = '{$oldName}'";
				$this->_db->setQuery($sql);
				$this->_db->query();
			}
		}
		else
		{
			$data['num_users'] = 1;
			$table->user_id = $user->get('id');
		}

		if ($remove_icon && trim($table->icon)!='')
		{
			//			/JFile::delete(JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.'groups'.DS.'icons'.DS.$table->icon);
			JFile::delete(JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.'groups'.DS.'thumb'.DS.$table->icon);
			$table->icon = "";
		}
		//$data['title'] = $this->_db->getEscaped($data['title']);
		$table->bind($data);
		$table->store();
		return $table->id;


	}
	function getActivity()
	{
		if(empty($this->_activity))
		{
			$hModel = &JModel::getInstance('History', 'CommunityModel');
			$this->_activity = $hModel->getGroupActivity($this->_id);
			
		}
		return $this->_activity;

	}



	function changePublish($state,$groupId)
	{
		$user = &JFactory::getUser();
		$gid = $user->get('gid');
		$table = &JTable::getInstance('Groups', "CommunityTable");
		$table->load($groupId);
		if (($table->get('user_id') == $user->get('id'))  || ($gid == 24 || $gid == 25))
		{
			$table->published = (int)$state;
		}
		else
		{
			JError::raiseNotice(400, JText::_('You do not have permission to edit this group.'));
			return false;
		}
		return $table->store();
	}

	

	
	


	function remove($id)
	{
		$id = (int)$id;
		$sql ="DELETE FROM #__community_communities WHERE id = {$id}";
		$this->_db->setQuery($sql);
		$this->_db->query();
		$sql = "DELETE FROM #__community_user_mapping WHERE group_id = {$id}";
		$this->_db->setQuery($sql);
		$this->_db->query();
		return true;
	}



}
?>
