<?php
/**
 * $Id: groupmembers.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 
jimport('joomla.application.component.model');
class CommunityModelGroupMembers extends JModel
{

	var $_id = 0;
	var $_data = null;
	var $_total = null;
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();
		global $mainframe, $option;

		// Get the pagination request variables
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		$this->setId();
	}

	function setId($id = null)
	{
		if ($id == null)
		{
			$this->_id = JRequest::getInt('id', 0);

		}
		else
		{
			$this->_id = $id;
		}
	}
	function &getData()
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = @$this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));

		}
		return $this->_data;
	}
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;

	}


	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = @$this->_getListCount($query);
		}

		return $this->_total;
	}

	function _buildQuery()
	{
		$order = $this->_buldOrderBy();
		$where = $this->_buildWhere();
		$sql = "SELECT u.*, um.pending, um.message, um.ctime as join_date,   um.access_type, um.user_block  FROM #__community_user_mapping AS um
				\n LEFT JOIN #__users AS u ON um.user_id = u.id
				\n WHERE 1 AND um.group_id = {$this->_id} ".$where
		.$order
		;

		return $sql;
	}

	function _buldOrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.groupmembers.filter_order',		'filter_order',		'um.ctime',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.groupmembers.filter_order_Dir',	'filter_order_Dir',	'DESC',			'word' );

		if ($filter_order){
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';
		}
		return $orderby;

	}

	function _buildWhere()
	{
		$user = JFactory::getUser();
		$aid = $user->get('gid');
		$where= array();
		$search = JRequest::getVar('search', '');
		if ($search != '')
		{
			$where[] = ' u.username LIKE "%'.$this->_db->getEscaped($search).'%"';
		}
		if (count($where))
		{
			$where= implode(' AND ', $where);
			return " AND ".$where;
		}
		return '';
	}
	/**
	 * returns an array of current active groups
	 *
	 * @param int $uid
	 */
	function getActiveGroupsArray($uid )
	{
		$uid = (int)$uid;
		$sql = "SELECT comm.id FROM #__community_communities AS comm"
		."\n LEFT JOIN #__community_user_mapping AS comm_map ON comm_map.group_id = comm.id AND comm_map.pending = 0 AND comm_map.user_block = 0 "
		."\n WHERE comm_map.user_id = $uid OR comm.user_id = $uid GROUP BY comm.id";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadResultArray();
		return $result;
	}






	/*CHECK MEMBERSHIP FUNCTIONS HERE*/

	function isGroupMember($group_id, $user_id, $include_blocked = true, $include_pending = false)
	{
		$str= "";
		$pending = " AND `pending` = 0 ";
		if (!$include_blocked)
		{
			$str = " AND `user_block` = 0 ";
		}
		if ($include_pending)
		{
			$pending.= "";
		}
		$sql = "SELECT COUNT(*) FROM #__community_user_mapping WHERE `user_id` = {$user_id} AND `group_id` = {$group_id}  ".$str.$pending;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();

	}


	function isGroupMemberFriend($group_id, $group_creator, $user_id)
	{
	    $group_membersIds = $this->getGroupMembers($group_id, 'all', false, null, true);
	    array_push($group_membersIds,$group_creator);
	    
	    $profileModel  = &JModel::getInstance('Profile', 'CommunityModel');
	    $friendsIds = $profileModel->getAllFriends($user_id);
	    
		return count(array_intersect($group_membersIds,$friendsIds));
	}


	function removeMember($group_id, $user_id)
	{
		$sql = "DELETE FROM #__community_user_mapping WHERE `group_id` = {$group_id} AND `user_id` = {$user_id}";
		$this->_db->setQuery($sql);
		$this->_db->query();
		$sql = "UPDATE #__community_communities SET `num_users` = `num_users` - 1 WHERE `id` = {$group_id}";
		$this->_db->setQuery($sql);
		$this->_db->query();
	}
	
	
	
	
	
	function isPending($group_id, $user_id)
	{
		$sql = "SELECT COUNT(*) FROM #__community_user_mapping WHERE `user_id` = {$user_id} AND `group_id` = {$group_id} AND `pending` = 1 ";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();

	}
	

	function isGroupModerator($group_id, $user_id, $include_blocked = true)
	{
		$str= "";
		if (!$include_blocked)
		{
			$str = " AND `user_block` = 0 ";
		}
		$sql = "SELECT COUNT(*) FROM #__community_user_mapping WHERE "
		."\n `user_id` = {$user_id} AND `group_id` = {$group_id} AND `access_type` = 1 AND pending = 0 ".$str;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();

	}

	function isCreator($group_id, $user_id)
	{
		$this->_db->setQuery("SELECT COUNT(*) FROM #__community_communities WHERE `user_id` = {$user_id} AND `id` = {$group_id}");
		return $this->_db->loadResult();
	}

	function isUserBlocked($group_id, $user_id)
	{
		$sql = "SELECT COUNT(*) FROM #__community_user_mapping WHERE `user_id` = {$user_id} AND `group_id` = {$group_id} AND user_block = 1";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}





	function getGroupMembers($group_id, $type = "all", $include_blocked = true, $limit = null, $onlyIds = false)
	{
		$blocked = "";
		$limitStr = "";
		if ($limit > 0)
		{
			$limitStr = " LIMIT $limit";

		}
		if (!$include_blocked)
		{
			$blocked = " AND um.user_block = 0 ";
		}
		if($onlyIds){
		    $select = "u.id"; 
		}else{
		    $select = "u.*, um.pending, um.message, um.ctime as join_date, um.access_type, um.user_block";
		}
		$groupBy = " GROUP BY (u.id) ";
		$sql = '';
		switch($type)
		{

			case 'moderators':
				$sql = "SELECT {$select}  FROM #__community_user_mapping AS um
				\n LEFT JOIN #__users AS u ON um.user_id = u.id
				\n WHERE um.group_id = {$group_id} AND um.access_type = 1 AND um.pending = 0 ".$blocked.$groupBy.$limitStr;
				break;
			case 'members':
				$sql = "SELECT {$select}  FROM #__community_user_mapping AS um
				\n LEFT JOIN #__users AS u ON um.user_id = u.id
				\n WHERE um.group_id = {$group_id} AND um.access_type = 0 AND um.pending = 0 ".$blocked.$groupBy.$limitStr;
				break;
			default:
			case 'all':
				$sql = "SELECT {$select}  FROM #__community_user_mapping AS um
				\n LEFT JOIN #__users AS u ON um.user_id = u.id
				\n WHERE um.group_id = {$group_id } AND um.pending = 0 ".$blocked.$groupBy.$limitStr;
				break;

		}

		$this->_db->setQuery($sql);
		if($onlyIds)
		    return $this->_db->loadResultArray();
		else
		    return $this->_db->loadObjectList();
	}


	function joinGroupDirectly($group_id, $user_id)
	{
		//first we need to check if this user has made a request before;
		$sql = "SELECT * FROM #__community_user_mapping WHERE `group_id` = {$group_id} AND `user_id` = {$user_id}";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadObjectList();
		if (count($result))
		{
			$result = $result[0];

			if ($result->user_block == 1)
			{
				JError::raiseWarning(100, JText::_("You are blocked in this group."));
				return false;
			}
			if ($result->pending == 1)
			{
				JError::raiseNotice(100, JText::_("You have already made a request to join this group"));
				return false;
			}
		}
		else
		{
			$sql = "INSERT INTO #__community_user_mapping (`user_id`, `group_id`, `user_block`, `ctime`, `access_type`, `pending`, `message`)"
			."\n VALUES({$user_id}, {$group_id}, 0, NOW(), 0, 0, '' )";
			$this->_db->setQuery($sql);
			$this->_db->query();
			$sql = "UPDATE #__community_communities SET `num_users` = `num_users` + 1 WHERE `id` = {$group_id} ";
			$this->_db->setQuery($sql);
			$this->_db->query();
			return true;
		}
	}

	function sendRequest($group_id, $user_id, $message = '')
	{
		$sql = "SELECT * FROM #__community_user_mapping WHERE `group_id` = {$group_id} AND `user_id` = {$user_id}";
		$this->_db->setQuery($sql);

		$result = $this->_db->loadObject();
		if ($result)
		{
			if ($result->user_block)
			{
				JError::raiseWarning(403, JText::_('You are blocked in this group'));
				return FALSE;
			}
			return TRUE;
		}

		$message = $this->_db->getEscaped($message);
		$sql = "INSERT INTO #__community_user_mapping (`user_id`, `group_id`, `user_block`, `ctime`, `access_type`, `pending`, `message`)"
		."\n VALUES({$user_id}, {$group_id}, 0, NOW(), 0, 1, '{$message}' )";
		$this->_db->setQuery($sql);
		$this->_db->query();
		return TRUE;
	}

	
	


}
?>