<?php
/**
 * $Id: groups.php 7352 2011-09-22 14:03:49Z kostya $
 * $LastChangedDate: 2011-09-22 20:03:49 +0600 (Thu, 22 Sep 2011) $
 * $LastChangedBy: kostya $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 
jimport('joomla.application.component.model');
class CommunityModelGroups extends JModel
{

	var $_id = 0;
	var $_categories = null;
	var $_coreGroups = null;
	var $_ownGroups = null;
	var $_modGroups = null;
	var $_memGroups = null;
	var $_groups = null;
	var $_catid = null;
	var $_total = null;
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();
		$this->setCategory();
		global $mainframe, $option;

		// Get the pagination request variables
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	

	function setCategory($catid=null)
	{
		if (empty($catid))
		{
			$this->_catid = JRequest::getInt('category_id', 0);
		}
		else
		{
			$this->_catid = $catid;
		}

	}

	function &getCategoriesList()
	{
		if (empty($this->_categories))
		{
			$user = &JFactory::getUser();
			$aid = $user->get('aid', 0);
			$sql = "SELECT * FROM #__community_group_categories"
			."\n WHERE `published` = 1 AND `access` <= {$aid} "
			."\n ORDER BY `ordering` ";
			$this->_db->setQuery($sql);
			$this->_categories = $this->_db->loadObjectList();
			for($i = 0; $i<count($this->_categories); $i++)
			{
				$row = &$this->_categories[$i];
				$published = "";
				if ($aid == 2)
				{
					$published = "";
				}
				else
				{
					$published = " AND (`published` = 1 OR `user_id` = {$user->id}) ";
				}
				$sql = "SELECT COUNT(*) FROM #__community_communities WHERE 1 {$published} AND `catid` = {$row->id}";
				$this->_db->setQuery($sql);
				$row->numGroups = $this->_db->loadResult();
			}

		}

		return $this->_categories;
	}

	function &getCoreGroups()
	{
		$user = &JFactory::getUser();

		if (empty($this->_coreGroups))
		{

			$aid = $user->get('aid');
			if ($aid == 0 || $aid == 1)
			{
				$sql = "SELECT cc.*, u.username AS username, u.name AS name FROM #__community_communities AS cc"
				."\n LEFT JOIN #__users AS u ON cc.user_id = u.id "
				."\nWHERE `is_core` = 1 AND published = 1 ";
			}
			else if ($aid > 1)
			{
				$sql = "SELECT cc.*, u.username AS username, u.name AS name FROM #__community_communities AS cc"
				."\n LEFT JOIN #__users AS u ON cc.user_id = u.id "
				."\nWHERE `is_core` = 1 ";
			}

			$this->_db->setQuery($sql);
			$groups = $this->_db->loadObjectList();
			for($i = 0; $i<count($this->_coreGroups);$i++)
			{
				$row = &$this->_coreGroups[$i];
				$row->params = new JParameter($row->params);
			}

			$this->_coreGroups = &$groups;
		}

		return $this->_coreGroups;
	}
    function &getOwnGroups()
	{
		$user = &JFactory::getUser();

		if (empty($this->_ownGroups))
		{
			$sql = "SELECT cc.*, u.username AS username, u.name AS name FROM #__community_communities AS cc"
			."\n LEFT JOIN #__users AS u ON cc.user_id = u.id "
			."\nWHERE cc.`user_id` = ".$user->get('id')." AND cc.published = 1 ";
			
			$this->_db->setQuery($sql);
			$this->_ownGroups = $this->_db->loadObjectList();
			
			for($i = 0; $i<count($this->_ownGroups); $i++)
			{
				$row = &$this->_ownGroups[$i];
				$row->params = new JParameter($row->params);
			}
		}
		return $this->_ownGroups;
	}
   
	function &getMemGroups()
	{
		$user = &JFactory::getUser();

		if (empty($this->_memGroups))
		{
			$sql = "SELECT cc.* , u.username AS username, u.name AS name 
			FROM #__community_communities AS cc"
			."\n LEFT JOIN #__community_user_mapping AS um ON um.group_id = cc.id "
			."\n LEFT JOIN #__users AS u ON cc.user_id = u.id "
			."\nWHERE um.`user_id` = ".$user->get('id')." AND um.access_type = 0 AND cc.published = 1 GROUP BY cc.id";
			
			$this->_db->setQuery($sql);
			$this->_memGroups = $this->_db->loadObjectList();
			
			for($i = 0; $i<count($this->_memGroups); $i++)
			{
				$row = &$this->_memGroups[$i];
				$row->params = new JParameter($row->params);
			}
		}
		return $this->_memGroups;
	}
	
	function &getModGroups()
	{
		$user = &JFactory::getUser();

		if (empty($this->_modGroups))
		{
			$sql = "SELECT cc.* , u.username AS username, u.name AS name 
			FROM #__community_communities AS cc"
			."\n LEFT JOIN #__community_user_mapping AS um ON um.group_id = cc.id "
			."\n LEFT JOIN #__users AS u ON cc.user_id = u.id "
			."\nWHERE um.`user_id` = ".$user->get('id')." AND um.access_type = 1  AND cc.published = 1 GROUP BY cc.id";
			
			$this->_db->setQuery($sql);
			$this->_modGroups = $this->_db->loadObjectList();
			
			for($i = 0; $i<count($this->_modGroups); $i++)
			{
				$row = &$this->_modGroups[$i];
				$row->params = new JParameter($row->params);
			}
		}
		return $this->_modGroups;
	}
	
	function getCurrentCategory()
	{
		$sql = "SELECT * FROM #__community_group_categories WHERE id = {$this->_catid}";
		$this->_db->setQuery($sql);

		return $this->_db->loadObject();


	}

	function &getGroups()
	{
		if (empty($this->_groups))
		{
			$query = $this->_buildQuery();
			$this->_groups = @$this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));

		}
		return $this->_groups;

	}
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;

	}


	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = @$this->_getListCount($query);
		}

		return $this->_total;
	}

	function _buildQuery()
	{
		$order = $this->_buldOrderBy();
		//echo $order;
		$where = $this->_buildWhere();
		$sql = "SELECT a.*, u.username AS username, u.name AS name FROM #__community_communities AS a"
		."\n LEFT JOIN #__community_group_categories AS c ON c.id = a.catid "
		."\n LEFT JOIN #__users AS u ON a.user_id = u.id "
		."\n WHERE 1 AND ".$where
		.$order
		;
		//echo $sql;

		return $sql;
	}

	function _buldOrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.groups.filter_order',		'filter_order',		'a.ctime',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.groups.filter_order_Dir',	'filter_order_Dir',	'DESC',			'word' );

		//echo ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';
		
		if ($filter_order){
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';
		}
		return $orderby;

	}

	function _buildWhere()
	{
		global $mainframe, $option;
		$search	= $mainframe->getUserStateFromRequest( $option.'.groups.search','search','','string' );
		$user = JFactory::getUser();
		$aid = $user->get('gid');
		$where= array();
		if (!in_array($aid, array(23,24,25)))
		{
			$where [] = "(a.published = 1 OR (a.published = 0 AND a.user_id = {$user->id}))";
		}
		/*else
		 {

		 }*/
		if (strlen(trim($search)) > 3)
		{
			$escaped = $this->_db->getEscaped($search);
			$where[] = " a.title LIKE '%$escaped%' ";

		}
		else
		{
			$catid = JRequest::getInt('category_id', 0);
			$where[] = " c.id = {$catid}";
		}
		$where= implode(' AND ', $where);
		return $where;
	}

	function isGroupCreator($user_id , $group_id)
	{
		$sql = "SELECT COUNT(*) FROM #__community_communities WHERE `user_id` = {$user_id} AND `id` = {$group_id}";
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();

	}

	function getGroupsForInvite($cuid, $iuid)
	{
		$sql = "SELECT com.id as key1, com.*, cc.id as key2 FROM #__community_communities AS com"
		."\n INNER JOIN #__community_group_categories AS cc ON cc.id = com.catid"
		."\n LEFT JOIN #__community_user_mapping AS um ON um.group_id = com.id AND um.user_id != {$iuid}"
		."\n WHERE com.published = 1 AND (um.user_id = {$cuid} OR com.user_id = {$cuid}) AND com.user_id != {$iuid} GROUP by (com.id)";
		$this->_db->setQuery($sql);
		$groupsList = $this->_db->loadObjectList();
		$sql = "SELECT group_id FROM #__community_user_mapping WHERE user_id = {$iuid}";
		$this->_db->setQuery($sql);
		$userGroups = $this->_db->loadResultArray();

		for($i = 0; $i<count($groupsList); $i++)
		{
			if (in_array($groupsList[$i]->id, $userGroups))
			{
				unset($groupsList[$i]);
			}

		}
			
		return $groupsList ;

	}
}
?>


