<?php
/**
 * $Id: history.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class CommunityModelHistory extends JModel
{

	var $_data       = null;
	var $_pagination = null;
	var $_total      = null;
	var $_friends    = array();
	var $_types      = array();
	var $_view_what  = 'all';

	function __construct()
	{
		global $mainframe;
		parent::__construct();
		$params	=& $mainframe->getParams();
		$limit		  = $mainframe->getUserStateFromRequest('com_community.limit', 'limit', COMMUNITY_HISTORY_TOTAL_LIMIT, 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		$this->setState( 'limit',      $limit);
		$this->setState( 'limitstart', $limitstart );
		$this->_view_what = JRequest::getVar('view_what', $params->get('view_what', 'all'));

	}

	function &getData($limit = null)
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$limitstart = $this->getState('limitstart');
			if ($limit == null)
			{
				$limit = $this->getState('limit');
			}
			else
			{
				$limitstart = 0;
				$limit = intval($limit);
			}
			//echo $query;
				
			$this->_data = @$this->_getList($query,$limitstart ,$limit);
			$this->_data = $this->_addInfo($this->_data);
		}
		return $this->_data;
	}

	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = @$this->_getListCount($query);
		}

		return $this->_total;
	}

	function _buildQuery()
	{
		global $mainframe;
		static $sql = null;

		if($sql) return $sql;

		$id = JRequest::getInt("id", 0);
		$params	=& $mainframe->getParams();
		$user = & JFactory::getUser();
		$db = & JFactory::getDBO();
		$orderBy = $this->_orderBy();
		$where = $this->_buildWhere();
		$this->_view_what = JRequest::getVar('view_what', $params->get('view_what', 'all'));

		$sql = " SELECT a.* FROM  #__community_activity AS a WHERE 1 {$where} {$orderBy}";
		
		switch($this->_view_what)
		{
			case 'my-groups':
				if(!$id) { $id = $user->get('id'); }
				if(!$id)
				{
					JError::raiseWarning(500, JText::_('User id is not defined'));
					return 'SELECT a.* FROM  #__community_activity AS a WHERE `client` = \'123\''; //$sql;
				}
				$sql = "SELECT cc.id FROM #__community_communities AS cc"
						."\n LEFT JOIN #__community_user_mapping AS um ON um.group_id = cc.id "
						."\n LEFT JOIN #__users AS u ON cc.user_id = u.id "
						."\nWHERE (um.`user_id` = {$id} AND um.access_type = 0 AND cc.published = 1) OR cc.user_id = {$id}
						GROUP BY cc.id";

				$this->_db->setQuery($sql);
				$ids = $this->_db->loadResultArray();

				if(count($ids))
				{
					$cids = implode(",", $ids);
					$sql = " SELECT a.* FROM  #__community_activity AS a WHERE `client` = 'community' AND client_id IN({$cids}) {$where}  {$orderBy}";
				}
				else
				{
					return "SELECT * FROM #__community_activity AS a WHERE user_id = 1012457854";
				}
				break;
			case 'my':
				if(!$id) { $id = $user->get('id'); }
				if(!$id)
				{
					JError::raiseNotice(500, JText::_('User id is not defined'));
					return $sql;
				}
				$sql = " SELECT a.* FROM  #__community_activity AS a WHERE user_id = {$id} {$where}  {$orderBy}";
				
				
				break;
			case 'group':
				if(!$id)
				{
					JError::raiseNotice(500, JText::_('Group id is not defined'));
					return $sql;
				}
				$sql = " SELECT a.* FROM  #__community_activity AS a WHERE client_id = {$id} AND `client` = 'community' {$where}  {$orderBy}";
				
				break;
			case 'friends':
				if(!$id) { $id = $user->get('id'); }
				if(!$id)
				{
					JError::raiseNotice(500, JText::_('User id is not defined'));
					return $sql;
				}
				$sql2 = "SELECT friend_id FROM #__community_userrelations WHERE `user_id` = $id AND `status` = 1";
				$db->setQuery($sql2);
				$friends = $db->loadResultArray();
				if(!$friends)
				{
					return "SELECT * FROM #__community_activity AS a WHERE user_id = 1012457854";
				}
				$sql = "SELECT a.* FROM  #__community_activity AS a WHERE user_id IN (".implode(",", $friends).") {$where}  {$orderBy}";
				break;
		}
		
		return $sql;

	}

	function _buildWhere()
	{
		global $mainframe, $option;
		$where = array();

		$type = $mainframe->getUserStateFromRequest($option.'.history.activity_type', 'activity_type', JText::_('All Activity'), 'var');
		if ($type != '' && $type != JText::_('All Activity'))
		{
			$type = $this->_db->getEscaped($type);
			$where[] = " a.type = '{$type}'";
		}
		$client = JRequest::getVar('client');
		if($client && ($client == 'user' || $client == 'community'))
		{
			$where[] = " a.client = '{$client}' ";
		}

		if(count($where))
		{
			return " AND ". implode(" AND ", $where);
		}
		return '';
	}


	function _orderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.history.filter_order',		'filter_order',		'a.ctime',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.history.filter_order_Dir',	'filter_order_Dir',	'DESC',			'word' );

		if ($filter_order){
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';
		}
		return $orderby;

	}
	


	
	function getTypes()
	{
		$this->_types = array();
		$types = array();
		foreach($this->_data as $item)
		{
			if(!in_array($item->type,$types))
			{
				$types[] = $item->type;
			}
			
		}
		for($i = 0; $i < count($types); $i++)
		{
			$type = new stdClass();
			$type->type = $types[$i];
			$type->total = 0;
			foreach($this->_data  as $item)
			{
				if($type->type == $item->type )
				{
					$type->total++;
					$type->icon = $item->icon;
				}	
				
			}
			$this->_types[] = $type;
		}
		return $this->_types;
	}


	function &getPagination()
	{
		jimport('joomla.html.pagination');

		if (empty($this->_pagination))
		{
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function _addInfo($activity)
	{
		for ($i = 0; $i<count($activity); $i++)
		{
			$item = &$activity[$i];
			$user = JFactory::getUser($item->user_id);
			$item->username = $user->get('username');
			$item->name = $user->get('name');
		}
		return $activity;
	}


	function getGroupActivity($groupId)
	{
		$limit = (int)COMMUNITY_HISTORY_GROUP_LIMIT;

		$sql = "SELECT activ.*, comm.id AS group_id, comm.title FROM #__community_activity AS activ "
		."\n INNER JOIN #__community_communities  AS comm ON comm.id = activ.client_id AND activ.client = 'community'"
		."\n WHERE 1 AND comm.id = {$groupId}"
		."\n ORDER BY activ.ctime DESC LIMIT $limit";
		$this->_db->setQuery($sql);

		//echo $this->_db->_sql;

		$activity = $this->_db->loadObjectList();
		$activity = $this->_addInfo($activity);
		return $activity;

	}




	/**
	 * The plugins must have following properties
	 * ->date                - the date that something happened
	 * ->user_id             - user who did the action
	 * ->username            - User's Username
	 * ->action              - the string containing what happened
	 * ->url                 - url a link to go and see something
	 * ->urlLabel            - url lable
	 * ->icon                - some icon for that action

	 function renderData($data = array(), $limit = 10, $client)
	 {
		$actions = array();
		$counter = 0;
		if (count($data))
		{
		foreach ($data as $value)
		{
		if (!$data || $data == '')
		{
		continue;
		}
		if (is_array($value))
		{
		foreach ($value as $val)
		{
		$key = strtotime($val->date);
		$actions[$key] = $val;
		}

		}
		else if (is_object($value))
		{
		$key = strtotime($value->date);
		$actions[$key] = $value;
		}
		}
		}

		rsort($actions);

		$actions = array_slice($actions,  0 , $limit);
		$this->_total = count($actions);
		$limit2 = $this->getState('limit');
		if ( $limit2 ==  0)
		{
		$limit2 = $this->_total;
		}
		if ($client == 'profile')
		{
		$limit2 = COMMUNITY_HISTORY_PROFILE_LIMIT;

		}
		$return = array_slice($actions,  $this->getState('limitstart') , $limit2);
		return $return;
		}
		*/

	/*
	 function _loadConfigurations($userid)
	 {
		$ini = "";
		$path = str_replace('\\', '/', COMMUNITY_GENERAL_USERCONFIG.DS.$userid.'.ini');
		if (JFile::exists($path))
		{
		$ini = JFile::read($path);
		}
		return $ini;
		}
		*/
	/*
	 function getFriends($uid)
	 {
		$uid = intval($uid);
		if (count($this->_friends) < 1)
		{
		$sql = "SELECT * FROM #__community_userrelations WHERE user_id = {$uid} and status = 1";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadObjectList();
		foreach ($result as $val)
		{
		if ($val->user_id == $uid)
		{
		if (!in_array($val->friend_id,$this->_friends))
		{
		$this->_friends[] = $val->friend_id;
		}
		}
		if ($val->friend_id == $uid)
		{
		if (!in_array($val->user_id,$this->_friends))
		{
		$this->_friends[] = $val->user_id;
		}
		}
		}
		}
		return $this->_friends;


		}
		*/

}
?>