<?php
/**
 * $Id: list.php 7353 2011-09-23 04:53:08Z peter $
 * $LastChangedDate: 2011-09-23 10:53:08 +0600 (Fri, 23 Sep 2011) $
 * $LastChangedBy: peter $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 
jimport('joomla.application.component.model');
class CommunityModelList extends JModel
{

	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var $_listId = null;
	var $_customQuery = null;
	var $_fworn = false;

	function __construct()
	{
		parent::__construct();
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function &getData($listid = null, $params)
	{
		// Lets load the content if it doesn't already exist
		$this->_listId = $listid;
		if (empty($this->_data))
		{
			$query = $this->_buildQuery($params);
			
			$this->_data = @$this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
			for ($i = 0; $i < count($this->_data); $i ++)
			{
				$item = &$this->_data[$i];
				$sql = 'SELECT COUNT(s.userid)' . '   FROM #__session AS s' . '  WHERE s.userid = ' . $item->id;
				$this->_db->setQuery($sql);
				$item->loggedin = $this->_db->loadResult();
			}
		}
		return $this->_data;
	}

	function getTotal($params)
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery($params);
			$this->_total = @$this->_getListCount($query);
		}
		return $this->_total;
	}

	function getPagination($params)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal($params), $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_pagination;
	}

	function _buildQuery($params = null)
	{
		global $mainframe, $Itemid;
		
		if(is_object($params))
		{
			$s = $mainframe->getUserStateFromRequest('com_community.filter_search'.$Itemid, 'search_word', $params->get('custom_search', JText::_("--Text Search--")), 'string');
		}	
		if ($this->_listId > 0)
		{
			$sql = $this->getPredefinedUsers($this->_listId);
		}
		else
		{
			$where = $this->_buildWhere();
			$left_joines = $this->_buildLeftJoines();
			$orderBy = $this->_orderBy();
			$sql = "SELECT u.* FROM #__users AS u " 
				. "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = u.id" 
				. "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id" 
				. "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id" 
				.	$left_joines . " WHERE u.block = 0 " . $where . " GROUP BY (u.id) " . $orderBy;
		}
		return $sql;
	}

	function _orderBy($params = null)
	{
		global $mainframe, $option, $Itemid;
		$filter_order = $mainframe->getUserStateFromRequest($option . '.list.filter_order'.$Itemid, 'filter_order', 'u.registerDate', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option . '.list.filter_order_Dir'.$Itemid, 'filter_order_Dir', 'DESC', 'word');
		$orderby = '';
		if ($filter_order)
		{
			$orderby = ' ORDER BY ' . $filter_order . ' ' . $filter_order_Dir . ' ';
		}
		if(is_object($params)) 
			if ($params->get('custom_orderby')) 
				$orderby = ' ORDER BY ' . $params->get('custom_orderby');
		return $orderby;
	}

	function _buildLeftJoines()
	{
		$dispacher = &JDispatcher::getInstance();
		$leftjoines = $dispacher->trigger('onSqlJoin');
		$leftjoines = CommunityHelperGeneral::_cleanArray($leftjoines);
		return "\n " . implode("\n ", $leftjoines);
	}

	function _buildWhere()
	{
		$ids = JRequest::getVar('id', '');
		if (JRequest::getVar('task') == 'myfriends')
		{
			$ids = $this->_findFriendIds();
		}
		$where = '';
		$dispacher = &JDispatcher::getInstance();
		$subwhere = $dispacher->trigger('onSqlWhere');
		$subwhere = CommunityHelperGeneral::_cleanArray($subwhere);
		
		if ($ids != '')
		{
			$where .= " AND u.id in($ids) ";
		}
		$nw = array();
		foreach ($subwhere as $w)
		{
			if (! trim($w)) continue;
			$nw[] = $w;
		}
		if (count($nw))
		{
			$this->_fworn = true;
			$where .= ' AND (' . implode(" OR ", $subwhere) . ')';
		}
		//echo $where;
		return $where;
	}

	function _findFriendIds()
	{
		$friends = array();
		$user = JFactory::getUser();
		$user_id = 0;
		if (JRequest::getInt('user_id') > 0)
		{
			$user_id = JRequest::getInt('user_id');
		}
		else
		{
			$user_id = $user->id;
		}
		$sql = "SELECT `friend_id`  FROM #__community_userrelations " . "WHERE (`user_id` = {$user_id}) AND `status` <> 0";
		$this->_db->setQuery($sql);
		$friends = $this->_db->loadResultArray();
		if (count($friends))
		{
			return implode(' , ', $friends);
		}
		else
		{
			return 1;
		}
	}

	function findPendingFriends()
	{
		//$friends = array();
		$user = &JFactory::getUser();
		$user_id = 0;
		if (JRequest::getInt('user_id') > 0)
		{
			$user_id = JRequest::getInt('user_id', $user->get('id'));
		}
		if ($user_id != $user->get('id'))
		{
			return array();
		}
		$sql = "SELECT cu.id AS frdshp_id ,cu.user_id as id , cu.friend_id , cu.status, u.username, u2.username as friendname, cu.message "
    		. " FROM #__community_userrelations AS cu " 
    		. "INNER JOIN #__users AS u ON cu.user_id = u.id " 
    		. "INNER JOIN #__users AS u2 ON cu.friend_id = u2.id " 
    		. "WHERE ( (cu.friend_id = {$user->id} AND cu.user_id <> {$user->id}) OR (cu.friend_id <> {$user->id} AND cu.user_id = {$user->id}) ) AND `status` = 0";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadObjectList();
		if (count($result))
		{
			return $result;
		}
		else
		{
			return array();
		}
	}

	function getPredefinedUsers($listid)
	{
		global $mainframe, $option, $Itemid;
		$this->_db->setQuery("SELECT * FROM #__community_userlists WHERE `id` = " . (int) $listid);
		$list = $this->_db->loadObject();
		$to_set = JRequest::get('POST', 2);
		$params = new JParameter($list->params);
		$paramsArray = $params->toArray();
		foreach ($paramsArray as $key => $prm)
		{
			if (strpos($key, '['))
			{
				$arr = explode('[', str_replace("]", "", $key));
				if (! isset($to_set[$arr[0]][$arr[1]]))
				{
					$to_set[$arr[0]][$arr[1]] = $prm;
				}
			}
		}
		JRequest::set($to_set, "POST");
		$where = $this->_buildWhere();
		$left_joines = $this->_buildLeftJoines();
		$order = $params->get('order', 'u.registerDate');
		$order_Dir = $params->get('order_Dir', 'DESC');
		$mainframe->setUserState($option . '.list.filter_order'.$Itemid, $mainframe->getUserStateFromRequest($option . '.list.filter_order', 'filter_order', $order, 'cmd'));
		$mainframe->setUserState($option . '.list.filter_order_Dir'.$Itemid, $mainframe->getUserStateFromRequest($option . '.list.filter_order_Dir', 'filter_order_Dir', $order_Dir, 'word'));
		/*$option.'.list.filter_order',		'filter_order',		'u.registerDate',	'cmd' );
			$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.list.filter_order_Dir',*/
		if ($params->get('custom_join', '') != '')
		{
			$left_joines .= " \n " . $params->get('custom_join', '');
		}
		if ($params->get('custom_where') != '')
		{
			$where .= " \n " . $params->get('custom_where', '');
		}
		
		$loggedin = '(SELECT COUNT(s.userid)' . '   FROM #__session AS s' . '  WHERE s.userid = u.id)';
		$orderBy = $this->_orderBy($params);
		
		$this->_customQuery = "SELECT u.*,  " . $loggedin . " AS loggedin FROM #__users AS u " . "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = u.id" . "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id" . "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id" . //. "\n LEFT  JOIN #__community_userrelations AS ur ON (ur.user_id = u.id OR ur.friend_id = u.id) AND ur.status = 1 "
		$left_joines . " WHERE u.block = 0 " . $where . " GROUP BY u.id " . $orderBy;
		//		print "<pre>";
		//		print_r($orderBy);
		//		print "</pre>";
		return $this->_customQuery;
	}

	function getPredefinedList($listid)
	{
		if ($listid < 1)
		{
			return;
		}
		$this->_db->setQuery("SELECT * FROM #__community_userlists WHERE `id` = " . (int) $listid);
		$list = $this->_db->loadObject();
		$list->params = new JParameter($list->params);
		return $list;
	}
}
?>