<?php
/**
 * $Id: profile.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();
require_once(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'includes'.DS.'helper.php');

jimport('joomla.application.component.model');
class CommunityModelProfile extends JModel
{
	var $_id   = 0;
	var $_data = null;
	var $_isMe = false;
	var $_isFriend = null;
	var $_isHisFriend = null;

	function __construct()
	{
		parent::__construct();
		$this->_setId();
		$this->_initData();
	}

	function _setId()
	{
		$user = JFactory::getUser();
		$this->_id = JRequest::getInt('user_id', $user->id);
	}

	function _initData()
	{
		$user = JFactory::getUser();

		if ($user->get('id') == $this->_id)
		{
			$this->_data = clone($user);
			$this->_isMe = true;
		}
		else
		{
			$this->_data = JFactory::getUser($this->_id);
			$this->_isMe = false;
		}
	}

	function getData()
	{
		$user = &JFactory::getUser();
		$user->set('friends_pending', $this->getPendingFriends()) ;

		return $this->_data;
	}


	function getIsMe()
	{
		return $this->_isMe;
	}

	function getPendingFriends()
	{

		$user = &JFactory::getUser();
		$db = JFactory::getDBO();
		$sql = "SELECT COUNT(*) FROM #__community_userrelations "
		." WHERE (friend_id = {$user->id}) AND `user_id` <> {$user->id} AND `status` = 0 ";
		$db->setQuery($sql);
		return $db->loadResult();

	}

	/**
	 * Function to add Friends
	 *
	 * @param int $me ID of the currenty user
	 * @param int $friend ID of the person to add as a friend
	 */
	function addFriend($me, $friend, $message, $default_msg)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT COUNT(*) FROM #__community_userrelations "
		." WHERE (user_id = {$me} AND friend_id = $friend)";
		$db->setQuery($sql);
		$exists = $db->loadResult();
		
		$message = nl2br($message);
		if (!$exists)
		{
			$sql = "SELECT * FROM #__community_userrelations WHERE (`user_id` = {$friend} AND `friend_id` = $me)";
			$db->setQuery($sql);
			$duplicate = $db->loadObject();
			if ($duplicate)
			{
				$sql = "INSERT INTO #__community_userrelations (`user_id`, `friend_id`, `status`, `ctime`) VALUES ( $me , $friend, 1, NOW())";
				$db->setQuery($sql);
				$db->query();
				$sql = "UPDATE #__community_userrelations SET `status` = 1 WHERE `id` = ".(int)$duplicate->id;
				$db->setQuery($sql);
				$db->query();
			}
			else
			{
				$message = $db->getEscaped(str_replace(array("\r\n", "\n"), "", $message));
				$sql = "INSERT INTO #__community_userrelations (`user_id`, `friend_id`, `status`, `ctime`, `message`) VALUES ( $me , $friend, 0, NOW(), '$message')";
				$db->setQuery($sql);
				$db->query();
				$helper = $db->insertid();
				//registering event in the events list
				$text = CommunityHelperGeneral::getFriendAddedEvent($me, $friend, $message, $helper, $default_msg);
				JSCommunityApi::registerEvent(JText::_("Friendship Request"), $text, $friend, null, 0, 'com_community', 'CommunityController' );
			}
			return true;
		}
		return false;
	}

	function confirmFriendShip($frd_id, $type = 1)
	{
		$table = &$this->getTable('Userrelations');
		$table->load($frd_id);
		
		if ($type)
		{
			$table->status = 1;
			$table->store();
			
			$sql = "SELECT COUNT(*) FROM #__community_userrelations WHERE `user_id` = {$table->friend_id} AND `friend_id` = {$table->user_id}";
			$this->_db->setQuery($sql);
			$result = $this->_db->loadResult();

			if(!$result)
			{
				$addedUser = JFactory::getUSer($table->friend_id);
				$text = JText::sprintf("and %s are now friends", '<a href="'.JRoute::_("index.php?option=com_community&view=profile&user_id={$table->friend_id}&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID).'">'.$addedUser->username."</a>");
				if(COMMUNITY_REGISTER_START_FRIEND)
				{
					JSCommunityApi::registerActivity($table->user_id,$text , $table->user_id, 'components/com_community/images/addfriend.png','user', null, null, '', 'Friendship' );
				}
				
				$sql = "INSERT INTO #__community_userrelations (`user_id` , `friend_id`, `status`, `ctime`) VALUES ({$table->friend_id} , {$table->user_id}, 1, NOW())";
				$this->_db->setQuery($sql);
				$this->_db->query();
			}
			else
			{
				JError::raiseNotice(600, JText::_("This Person is already in you friends list"));
			}
			$text = CommunityHelperGeneral::getEventConfirmfFiendship($table->friend_id);
			$title = JText::_("Friendship Accepted");
		}
		else
		{
			$text = CommunityHelperGeneral::getEventRejectFriendship($table->friend_id);
			$title = JText::_("Friendship Rejected");
			$table->delete(); 
			//$sql = "UPDATE  #__community_userrelations SET `status` = 1 WHERE `id` = $frd_id";
			//$sql = "DELETE FROMT  #__community_userrelations WHERE `id` = $frd_id";
			//$this->_db->setQuery($sql);
			//$this->_db->query();
		}
		
		JSCommunityApi::registerEvent($title, $text, $table->user_id);
		
	}
	
	function isFriend($id)
	{
		$me = &JFactory::getUser();
		if ($me->id < 1)
		{
			return false;
		}
		if (empty($this->_isFriend))
		{

			$db = JFactory::getDBO();
			$sql = "SELECT COUNT(*) FROM #__community_userrelations "
			." WHERE (user_id = {$me->id} AND friend_id = $friend) ";
			$db->setQuery($sql);
			$this->_isFriend = (boolean)$db->loadResult();
		}
		return $this->_isFriend;
		
	}

	function isMyFriend($friend)
	{
		$me = &JFactory::getUser();
		if ($me->id < 1)
		{
			return false;
		}
		if (empty($this->_isFriend))
		{

			$db = JFactory::getDBO();
			$sql = "SELECT COUNT(*) FROM #__community_userrelations "
			." WHERE ((user_id = {$me->id} AND friend_id = {$friend}) OR (user_id = {$friend} AND friend_id = {$me->id})) AND status = 1";
			$db->setQuery($sql);
			$this->_isFriend = (boolean)$db->loadResult();
		}
		return $this->_isFriend;
	}

	function endFriendship($me, $friend)
	{
		if(!$me || !$friend) return;
		$sql = "DELETE FROM #__community_userrelations"
		." WHERE (user_id = {$me} AND friend_id = $friend) OR (user_id = {$friend} AND friend_id = {$me})";

		$this->_db->setQuery($sql);
		return $this->_db->query();
	}


	function getFriendPath($user_from, $user_to)
	{
		$friend_path = $this->findFriendPath($user_from, $user_to, COMMUNITY_FRIENDS_FRIEND_DEPTH,"|", "#__community_userrelations");
		//echo $friend_path;
		$fullArray = explode("|", $friend_path);
		$found = array();
		$tmp_array = array();
		$previous_element = array();
		$first_person = 0;
		// First pass to convert into array all the elements
		for ($i = 0; $i<count($fullArray); $i++ )
		{
			$tmp_array = explode( ",", $fullArray[$i]);
			$fullArray[$i] = $tmp_array;
		}
		$totalElements = count($fullArray);

		//Second pass to take out the friends
		/*print "<pre>";
		print_r($fullArray);
		print "</pre>";*/
		for ($i = 0; $i<count($fullArray); $i++ )
		{
			if ($i == 0) //first element of the array
			{
				foreach (@$fullArray[$i] as $element)
				{

					$found[] = $element;

				}
			}
			else //elements starting from the second element
			{
				foreach ($fullArray[$i] as $element)
				{
					if (((in_array($element, @$fullArray[$i-1])&& in_array($element, @$fullArray[$i]))	||
							(@in_array($element, @$fullArray[$i+1]) && in_array($element, @$fullArray[$i]))) &&
						!in_array($element, $found))
					{
						$found[] = $element;

					}
					else
					{
						continue;
					}
				}
				if ($i == $totalElements-1)
				{
					foreach ($fullArray[$totalElements-1] as $element)
					{
						if (!in_array($element,$found))
						{
							$found [] = $element;
						}
					}
				}
			}
		}
		/*print "<pre>";
		 print_r($found);
		 print "</pre>";*/
		return $found;
	}


	function findFriendPath( $user_from, $user_to, $levels = 7, $separator = "/", $table = "`#__felix_userrealations`" )
	{
		/*$table = "`#__felix_userrealations`";

		$user_from = JRequest::getInt('user_from', 1);
		$user_to   = JRequest::getInt('user_to',   4007);
		$levels    = JRequest::getInt('levels',    5);*/

		$sql = "";

		//$separator = "/";

		$select = "SELECT ";
		$select .= "if(u1.id, CONCAT( CONCAT(u.user_id,',',u.friend_id), '$separator', CONCAT(u1.user_id,',',u1.friend_id), [place_holder] ), null)";
		for( $i = 2; $i <= $levels; $i++ ) {
			$place_holder = ( $i == $levels ? "''": "[place_holder]" );
			$replacement = "if( u$i.id, CONCAT( '$separator', CONCAT(u$i.user_id,',',u$i.friend_id), if( u$i.user_id <> $user_to AND u$i.friend_id <> $user_to, $place_holder, '' ) ), '' )";
			$select = str_replace( '[place_holder]', $replacement, $select );
		}

		$sql .= $select."\n";
		$sql .= "FROM $table AS u\n";

		$left_joines = array();
		$last_ps = "";
		$left_join_exclusion = array();
		for( $i = 1; $i <= $levels; $i++ ) {
			$left_join_exclusion[] = "u$last_ps.id";
			$left_joines[] = "LEFT JOIN $table AS u$i ON (u$i.user_id = u$last_ps.friend_id OR u$i.friend_id = u$last_ps.user_id ) AND u$i.id NOT IN(".implode(", ",$left_join_exclusion).")";
			$last_ps = $i;
		}
		///OR u$i.user_id = u$last_ps.user_id  OR u$i.friend_id = u$last_ps.friend_id

		$sql .= implode( "\n", $left_joines )."\n";

		$where = "WHERE u.user_id = $user_from";

		for( $i = 1; $i <= $levels; $i++ ) {
			$w_OR[] = "u$i.user_id = $user_to";
			$w_OR[] = "u$i.friend_id = $user_to";
		}

		$where .= " AND (".implode( " OR ", $w_OR ).")";

		$sql .= $where."\n";

		$sql .= "GROUP BY u.user_id";
		//print '<pre>'.str_replace( "#__", "jos_", $sql ).'</pre>';
		$this->_db->setQuery($sql);
		$resultString = $this->_db->loadResult();
		return $resultString;
	}

	function addGuest($profile_id, $user_id)
	{
		if ($user_id == $profile_id)
		{
			return;

		}

		$sql = "SELECT COUNT(*) FROM #__community_guests WHERE `user_id` = {$profile_id} AND `guest_id` = ".$user_id;
		$this->_db->setQuery($sql);

		$result = $this->_db->loadResult();

		if ($result)
		{
			$sql = "UPDATE #__community_guests SET `ctime` = NOW(), `ip` = '".getenv("REMOTE_ADDR")."' WHERE `user_id` = {$profile_id} AND `guest_id` = ".$user_id;
			$this->_db->setQuery($sql);
			$this->_db->query();
		}
		else
		{
			$sql = "INSERT INTO #__community_guests (`user_id`, `guest_id`, `ctime`, `ip`) VALUES ({$profile_id}, {$user_id}, NOW(), '".getenv("REMOTE_ADDR")."')";
			$this->_db->setQuery($sql);
			$this->_db->query();
		}


	}

	function getFriends($user_id)
	{
		$sql = "SELECT * FROM #__community_userrelations "
			  ."\n WHERE (`user_id` = {$this->_id} AND `friend_id` = {$user_id}) OR (`user_id` = {$user_id} AND `friend_id` = {$this->_id}) AND `status` = 1";

		$this->_db->setQuery($sql);
		$friends = $this->_db->loadObjectList();
		//ECHO $sql;

		return $friends;
	}

	function getAllFriends($uid)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT user_id, friend_id FROM #__community_userrelations "
				."\n WHERE (`user_id` = {$uid} OR `friend_id` = {$uid}) AND `status` = 1";
		$db->setQuery($sql);
		$result  = $db->loadObjectList();
		$friends = array();
		for ($i = 0; $i< count($result); $i++)
		{
			if ($result[$i]->user_id == $uid && !in_array($result[$i]->friend_id, $friends))
			{
				$friends[] = $result[$i]->friend_id;
			}
			else if($result[$i]->friend_id == $uid &&  !in_array($result[$i]->user_id, $friends))
			{
				$friends[] = $result[$i]->user_id;
			}

		}
		unset($result);
		return $friends;
	}

	function getPluginCoreConfigurations($plg_id)
	{
		$sql = "SELECT * FROM #__plugins WHERE `id` = {$plg_id}";
		$this->_db->setQuery($sql);
		$plugin = $this->_db->loadObject();
		$plugin->params = new JParameter($plugin->params);
		return $plugin;
	}

	function areWeFriends($user1, $user2)
	{
		$sql = "SELECT status FROM #__community_userrelations WHERE (user_id = {$user1} AND friend_id = {$user2}) OR (user_id = {$user2} AND friend_id = {$user1}) LIMIT 1";
		$this->_db->setQuery($sql);
		$flag = $this->_db->loadResult();
		return $flag;
	}




}
?>