<?php
/**
 * $Id: view.html.php 7951 2012-03-14 07:17:02Z kostya $
 * $LastChangedDate: 2012-03-14 13:17:02 +0600 (Wed, 14 Mar 2012) $
 * $LastChangedBy: kostya $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access'); 

jimport( 'joomla.application.component.view');

class CommunityViewGroups extends JView
{
	/**
	 * user groups
	 *
	 */
	function display($tpl = null)
	{

		if (JRequest::getVar('layout', 'default') != 'default')
		{
			switch(JRequest::getVar('layout'))
			{
				case 'create':
					$this->_displayForm($tpl);
					return;
					break;
				case 'group':
					$this->_displayGroup($tpl);
					return;
					break;
				case 'request':
					$this->_displayRequestForm($tpl);
					return;
					break;
				case 'requests':
					$this->_displayRequests($tpl);
					return;
					break;
				case 'invite':
					$this->_displayInvite($tpl);
					return;
					break;
				case 'my':
					$this->_displayMy($tpl);
					return;
					break;
				default:
					break;
			}
		}

		/*if (JRequest::getInt('category_id', 0) < 1)
		 {*/
		$this->_displayMain($tpl);
		return;
		//}



	}

	function  _displayGroup($tpl)
	{
		global $Itemid, $mainframe;
		JHTML::_('behavior.tooltip');
		$params = & $mainframe->getParams();
		//$Itemid = JRequest::getInt("Itemid");
		$user = &JFactory::getUser();
		$uri = &JFactory::getURI();
		$aid = $user->get('aid');
		$document = &JFactory::getDocument();
		$document->addScript(JURI::root() . 'includes/js/joomla.javascript.js');
		$lists = array();
		$access = true;
		$model = &JModel::getInstance('Group', 'CommunityModel');
		$model->setId(JRequest::getInt('id', $params->get('default_group')));
		$mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
		
		$data = &$model->getData();
		$groupParams = new JParameter($data->get("params", ''));
		
		if ($data->get('published') == 0)
		{
			JError::raiseWarning(100, JText::_("The groups does not exists or not available."));
			$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=protected&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, FALSE));
			return;
		}
		
		if( !CommunityHelperGroups::checkGroupAccess($user, $data->get('id'), $data->get('access'), $data->get('user_id')) ){
		    $access = false;
		}

		$this->_prepareOneItem($data);

		$pathway = &$mainframe->getPathway();

		$groupsModel  = &JModel::getInstance('Groups', 'CommunityModel');
		$groupsModel->setCategory($data->catid);
		$currentCategory = $groupsModel->getCurrentCategory();

		$pathway->addItem($currentCategory->title, "index.php?option=com_community&view=groups&layout=default&category_id={$currentCategory->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID);
		$pathway->addItem($data->title, '');
        
		if ($mModel->isUserBlocked($data->id, $user->get('id') ))
		{
			JError::raiseWarning(404, JText::_("You were blocked in this group"));
			$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=default&category_id='.$data->catid.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false));
		}

		//Check whether the user is creator of the group
		$creator = &JFactory::getUser($data->user_id);
		$isCreator = false;
		$isModerator = false;
		$isMember = false;
		if ($creator->get('id') == $user->get('id'))
		{
			$isCreator = true;

		}
		//Check if the user is a member of a group

		if($user->get('id') > 0 )
		{
			$isMember = $mModel->isGroupMember($data->id, $user->get('id'));
			$isModerator = $mModel->isGroupModerator($data->id, $user->get('id'));
		}

		//check if the user is moderator of the group


		if ($isCreator)
		{
			$isModerator = true;
		}
		if($isModerator)
		{
			$isMember = true;
		}


		//getting the menu items for the group
		$menuItems = CommunityHelperMenu::getGroupMenuItems(array('isMember'=>$isMember, 'isModerator'=>$isModerator, 'isCreator'=>$isCreator), $data, $user, $Itemid);
		//here we do cheking of the user's access based on the carma
		if (COMMUNITY_CARMA_ENABLE && !$isModerator && !$isCreator)
		{
			if (!CommunityHelperGroups::checkGroupCarmaAccess($user, $data->id, $data->user_id))
			{
				JError::raiseNotice(500, JText::_("You do not have enough carma to access this group"));
				$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=default&category_id='.$data->get('catid').'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false));
				return;
			}
		}

		//prepare the group info for the output.

    	$activity = array();
		if (COMMUNITY_HISTORY_GROUP_ENABLE && COMMUNITY_HISTORY_ALL_ENABLE && (COMMUNITY_HISTORY_ACCESS <= $user->get('aid')))
		{
			$activity = $model->getActivity();
		}

		$document->setTitle($data->title);
		$moderators = $mModel->getGroupMembers($data->id, 'moderators', false, COMMUNITY_GROUPS_SHOW_NUM_MODERS);
		$members = $mModel->getGroupMembers($data->id, 'members', false, COMMUNITY_GROUPS_SHOW_NUM_MEMBERS);

		//$isModerator = $model->isGroupModerator($data->id, $user->get('id'));

		$document->addStyleDeclaration('
			.mytipdrop-tip {
			width: 200px;
			z-index: 13000;
			border: 1px solid #d0d0d0;
		}
		
		.mytipdrop-title {
			font-weight: bold;
			margin: 0;
			padding: 8px 8px 4px;
			background-color: #d0d0d0;
			border-left: 5px solid whitesmoke;
			border-right: 5px solid whitesmoke;
			border-top: 5px solid whitesmoke;
			color: #000;
		}
		
		.mytipdrop-text {
			font-size: 12px;
			padding: 4px 8px 8px;
			background-color: #fff;
			border-bottom: 5px solid whitesmoke;
			border-left: 5px solid whitesmoke;
			border-right: 5px solid whitesmoke;
			border-top: 5px solid whitesmoke;
			color: #000;
		}');
		JHTML::_('behavior.tooltip', '.myTip', array('fixed' => 1, 'hideDelay' => 2000, 'className'=>'mytipdrop'));
		
		if($sections = $model->getSections($groupParams->get('used_sections'))){
			
			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models'.DS.'list.php';
			 
			$modelres = new ResModelList();
			foreach ($sections as $key => $value)
			{
				$sec_params = ResHelper::initListParams($key);
				$types = $value['types']; //explode(",", $params->get('type'));
				JArrayHelper::toInteger($types);
				foreach ($types AS $type)
				{
					if(!$type) continue;
		
					$tp = $modelres->getType($type);
					$type_params = new JParameter($tp->params);
		
					if(!MEAccess::isAdmin())
					{
						if($type_params->get('submission') == 'none')	continue;
						//if($params->get('category_mode') == 1)
						if($type_params->get('submission') > $user->get('aid') && ($type_params->get('submission') == 2))	continue;
					}
		
					if($type_params->get('submission') == 1 && !$user->get('id'))
					{
						$menu_element = JText::sprintf($sec_params->get('menu_label_add_reg'), $tp->name);
						if($sec_params->get('menu_icon_add') && $sec_params->get('menu_show_icons') && $menu_element) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$sec_params->get('menu_icon_add').'" align="absmiddle" /> '.$menu_element;
						$sections[$key]['add'][$tp->id] = $menu_element;
					}
					else
					{
						$link = "index.php?option=com_resource&controller=article&category_id={$key}&view=article&layout=form&type_id={$type}&client_id=".$data->id."&client=".urlencode(stripslashes($value['client']))."&Itemid=".MEUrl::itemid(NULL, $key);
						$link = MEUrl::linkAdditions($link, array('user_id' => 0, 'ucid' => 0, 'view_what' => 0));
						$link .= '&redirect='.base64_encode($uri->toString());
	
						$menu_element = JHTML::link(MERoute::_($link), JText::sprintf($sec_params->get('menu_label_add'), $tp->name));
						if($sec_params->get('menu_icon_add') && $sec_params->get('menu_show_icons')) $menu_element = '<img src="'.JURI::root().'components/com_resource/images/user_menu/'.$sec_params->get('menu_icon_add').'" align="absmiddle" /> '.$menu_element;
						$sections[$key]['add'][$tp->id] = $menu_element;
					}
				}
			}
		}else{
			$sections = array();
		}
		
		$current_template = $groupParams->get('template', (COMMUNITY_GENERAL_DEFAULT_GROUP_TEMPLATE ? COMMUNITY_GENERAL_DEFAULT_GROUP_TEMPLATE : 'default'));
		if(!JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'groups'.DS.'tmpl'.DS.'group_groups_'.$current_template.'.ini')){
			$current_template = 'default';
		}
		$templateParams = "";
		$tmpl_ini_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'groups'.DS.'tmpl'.DS.'group_groups_'.$current_template.'.ini';
		$tmpl_ini = "";
		if(JFile::exists($tmpl_ini_file))
		{
			$tmpl_ini = JFile::read($tmpl_ini_file);
		}
		$tmpl_params = new JParameter($tmpl_ini);

		$this->assignRef('params',      $params);
		$this->assignRef('user',        $user);
		$this->assignRef('creator',     $creator);
        $this->assignRef('access',      $access);
		$this->assignRef('data',        $data);
		$this->assignRef('groupParams', $groupParams);

		$this->assignRef('isCreator',   $isCreator);
		$this->assignRef('isMember',    $isMember);
		$this->assignRef('isModerator', $isModerator);

		$this->assignRef('Itemid',      $Itemid);
		$this->assignRef('sections',    $sections);
		$this->assignRef('moderators',  $moderators);
		$this->assignRef('members',     $members);
		$this->assignRef('activity',    $activity);
		$this->assignRef('menuItems',   $menuItems);

		$this->assignRef('uri',         $uri);
		$this->assignRef('lists',       $lists);
		$this->assignRef('current_template',     $current_template); 
		$this->assignRef('tmpl_params',     $tmpl_params); 
		parent::display($tpl);
	}
	

	function _displayMy($tpl = null)
	{
		global $mainframe, $Itemid, $option;

		$document = &JFactory::getDocument();
		$document->addScript(JURI::root()."includes/js/joomla.javascript.js");

		$params = new JParameter('');

		$params->set('page_title', JText::_("My Groups"));
		$params->set('show_page_title', 1);
		
		$pathway = &$mainframe->getPathway();

		$uri = &JFactory::getURI();
		$user = &JFactory::getUser();
		
		if(!$user->get('id'))
		{
			JError::raiseNotice(403, 'You need to be loged in to access this page');
			CommunityHelperGeneral::redirectToLogin();
			return;
		}

		$own_groups = $this->get('OwnGroups');
		$mod_groups = $this->get('ModGroups');
		$mem_groups = $this->get('MemGroups');
		
		$this->_prepareItems($own_groups);
		$this->_prepareItems($mod_groups);
		$this->_prepareItems($mem_groups);
		
		$pathway->addItem(JText::_('My Groups'), '');
		$document->setTitle(JText::_('My Groups'));
				
		$this->assignRef('own_groups',       $own_groups);
		$this->assignRef('mod_groups',       $mod_groups);
		$this->assignRef('mem_groups',       $mem_groups);
		$this->assignRef('params' ,          $params);
		$this->assignRef('user',             $user);
		$this->assignRef('uri',              $uri);
		parent::display($tpl);
	}

	function _displayMain($tpl = null)
	{
		global $mainframe, $Itemid, $option;
		$search				= $mainframe->getUserStateFromRequest( $option.'.groups.search',            'search', '',  'string' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.groups.filter_order',		'filter_order',		'a.ctime',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.groups.filter_order_Dir',	'filter_order_Dir',	'DESC',	'word' );


		$document = &JFactory::getDocument();
		$document->addScript(JURI::root()."includes/js/joomla.javascript.js");


		$activeMenu	= &JSite::getMenu();
		$menu	  = $activeMenu->getActive();
		$menu_params = new JParameter( @$menu->params );

		$pathway = &$mainframe->getPathway();

		$uri = &JFactory::getURI();
		$user = &JFactory::getUser();

		$categories = &$this->get('CategoriesList');
		$coreGroups = &$this->get('CoreGroups');
		$groups = array();

		$currentcategory = '';
		$pagination = '';

		$groups 		 = &$this->get('Groups');
		$currentcategory = $this->get('CurrentCategory');
		$pagination 	 = &$this->get('Pagination');

		if ($currentcategory)
		{
			$pathway->addItem($currentcategory->title, '');
			$document->setTitle($currentcategory->title);
		}


		$this->_prepareItems($groups);
		$this->_prepareItems($coreGroups);


		$lists['order'] = $filter_order;
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['search']  = '<input type="text" name="search" value="'.$search.'" class="inputbox">';


		$showCategoryList = true;

		if (strlen(trim($search)) > 3)
		{
			//$showCategoryList = false;
		}
		else if (strlen(trim($search)) > 0 && strlen(trim($search)) < 4)
		{
			JError::raiseNotice(400, JText::_("The search keyword must be more than three characters"));
		}
		
		$current_template = (COMMUNITY_GENERAL_DEFAULT_GROUPS_LIST_TEMPLATE ? COMMUNITY_GENERAL_DEFAULT_GROUPS_LIST_TEMPLATE : 'default');
		if(!JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'groups'.DS.'tmpl'.DS.'group_groups_'.$current_template.'.ini')){
			$current_template = 'default';
		}
		$templateParams = "";
		$tmpl_ini_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'groups'.DS.'tmpl'.DS.'default_groups_'.$current_template.'.ini';
		$tmpl_ini = "";
		if(JFile::exists($tmpl_ini_file))
		{
			$tmpl_ini = JFile::read($tmpl_ini_file);
		}
		
		$tmpl_params = new JParameter($tmpl_ini);
		$tmpl_params->set('page_title', $menu_params->get('page_title', JText::_("Groups List")));
		$tmpl_params->set('show_page_title', $menu_params->get('show_page_title', 1));

		$this->assignRef('search',       $search);
		$this->assignRef('pagination',       $pagination);
		$this->assignRef('lists',            $lists);
		$this->assignRef('groups',           $groups);
		$this->assignRef('tmpl_params' ,     $tmpl_params);
		$this->assignRef('user',             $user);
		$this->assignRef('Itemid',           $Itemid);
		$this->assignRef('categories',       $categories);
		$this->assignRef('coreGroups',       $coreGroups);
		$this->assignRef('uri',              $uri);
		$this->assignRef('currentCategory',  $currentcategory);
		$this->assignRef('current_template',     $current_template); 
		$this->assignRef('showCategoryList', $showCategoryList);

		parent::display($tpl);
	}

	function _displayForm($tpl = null)
	{
		defined('COMMUNITY_GENERAL_USR_CHOOSE_GROUP_TMPL') or define('COMMUNITY_GENERAL_USR_CHOOSE_GROUP_TMPL', '');
		global $mainframe, $Itemid;
		//$Itemid = JRequest::getInt("Itemid");
		$user = &JFactory::getUser();
		if ($user->get('id') < 1)
		{
			JError::raiseWarning(100, JText::_("Only registered users can create groups") );
			CommunityHelperGeneral::redirectToLogin();
			return;

		}
		if(!CommunityHelperGroups::canCreateGroup($user, JRequest::getInt('category_id', 0)))
		{
			JError::raiseWarning(400, JText::_("You cannot create a group in this category. Please select a category where you can create a group."));
		}




		$uri = &JFactory::getURI();
		$gid = $user->get('gid');
		$document = &JFactory::getDocument();
		$document->addScript(JURI::root() . 'includes/js/joomla.javascript.js');

		jimport('joomla.filesystem.folder');
		$isInboxInstalled = false;
		if (JFolder::exists(JPATH_ROOT.DS.'components'.DS.'com_jsinbox') && JFolder::exists(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jsinbox'))
		{
			$isInboxInstalled = true;
		}



		$lists = array();
		$model = &JModel::getInstance('Group', 'CommunityModel');

		$data = &$model->getData();
		$isNew = false;
		if ($data->get('id') == 0)
		{
			$isNew = true;
			if (!COMMUNITY_GROUPS_ALLOW_CREATE && $user->gid < 23)
			{
				JError::raiseWarning(404, JText::_("It is not allowed to create groups."));
				return;
			}
			$lists['ctime'] = JHTML::_('calendar',JHTML::_('date', 'now', '%Y-%m-%d %H:%M:%S') ,'ctime' ,'ctime', '%Y-%m-%d %H:%M:%S', array('class' =>'inputbox'));
		}
		else
		{
			$lists['ctime'] = JHTML::_('calendar', $data->get('ctime') ,'ctime' ,'ctime', '%Y-%m-%d %H:%M:%S', array('class' =>'inputbox'));
		}
		//***************IF USER IS NOT AUTHORIZED******************************
		if (!$isNew)
		{
			if (($gid < 23)  && ($user->get('id') != $data->user_id))
			{
				if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
					$return = base64_decode($return);
					if (strpos( $return, 'http' ) !== false && strpos( $return, JURI::base() ) !== 0) {
						$return = '';
					}
				}
				JError::raiseWarning(100, JText::_("You are not authorized to edit this group"));
				if ($return){
					$mainframe->redirect(JRoute::_($return, false));
				}
				else
				{
					$mainframe->redirect(JRoute::_('index.php?option=com_community&view=groups&layout=default&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID, false) );
				}

			}

		}
		//**********************************************************************
		if ($isNew)
		{
			$document->setTitle(JText::_("Create Group"));
		}
		else
		{
			$document->setTitle(JText::_("Edit Group")." ".$data->title);
		}
		$categories = $model->getCategories();
		$options = array();

		foreach ($categories as $cat)
		{
			$options[] = JHTML::_('select.option', $cat->id, $cat->title);
		}
		$lists['categories'] = JHTML::_('select.genericlist',   $options, 'catid', 'class="inputbox"', 'value', 'text', $data->get('catid', JRequest::getInt('category_id', 0)) );

		$pathway = &$mainframe->getPathway();
		$currentCategory = $data->get('catid', JRequest::getInt('category_id', 0));
		if ($currentCategory!=0)
		{
			$groupsModel = &$this->getModel();
			$groupsModel->setCategory($currentCategory);
			$currentCategory = $this->get('CurrentCategory');
			$pathway->addItem($currentCategory->title, "index.php?option=com_community&view=groups&layout=default&category_id={$currentCategory->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID);

		}
		if($isNew)
		{
			$pathway->addItem(JText::_("Create Group"));
		}
		else
		{
			$pathway->addItem($data->title, 'index.php?option=com_community&view=groups&layout=group&id='.$data->id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID);
			$pathway->addItem(JText::_("Edit"));
		}
		$params = new JParameter($data->params, JPATH_COMPONENT_SITE.DS.'views'.DS.'groups'.DS.'group_params.xml');
		//reset the options array in order to fill with other data for the access
		$options = array();
		$options[] = JHTML::_('select.option', 0, JText::_("Everybody"));
		$options[] = JHTML::_('select.option', 1, JText::_("Registered"));
		$options[] = JHTML::_('select.option', 2, JText::_("Group Members"));
		//$options[] = JHTML::_('select.option', 3, JText::_("Group Memebers"));
		$options[] = JHTML::_('select.option', 4 , JText::_("Moderators"));
		$options[] = JHTML::_('select.option', 5 , JText::_("Creator"));

		$access = $data->get('access', 0) == 3 ? 2 :$data->get('access', 0);
		$submit_access = 0;
		$comment_access = 0;
		if ( $isNew) //? 2 : ;
		{
			$submit_access = 2;
			$comment_access = 0;
		}
		else if($data->get('submit_access', 2) == 3) { $submit_access = 2; }
		else                                         { $submit_access = $data->get('submit_access', 2);}

		if ($data->get('comments_access', 0) == 3) { $comment_access = 2; }
		else                                       { $comment_access = $data->get('comments_access', 0); }

		$accessjs        = 'onchange="changeFriendsDiv(\'access\', this.value);changeKarmaDiv(\'access_karma\', this);" onkeyup="changeFriendsDiv(\'access\', this.value);changeKarmaDiv(\'access_karma\', this);"';
		$submitaccjs     ='onchange="changeFriendsDiv(\'submit_access\', this.value);changeKarmaDiv(\'submit_access_karma\', this);" onkeyup="changeFriendsDiv(\'submit_access\', this.value);changeKarmaDiv(\'submit_access_karma\', this);"';
		$commentaccessjs = 'onchange="changeFriendsDiv(\'comment_access\', this.value);changeKarmaDiv(\'comment_access_karma\', this);" onkeyup="changeFriendsDiv(\'comment_access\', this.value);changeKarmaDiv(\'comment_access_karma\', this);"';


		$lists['access'] 			= JHTML::_('select.genericlist',   $options, 'access', 'class="inputbox" '.$accessjs, 'value', 'text',$access  );
		$lists['submit_access']		= JHTML::_('select.genericlist',   $options, 'submit_access', 'class="inputbox" '.$submitaccjs, 'value', 'text', $submit_access);
		$lists['comments_access'] 	= JHTML::_('select.genericlist',   $options, 'comments_access', 'class="inputbox" '.$commentaccessjs, 'value', 'text', $comment_access );
		$lists['published']			= JHTML::_('select.booleanlist', 'published',  'class="inputbox"',  $isNew ? 1 : $data->get('published', 1) );
		if ($isInboxInstalled)
		{
			$options[0] = JHTML::_('select.option', 0, JText::_("Nobody"));
			$message_accessjs        = 'onchange="changeKarmaDiv(\'message_access_karma\', this);" onkeyup="changeKarmaDiv(\'message_access_karma\', this);"';
			$lists['message_access'] = JHTML::_('select.genericlist',   $options, 'params[message_access]', 'class="inputbox" '.$message_accessjs, 'value', 'text',$params->get('message_access', 2)  );
		}

		$carmaList = JSCommunityApi::getCarmaList();
		//$carmaList = JSCommunityApi::cutTheCarma($user, $carmaList);
		$carmaOptions = array();
		if (COMMUNITY_CARMA_ENABLE)
		{
			foreach($carmaList as $key=>$value)
			{
				$carmaOptions[] = JHTML::_('select.option', $key, $value['title']." ({$value['points']})");
			}
		}

		$joinTypeOptions = array();
		$joinTypeOptions[] = JHTML::_('select.option', 0, JText::_("Everybody"));
		$joinTypeOptions[] = JHTML::_('select.option', 2, JText::_("Friends"));
		$joinTypeOptions[] = JHTML::_('select.option', 1, JText::_("Request"));


		//function radiolist( $arr, $name, $attribs = null, $key = 'value', $text = 'text', $selected = null, $idtag = false, $translate = false )
		$lists['join_type'] = JHTML::_('select.genericlist',$joinTypeOptions, 'join_type',  'class="inputbox" onclick="changeKarmaDiv2(\'join_carma\', this);" onkeyup="changeKarmaDiv2(\'join_carma\', this);"','value','text',  $data->get('join_type', 0) );

		$editor = &JFactory::getEditor(COMMUNITY_GROUPS_EDITOR);

		if ($user->get('aid') == 2)
		{
			$lists['is_core'] =  JHTML::_('select.booleanlist', 'is_core',  'class="inputbox"',  $data->get('is_core', 0) );
		}
		
		$lists['templates'] = $this->getTemplates(COMMUNITY_GENERAL_USR_CHOOSE_GROUP_TMPL, $params);

		$this->assignRef('data', 		    $data);
		$this->assignRef('editor', 		    $editor);
		$this->assignRef('params', 		    $params);
		$this->assignRef('user', 		    $user);
		$this->assignRef('uri', 		    $uri);
		$this->assignRef('lists', 		    $lists);
		$this->assignRef('isNew', 		    $isNew);
		$this->assignRef('carmaOptions',    $carmaOptions);
		$this->assignRef('Itemid', 		    $Itemid);
		$this->assignRef('isInboxInstalled',$isInboxInstalled);
		parent::display($tpl);
	}
	
	function getTemplates($list, $params)
	{
		if(!$list) return array();
		$templates =  explode('|', $list);
		$name = 'template';
		
		$result = array();
		$options[] = JHTML::_('select.option', '', JText::_('-Select Group Template-') );

		$layouts_path = CommunitySubTemplate::getTmplPath( 'group' );
		$tmpl_mask    = CommunitySubTemplate::getTmplMask( 'group' );

		$files = JFolder::files( $layouts_path, $tmpl_mask['index_file'] );
		foreach( $files as $key => $file ){
			if(!in_array(str_replace('group_groups_', '' ,JFile::stripExt($file)),$templates))
				continue;
			$xml = new JSimpleXML();
			$xml->loadFile($layouts_path.DS.$file);
			$title = $xml->document->_children[0]->data();
			$tmplname = preg_replace ( $tmpl_mask['ident'], '', $file );
			$options[] = JHTML::_( 'select.option', $tmplname, $title );
			unset($xml);
		}

		if (count($options) > 1)
		{
			return JHTML::_('select.genericlist',  $options, "params[{$name}]", 'class="inputbox"', 'value', 'text', $params->get($name));
		}
		return array();
	}

	function _displayRequestForm($tpl)
	{
		global $mainframe, $Itemid;
		$params = $mainframe->getParams();
		$user = &JFactory::getUser();
		$uri = &JFactory::getURI();
		//$Itemid = JRequest::getInt("Itemid");
		if($user->get('id') < 1)
		{
			CommunityHelperGeneral::redirectToLogin();
		}
		$model = &JModel::getInstance('Group', 'CommunityModel');
		$mModel = &JModel::getInstance('GroupMembers', 'CommunityModel');
		$model->setId(JRequest::getInt('id', $params->get('default_group')));

		$data = &$model->getData();
		$pending = $mModel->isPending($data->id, $user->get('id'));
		if ($data->get('id', 0) == 0)
		{
			JError::raiseWarning(404, JText::_('The Group does not exist'));
			return;
		}

		$this->assignRef('pending', $pending);
		$this->assignRef('uri', $uri);
		$this->assignRef('data', $data);
		$this->assignRef('Itemid', $Itemid);
		$this->assignRef('user', $user);
		parent::display($tpl);
	}


	function _displayRequests($tpl)
	{
		global $mainframe, $Itemid, $option;
		$id = JRequest::getInt('id', 0);
		if ($id == 0)
		{
			JError::raiseNotice(100, JText::_('The group does not exist'));
			parent::display($tpl);
			return;
		}

		$uri = &JFactory::getURI();
		$user = &JFactory::getUser();
		
		if ($user->get('id') < 1)
		{
			CommunityHelperGeneral::redirectToLogin();
		}
		
		$model = &JModel::getInstance('GroupMembers', 'CommunityModel');
		$groupModel = &JModel::getInstance('Group', "CommunityModel");

		$data = &$groupModel->getData();
		$creator = &JFactory::getUser($data->user_id);

		if( !$model->isGroupModerator($id, $user->get('id')) && $user->get('id') != $creator->get('id') ){
		    echo '<div class="componentheading">',JText::_("Manage User of the group"),' ',$data->title,'</div>';
		    echo JText::_("You have not enough rights for this page! Only creator and moderators have access.");
		    return;
		}
		
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.groupmembers.filter_order',		'filter_order',		'um.ctime',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.groupmembers.filter_order_Dir',	'filter_order_Dir',	'',	'word' );

		$document = &JFactory::getDocument();
		$document->addScript(JURI::root() . 'includes/js/joomla.javascript.js');
		

		$pathway = &$mainframe->getPathway();
		$groupsModel  = &JModel::getInstance('Groups', 'CommunityModel');
		$groupsModel->setCategory($data->catid);
		$currentCategory = $groupsModel->getCurrentCategory();
		$pathway->addItem($currentCategory->title, "index.php?option=com_community&view=groups&layout=default&category_id={$currentCategory->id}&Itemid=".JRequest::getInt("Itemid"));
		$pathway->addItem($data->title, 'index.php?option=com_community&view=groups&layout=group&id='.$data->id."&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID);
		$pathway->addItem(JText::_("Manage Members"));


		$lists = array();
		$lists['order'] = $filter_order;
		$lists['order_Dir'] = $filter_order_Dir;
		
		$items      = $model->getData();
		$pagination = $model->getPagination();

		$creator = &JFactory::getUser($data->user_id);


		$this->assignRef('uri', $uri);
		$this->assignRef('data', $data);
		$this->assignRef('creator', $creator);
		$this->assignRef('lists', $lists);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('items', $items);
		$this->assignRef('user', $user);
		$this->assignRef('mModel', $model);
		parent::display($tpl);
	}

	function _displayInvite($tpl)
	{
		global $mainframe;
		$user_id = JRequest::getInt('user_id');
		if($user_id == 0)
		{
			JError::raiseWarning(404, JText::_("No user selected for invintation"));
			return;
		}

		$params      = $mainframe->getParams();

		$user        = &JFactory::getUser($user_id);
		$currentUser = &JFactory::getUser();
		$uri         = &JFactory::getURI();
		$Itemid      = JRequest::getInt("Itemid");

		$lists       = array();
		$items       = array();

		$pagination  = null;


		$mGroups = &JModel::getInstance("Groups", "CommunityModel");
		$items = $mGroups->getGroupsForInvite($currentUser->get('id'), $user_id);
		
		if (count($items)<1)
		{
			JError::raiseNotice(403, JText::_("You are not a member of any group to invite to."));
			echo "<br><br><a href='javascript:back();'>".JText::_("Back")."</a>";
			return;
		}
		$this->_prepareItems($items);

		$this->assignRef('uri',         $uri);
		$this->assignRef('params',      $params);
		$this->assignRef('lists',       $lists);
		$this->assignRef('pagination',  $pagination);
		$this->assignRef('items',       $items);
		$this->assignRef('user',        $user);
		$this->assignRef('currentUser', $currentUser);
		$this->assignRef('Itemid',      $Itemid);

		parent::display($tpl);
	}

	function _prepareItems(&$groups) {
		global $Itemid;
		if(!$groups) return array();
		$uri = &JFactory::getURI();
		$user = &JFactory::getUser();
		$gid = $user->get('gid');
		$imgFolder =  COMMUNITY_GENERAL_UPLOAD;

		if (count($groups)) {
			while (list($key, $value) = each($groups)) {
				$group =& $groups[$key];
				$group->icon = JURI::root().'index2.php?option=com_community&controller=groups&task=groupicon&group_id='.$group->id.'&no_ajax=1&width='.COMMUNITY_GROUPS_ICONS_WIDTH.'&height='.COMMUNITY_GROUPS_ICONS_HEIGHT;
				$group->publish = "";
				$group->edit    = "";
				if(($gid >= 20 && $gid <= 25)||  $group->user_id == $user->get('id')) {
					$taskLink = '';
					$taskImage = "";
					if ($group->published) {
						$taskLink = 'index.php?option=com_community&controller=groups&task=unpublish&id='.$group->id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID."&return=".base64_encode($uri->toString());
						$taskImage = "<img src='".JURI::root()."components/com_community/images/a.unpublish.png' />";
					}
					else {
						$taskLink = 'index.php?option=com_community&controller=groups&task=publish&id='.$group->id.'&Itemid='.COMMUNITY_GENERAL_GROUP_ITEMID."&return=".base64_encode($uri->toString());
						$taskImage = "<img src='".JURI::root()."components/com_community/images/a.publish.png' />";

					}
					$group->publish = "<a href='{$taskLink}&return=".base64_encode($uri->toString())."'>{$taskImage}</a>";

				}
				if ($group->user_id == $user->get('id') || ($gid >= 23 && $gid <= 25) ) {
					$edit_img = "<img src='".JURI::root()."components/com_community/images/a.edit.png' />";
					$edit_link = JRoute::_("index.php?option=com_community&view=groups&layout=create&id={$group->id}&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID."&return=".base64_encode($uri->toString()));
					$group->edit = "<a href='{$edit_link}'>{$edit_img}</a>";
				}
			}
		}
	}

	function _prepareOneItem(&$group)
	{
		global $Itemid;
		//$ItemId = JRequest::getInt('ItemId');
		$uri = &JFactory::getURI();
		$user = &JFactory::getUser();

		$gid = $user->get('gid');
		$imgFolder = COMMUNITY_GENERAL_UPLOAD;
		$group->icon = JURI::root().'index2.php?option=com_community&controller=groups&task=groupicon&group_id='.$group->id.'&no_ajax=1&width='.COMMUNITY_GROUPS_THUMB_WIDTH.'&height='.COMMUNITY_GROUPS_THUMB_HEIGHT;
		$group->publish = "";
		$group->edit    = "";
	}

	function _renderParamsGroup($group, &$params)
	{

		$paramsArray =  $params->renderToArray('params',$group);

		?>

		<?php
		foreach ($paramsArray as $param)
		{
			if($param[1]){
			?>
<tr valign="top">
	<td class="key"><?php echo $param[0]; ?></td>
	<td class="value"><?php echo $param[1]; ?></td>
</tr>
			<?php
			}
		}
		?>

		<?php
	}
}
?>