<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('restricted');

jimport( 'joomla.application.component.view');

class CommunityViewHistory extends JView
{
	/**
	 * Prepare info for User History.
	 *
	 */

	function display($tpl = null)
	{
		global $mainframe, $Itemid, $option;
		$user = JFactory::getUser();
		$uri  = JFactory::getURI();
		JHTML::_('behavior.mootools');
		JHTML::_('behavior.tooltip');
		
		if(!COMMUNITY_HISTORY_ALL_ENABLE)
		{
			JError::raiseNotice(403, JText::_('Activity History is disabled on this site.'));
			return;
		}
		if(COMMUNITY_HISTORY_ACCESS > $user->get('aid'))
		{
			//if(!$user->get('id')) CommunityHelperGeneral::redirectToLogin();
			JError::raiseNotice(403, JText::_('You cannot access Activity History. You do not have enought Rights.'));
			return;
			//parent::display($tpl);
		}

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.history.filter_order',		'filter_order',		'activ.ctime',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.history.filter_order_Dir',	'filter_order_Dir',	'',	'word' );
		$type               = $mainframe->getUserStateFromRequest($option.'.history.activity_type', 'activity_type', JText::_('All Activity'), 'string');

		defined('COMMUNITY_GENERAL_PROFILE_ITEMID') or define('COMMUNITY_GENERAL_PROFILE_ITEMID', $Itemid);


		$pathway	=& $mainframe->getPathway();
		$group_id   = JRequest::getInt('group_id');
		$tGroups = null;
		$menus	= &JSite::getMenu();
		$menu	  = $menus->getActive();
		$params = new JParameter( @$menu->params );

		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::root().'components/com_community/assets/style.css');
		
		$link	= '&format=feed&activity_type='.urlencode($type);
	    $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
		$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
		
		if ($group_id > 0 )
		{
			$tGroups = &JTable::getInstance("Groups", 'CommunityTable');
			$tGroups->load($group_id);
			$pathway->addItem($tGroups->title, 'index.php?option=com_community&view=groups&id='.$tGroups->id."&layout=group&Itemid=".COMMUNITY_GENERAL_GROUP_ITEMID);
			$params->set('page_title', $tGroups->get('title')." ".JText::_("Group Activity"));
		}

		$profile = null;
		$user_id = JRequest::getInt('user_id', 0);
		$pageTitle = $params->get('page_title');
		if ($user_id)
		{
			$profile = JFactory::getUser($user_id);
		}
		if ($user_id == $user->get('id') && $user->get('id') > 0 && JRequest::getVar("view_what") == 'friends')
		{
			$profile = $user;
			$params->set('page_title', JText::_("My Friends Activity"));
			JRequest::setVar('view_what', 'friends');
		}
		else if ($user_id == $user->get('id') && $user->get('id') > 0 )
		{
			$profile = $user;
			$params->set('page_title', JText::_("My Activity"));
		}
		
		if (!empty($profile))
		{
			$pathway->addItem($profile->username, 'index.php?option=com_community&view=profile&user_id='.$profile->id."&Itemid=".$Itemid);
			$params->set('page_title', JText::_("Activity of ".$profile->username));
		}

		if(!$params->get('page_title'))
		{
				$params->set('page_title', JText::_("Activity History"));
		}

		$pathway->addItem(JText::_("Activity"));

		$document->setTitle($params->get('page_title'));

		$model = &JModel::getInstance('History', 'CommunityModel');
		$data = &$model->getData();
		$pagination = &$model->getPagination();

		$Itemid = JRequest::getInt('Itemid');
		$types = $model->getTypes();
		$types = CommunityHelperGeneral::_cleanArray($types);
		
		$all = new StdClass();
		$all->type = JText::_("All Activity");
		$all->icon = "";
		array_unshift($types, $all );

		$lists = array();

		$this->assignRef('data',       $data);
		$this->assignRef('type',       $type);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('Itemid',     $Itemid);
		$this->assignRef('user',       $profile);
		$this->assignRef('types',      $types);
		$this->assignRef('params',     $params);
		$this->assignRef('lists',      $lists);
		$this->assignRef('uri',      $uri);

		parent::display($tpl);
	}
	
	function getGroupTitle($id)
	{
		$db = & JFactory::getDBO();
		static $result = array();
		
		if(@$result[$id]) return $result[$id];
		
		$sql2 = " SELECT title FROM  #__community_communities WHERE id = $id";
		$db->setQuery($sql2);
		$result[$id] = $db->loadResult();
		
		return $result[$id];
	}

}
?>