<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.view');
class CommunityViewList extends JView
{

	function display($tpl = null)
	{
		global $mainframe, $option, $Itemid;
		
		defined('COMMUNITY_GENERAL_PROFILE_ITEMID') or define('COMMUNITY_GENERAL_PROFILE_ITEMID', $Itemid);
		
		$document = &JFactory::getDocument();
		$document->addScript(JURI::root() . "components/com_community/assets/javascript.js");
		$document->addScript(JURI::root() . "includes/js/joomla.javascript.js");
		$document->addStyleSheet(JURI::root() . "components/com_community/assets/style.css");
		
		$uri = JFactory::getURI();
		$user = &JFactory::getUser();
		$pathway = & $mainframe->getPathway();
		$model = &JModel::getInstance('List', 'CommunityModel');
		$dispacher = &JDispatcher::getInstance();
		$params = new JParameter('');
		$menus = &JSite::getMenu();
		$menu = $menus->getActive();
		$menu_params = &$mainframe->getParams();
		//$params->merge($menu_params);
		//echo $params->get('show_filters');
		$pendingFriends = array();
		$filters = array();
		$items = array();
		$pagination = null;
		$predefined_list = null;
		
		if (COMMUNITY_ACCESS_ALLOW_LIST > $user->get('aid'))
		{
			JError::raiseWarning(403, JText::_('You do not have permission to access user list'));
			return;
		}
		
		$params->set('show_title', $menu_params->get('show_page_title', 1));
		
		$text_search = true; $template = COMMUNITY_GENERAL_LIST_TEMPLATE;
		if ($menu_params->get('list', 0))
		{
			$predefined_list = $model->getPredefinedList($menu_params->get('list', 0));
			$params->set('description', $predefined_list->description);
			$params->set('filter_order', $predefined_list->params->get('order', 'u.registerDate'));
			$params->set('filter_order_dir', $predefined_list->params->get('order_Dir', 'DESC'));
			$text_search = $predefined_list->params->get('pt_show_hide_text_search');
			$template = $predefined_list->params->get('custom_template', COMMUNITY_GENERAL_LIST_TEMPLATE);
			
			if($predefined_list->params->get('custom_search'))
			{
				$search_default = $mainframe->getUserStateFromRequest('com_communiy.filter_search'.$Itemid, 'search_word', $predefined_list->params->get('custom_search'), 'string');
				if($search_default == JText::_('--Text Search--'))
				{
					$mainframe->setUserState('com_communiy.filter_search'.$Itemid, $predefined_list->params->get('custom_search'));
					$search_default = $predefined_list->params->get('custom_search');
				}
				JRequest::setVar('search_word', $search_default);
			}
			//if($predefined_list->params->get('custom_search') && !JRequest::getVar('search_word')) JRequest::setVar('search_word', $predefined_list->params->get('custom_search'));
		}
		if(!$template) $template = 'default';
		
		$templateParams = "";
		$tmpl_ini_file = JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'views' . DS . 'list' . DS . 'tmpl' . DS . 'default_list_' . $template . '.ini';
		$tmpl_ini = "";
		if (JFile::exists($tmpl_ini_file))
		{
			$tmpl_ini = JFile::read($tmpl_ini_file);
		}
		$tmpl_params = new JParameter($tmpl_ini);
		$menu_params->set('order_box', $tmpl_params->get('order_box', 1));
		$menu_params->set('show_filters', $tmpl_params->get('show_filters', 1));
		$params->set('order_box', $tmpl_params->get('order_box', 1));
		$params->set('show_filters', $tmpl_params->get('show_filters', 1));
		
		$lists['order'] 	= $mainframe->getUserStateFromRequest($option . '.list.filter_order'.$Itemid, 'filter_order', $params->get('filter_order'), 'cmd');
		$lists['order_Dir'] = $mainframe->getUserStateFromRequest($option . '.list.filter_order_Dir'.$Itemid, 'filter_order_Dir', $params->get('filter_order_dir'), 'word');
		
		$resultFilters = array();
		if ($menu_params->get('show_filters', 1))
		{
			if ($params->get('general_filter', 1) && $text_search)
			{
				$search_default = $mainframe->getUserStateFromRequest('com_community.filter_search'.$Itemid, 'search_word',  JText::_('--Text Search--'), 'string');
				$onClick = "onclick='if (this.value==\"" . JText::_("--Text Search--") . "\"){this.value=\"\"}'";
				$onBlur = "onblur='if (this.value==\"\"){this.value = \"" . JText::_("--Text Search--") . "\"}'";
				$resultFilters[] = '<input type="text" class="inputbox" value="' . $search_default . '" name="search_word" ' . $onClick . ' ' . $onBlur . ' >';
			}
			$filters = $dispacher->trigger('onRenderFilters');
			foreach ($filters as $key => $fl)
			{
				if (!is_array($fl) && ($fl == '' || empty($fl) || $fl == NULL))
				{
					unset($filters[$key]);
				}
				else 
					if (is_array($fl))
					{
						foreach ($fl as $k => $f)
						{
							if (! empty($predefined_list) && $predefined_list->params->get('pt_show_hide_' . $k, 1))
							{
								$resultFilters[$k] = $f;
							}
							else 
								if (empty($predefined_list))
								{
									$resultFilters[$k] = $f;
								}
						}
					}
			}
		}
		
		$items = $model->getData($menu_params->get('list', 0), @$predefined_list->params);
	
		$pagination = $model->getPagination(@$predefined_list->params);
		
		if (JRequest::getVar('task') == 'myfriends')
		{
			if (JRequest::getInt('user_id', 0) == 0 && ! $user->get('id'))
			{
				JError::raiseNotice(404, JText::_("No Friends to Select"));
				$mainframe->redirect(JRoute::_('index.php?option=com_community&Itemid=' . $Itemid, false));
			}
			$params->set('heading', JText::_("Friends"));
			$document->setTitle(JText::_("Friends"));
			$this->setLayout('friends_list');
			if (JRequest::getInt('user_id', 0))
			{
				$profile = &JFactory::getUser(JRequest::getInt('user_id'));
				$pathway->addItem($profile->username, 'index.php?option=com_community&view=profile&user_id=' . $profile->id . "&Itemid=" . COMMUNITY_GENERAL_PROFILE_ITEMID);
			}
			$isMy = ($user->id == JRequest::getInt('user_id', $user->id)) ? true : false;
			$pathway->addItem(JText::_("Friends"));
			$pendingFriends = $model->findPendingFriends();
			$this->assignRef('isMy', $isMy); // are these friends are mine
			for ($i = 0; $i < count($pendingFriends); $i ++)
			{
				$dispacher->trigger('onRenderAvatar', array(
					&$pendingFriends[$i]
				));
				if (! isset($pendingFriends[$i]->avatar) || empty($pendingFriends[$i]->avatar))
				{
					$pendingFriends[$i]->avatar = false;
				}
			}
		}
		else
		{
			$params->set('page_title', $menu_params->get('page_title', JText::_("User List")));
			$pathway->addItem(JText::_("User List"), 'index.php?option=com_community&view=userlist&Itemid=' . $Itemid);
			$this->setLayout('default');
		}
		if ($menu_params->get('page_title', '') == '' && $menu_params->get('show_page_title', 1))
		{
			$document->setTitle($params->get('page_title', JText::_("User List")));
		}
		for ($i = 0; $i < count($items); $i ++)
		{
			$items[$i]->avatar = 'index2.php?option=com_community&controller=profile&task=avatar&user_id='.$items[$i]->id.'&width='.$tmpl_params->get('avatar_width', 250).'&height='.$tmpl_params->get('avatar_height', 250).'&no_ajax=1';
			
			$items[$i]->additional_data = array();
			$realData = $dispacher->trigger('onListExtra', array(
				$items[$i]
			), @$userParams);
			//$items[$i]->additional_data
			foreach ($realData as $d)
			{
				if (! $d)
				{
					continue;
				}
				else 
					if (is_array($d))
					{
						foreach ($d as $v)
						{
							$items[$i]->additional_data[] = $v;
						}
					}
					else 
						if (is_object($d))
						{
							$items[$i]->additional_data[] = $d;
						}
			}
		}
		
		$task = JRequest::getVar('task', '');
		$this->assignRef('template', $template); // Friends to be added
		$this->assignRef('pendingFriends', $pendingFriends); // Friends to be added
		$this->assignRef('fworn', $model->_fworn); // Lists (Ordering)
		$this->assignRef('lists', $lists); // Lists (Ordering)
		$this->assignRef('user', $user); // Current User
		$this->assignRef('task', $task); // Current Task
		$this->assignRef('Itemid', $Itemid); // Itemid
		$this->assignRef('uri', $uri); // Itemid
		$this->assignRef('pagination', $pagination); // Pagination
		$this->assignRef('params', $params); // General Parameters
		$this->assignRef('items', $items); // Item list from the DB
		$this->assignRef('tmpl_params', $tmpl_params); // Template Parameters
		$this->assignRef('filters', $resultFilters); // Custom Filters
		$this->assignRef('request_url', $uri->toString()); // Current URL
		parent::display($tpl);
	}

	function _loadConfigurations($userid)
	{
		$ini = "";
		$path = str_replace('\\', '/', COMMUNITY_GENERAL_USERCONFIG . DS . $userid . '.ini');
		if (JFile::exists($path))
		{
			$ini = JFile::read($path);
		}
		return $ini;
	}
}
?>