<?php defined('_JEXEC') or dir('Restricted Access');
/**
 * ***************************** DESCRIPTION ***********************************
 *
 * $this->menuItems is array of objects with system menu - for system menu
 *      Each object has properties:
 *      ->alt  - title of the Menu Item example: My Details, Add a Friend
 * 			->icon - path to the the icon file image example: images/icons/someicon.png
 *      ->link - link path example: http://somedomain.com/article.html
 *                                  index.php?option=com_community
 *------------------------------------------------------------------------------
 * $this->menus is array of objects that contain title and array of menus - for
 *              additional groups of menu items
 * 				Each array element's structure is
 * 				->title - title of the menu group
 * 				->items - array of menu items same as objects of elements
 *                  of $this->menuItems.
 *------------------------------------------------------------------------------
 * $this->is_me the boolean variable containin true if this is the profile of
 *              the current user, false if current profile is not belonging to
 *              the current user
 *------------------------------------------------------------------------------
 * $this->coreData array with the collection of data that is wanted to be shown
 *                 as core user's data. Each element consist of 2 properties
 * 				->lable - the lable of the the field
 *        ->value - value of that field
 *
 *	$this->additional_data is an array of objects that have two properties
 *       ->title - the title of text returned by the plugin
 *       ->text  - and the text(html code)
 *
 * */
jimport('joomla.html.pane');
jimport('joomla.utilities.date');
$tabs = &JPane::getInstance('tabs');
?>
<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td width="30%" valign="top" colspan="2">
			<div align="left" >
				<table width="100%" >
					<tr>
						<td width="1%" valign="top">
							<img src="<?php echo JURI::root().$this->user->avatar;?>"><br clear="left">
							<?php  echo JSCommunityApi::getUserStatusMessage($this->user->id, true);?>
							<?php
							if (COMMUNITY_CARMA_ENABLE):
								$carma = JSCommunityApi::getUserCarma($this->user->id);
								echo "<br>";
								echo $carma->title;
								echo " (<b>{$carma->points}</b>)";
								echo "<br>";
								echo "<b>{$carma->image}</b>";
								endif;
							?>
						</td>
						<td align="left" valign="top">
							<table width="100%" border="0" align="left">
								<tr>
									<th class="sectiontableheader" colspan="2">
										<big><?php echo JText::_("General Info"); ?></big>
									</th>
								</tr>
								<?php if($this->tmpl_params->get('name')):?>
								<tr>
									<td width="150">
										<b><?php echo JText::_("Name")?>:</b>
									</td>
									<td>
										<?php echo $this->user->name; ?>
									</td>
								</tr>
								<?php endif;?>
								<?php if($this->tmpl_params->get('username')):?>
								<tr>
									<td width="150">
										<b><?php echo JText::_("Username")?>:</b>
									</td>
									<td>
										<?php echo $this->user->username; ?>
									</td>
								</tr>
								<?php endif;?>
								<?php if($this->tmpl_params->get('usertype')):?>
								<tr>
									<td>
										<b><?php echo JText::_("Usertype")?>:</b>
									</td>
									<td>
										<?php echo $this->user->usertype; ?>
									</td>
								</tr>
								<?php endif;?>
								<?php if($this->tmpl_params->get('regDate')):?>
								<tr>
									<td>
										<b><?php echo JText::_("Registration Date")?>:</b>
									</td>
									<td>
										<?php
										if ($this->user->registerDate == '0000-00-00 00:00:00')
										{
											echo JText::_('Never');
										}
										else
										{
											$registerDate	 = new JDate( $this->user->registerDate );
											echo $registerDate->toFormat(COMMUNITY_GENERAL_DATE_FORMAT);
										}
										?>
									</td>
								</tr>
								<?php endif;?>
								<?php if($this->tmpl_params->get('lastVisit')):?>
								<tr>
									<td>
										<b><?php echo JText::_("Last Visit")?>:</b>
									</td>
									<td>
									<?php
										if ($this->user->lastvisitDate == '0000-00-00 00:00:00')
										{
											echo JText::_('Never');
										}
										else
										{
											$lastvisitDate	 = new JDate( $this->user->lastvisitDate );
											echo $lastvisitDate->toFormat(COMMUNITY_GENERAL_DATE_FORMAT);
										}
										?>
									</td>
								</tr>
								<?php endif; ?>
								<?php foreach ($this->coreData as $data)
								{
									?>
									<tr>
										<td>
											<b><?php echo $data->lable; ?></b>:
										</td>
										<td>
											<?php echo $data->value; ?>
										</td>
									</tr>
									<?php
								}
								 ?>
							</table>
						</td>
					</tr>
				</table>
			</div>

			<?php
				/*<!-- MENU GENERATION START -->*/
			 /* ------------------------MAIN MENU--------------------------------*/
			 ?>
			<table width="100%" cellpadding="2" cellspacing="0">
				<tr>
				<?php
				foreach ($this->menuItems as $menuItem) {
					if (is_object($menuItem)){
					?>
						<td align="left" width="1%" nowrap="nowrap" valign="bottom"><img src="<?php echo $menuItem->icon;?>">
						<a href="<?php echo $menuItem->link;?>"  title="<?php echo $menuItem->alt;?>">
						<?php echo $menuItem->alt;?>
						</a>
					  </td>
					<?php
					}
				}
				?>
				<td>
				</td>
				</tr>
			</table>

			<?php /*------------------- ADDITIONAL PLUGIN MENUS ------------------*/?>
			</td>
		</tr>
		<tr>
			<td valign="top" width="10%">
			<?php if (count($this->menus)): ?>

				<?php
				foreach ($this->menus as $menuGroup) {
						$menuTitle = @$menuGroup->title;
						?>
							<table width="100%" cellpadding="2" cellspacing="0">
								<tr>
								<th colspan="2"><?php echo $menuTitle; ?></th>
									</tr>
								<tr>
								<?php
								if (count(@$menuGroup->menuItems))
								{
								foreach ($menuGroup->menuItems as $m)
								{
									?>
									<tr>
										<td width = "16"><img src="<?php echo $m->icon;?>" /></td>
										<td><a href="<?php echo $m->link;?>" title="<?php echo $m->alt;?>">
										<?php echo $m->alt;?>
										</a></td>
									</tr>
									<?php
								}
								}
								?>
								</table>
						<?php
					}
				?>
				<?php endif; ?>
			<?php /* MENU GENERATION END -- */ ?>
		</td>
		<td valign="top" align="left" >
			<div>
				<?php
					echo $this->profileParams->get('welcome_msg');
				?>
				</div>
		</td>
	</tr>

</table>
<?php if (count($this->relation_path)) :?>
<table width="100%" align="center" cellpadding="4">
<tr>
	<th >
		<?php echo JText::_("You know this person through:");?>
	</th>
</tr>
<tr>

<?php
//$rel - user
$out = array();
foreach ($this->relation_path as $rel)
{
	$link = '<a href="'.JRoute::_('index.php?option=com_community&view=profile&Itemid='.COMMUNITY_GENERAL_PROFILE_ITEMID.'&user_id='.$rel->id).'" alt="'.$rel->username.'" title="'.$rel->username.'">';
	$linkend = "</a>";
	$out[]= "<td align='center'>".$link."<img src='".JURI::root().$rel->avatar."'><br>{$rel->username}{$linkend}</td>";
}
echo implode( "<td valign='middle'><img src='components/com_community/images/str_right.gif'></td>" , $out)
?>
</tr>
</table>
<?php endif; ?>
<div>

				<?php
				echo $tabs->startPane( 'pane' );
				$i = 0;
				foreach ($this->additional_data as $key=>$val)
				{

						echo $tabs->startPanel($val->title, 'panel-main'.$key);
						echo $val->text;
						echo $tabs->endPanel();

				}
				echo $tabs->endPane();
				?>
</div>
<?php
	/**
	 * ACTIVITY STREAM
	 * The plugins must have following properties
	 * ->ctime                - the date that something happened
	 * ->user_id             - user who did the action
	 * ->username            - User's Username
	 * ->text              - the string containing what happened
	 * ->url                 - url a link to go and see something
	 * ->icon                - some icon for that action
	 **/
if (count($this->history) > 0):
?>
<div class="contentheading">
<?php if ($this->is_me)	{ echo JText::_("Friends' Activity"); }	else { echo JText::_("Activity");} ?>
</div>
<table width="100%" cellpadding="2" cellpadding="0">
<?php
foreach ($this->history as $key=>$item)
{
?>
	<tr>
		<td width="1%">
			<?php if ($item->icon): ?>
			<img src="<?php echo $item->icon;?>">
			<?php endif; ?>
		</td>
		<td width="10%" nowrap="nowrap">
		<?php
			$action	 = new JDate( $item->ctime);
			echo $action->toFormat(COMMUNITY_ACTIVITY_DATE_FORMAT_PROFILE);
		?>
		</td>
		<?php if ($item->client == 'user'): ?>
		<td align="left">
			<?php echo JSCommunityApi::getUserSlideMenu($item->user_id, $item->username);?>
			<?php echo $item->text; ?>
		</td>
		<?php else : ?>
		<td align="left">
			<?php echo JSCommunityApi::getUserSlideMenu($item->user_id,$item->username); ?>
			<?php echo $item->text; ?>
			(<a href="<?php echo JRoute::_('index.php?option=com_community&view=groups&layout=group&id='.$item->group_id);  ?>"><?php echo $item->grouptitle ?></a>)

		</td>
		<?php endif; ?>
	</tr>
<?php
}
?>
<tr>
	<td colspan="3" align="left">
		<a href="<?php echo JRoute::_("index.php?option=com_community&view=history&view-what=user&user_id={$this->user->id}&Itemid=".$this->Itemid); ?>" class="readon"><?php echo JText::_('Activity History');?></a>
	</td>
</tr>
</table>
<?php endif; ?>