<?php
/**
 * $Id: view.html.php 7951 2012-03-14 07:17:02Z kostya $
 * $LastChangedDate: 2012-03-14 13:17:02 +0600 (Wed, 14 Mar 2012) $
 * $LastChangedBy: kostya $
 * MightyTouch by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or dir('Restricted Access');

jimport( 'joomla.application.component.view');

class CommunityViewProfile extends JView
{
	/**
	 * Prepare info for User profile.
	 *
	 */

	function display($tpl = null)
	{
		global $mainframe, $option;
		$Itemid = JRequest::getInt('Itemid');
		defined('COMMUNITY_GENERAL_USR_CHOOSE_SITE_TMPL') 	or define('COMMUNITY_GENERAL_USR_CHOOSE_SITE_TMPL', '');
		defined('COMMUNITY_GENERAL_USR_CHOOSE_TMPL') 		or define('COMMUNITY_GENERAL_USR_CHOOSE_TMPL', '');
		defined('COMMUNITY_GENERAL_PROFILE_ITEMID') 		or define('COMMUNITY_GENERAL_PROFILE_ITEMID', $Itemid);
		defined('COMMUNITY_ACCESS_DEFAULT') 				or define ('COMMUNITY_ACCESS_DEFAULT', 0);
		defined('COMMUNITY_ACCESS_ALLOW_CHANGE_ACCESS') 	or define ('COMMUNITY_ACCESS_ALLOW_CHANGE_ACCESS', 0);

		//Calling a function  based on a chosen layout
		switch(JRequest::getVar('layout'))
		{
			case 'edit':
				$this->_editProf($tpl);
				return;
				break;

			case 'config':
				$this->_showPluginConfig($tpl);
				return;
				break;

			case 'friend_request':
				$this->_showFriendRequest($tpl);
				return;
				break;

			case 'invite':
				$this->_showInviteToCommunityForm($tpl);
				return;
				break;

			default:
				break;

		}
		$uri = JFactory::getURI();
		$user = JFactory::getUser();

		$model = &$this->getModel('Profile');


		if (($user->get('id') < 1 && JRequest::getVar('user_id', 0) == 0) || (!COMMUNITY_GENERAL_ALLOW_PUBLIC && $user->get('id') < 1))
		{
			CommunityHelperGeneral::redirectToLogin();

		}
		if(JRequest::getInt('user_id') == -1 )
		{
			JError::raiseError(404, JText::_("This user does not exist"));
		}

		$core_data = array(); // array to store user profile additional info as core data

		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::root()."components/com_community/assets/taber_style.css");
		$document->addStyleSheet(JURI::root()."components/com_community/assets/style.css");
		$document->addScript(JURI::root()."components/com_community/assets/javascript.js");
		$profile = $model->getData();

		$userParams = $this->_loadConfigurations($profile->id);

		$isMe = $model->getIsMe();
		$profileAccess =  $userParams->get('access', COMMUNITY_ACCESS_DEFAULT);
		//echo COMMUNITY_ACCESS_ALLOW_CHANGE_ACCESS;
		if (!COMMUNITY_ACCESS_ALLOW_CHANGE_ACCESS)
		{
			$profileAccess = COMMUNITY_ACCESS_DEFAULT;
		}

		$isHisFriend = $model->getFriends($user->get('id'));
		$tmpFriendship = false;

		if (COMMUNITY_GENERAL_USR_CHOOSE_SITE_TMPL != '')
		{
			JSCommunityApi::setUserTemplate($userParams->get('profile_site_template'));
		}

		$document->setTitle($profile->username);
		$dispacher = &JDispatcher::getInstance();

		$additional_data = $this->loadBlocks($profile);
		//----------------------------------------------

		$core_data = $dispacher->trigger('onProfileCoreData', array(&$profile, $userParams));
		$tempAdditionalData = array();
		foreach ($core_data as $data)
		{
			if (!$data){continue;}
			else if (is_array($data))
			{
				foreach ($data as $d)
				{
					$tempAdditionalData[] = $d;
				}
			}
			else if (is_object($data))
			{
				$tempAdditionalData[] = $data;
			}
		}
		$core_data = $tempAdditionalData;
		unset($tempAdditionalData);

		//--------------------------------------------------------------------------

		$pathway	=& $mainframe->getPathway();
		//$pathway->addItem(JText::_('User List'), 'index.php?option=com_community&controller=list');
		$pathway->addItem($profile->username);

		//--------------------------------------------------------------------------
		// Creating core menu items
		$menuItems = array();
		$menuItems = CommunityHelperMenu::getCoreMenus($profile, $user, $isMe );


		$this->assignRef('profileParams',   $userParams);        // Profile Parameters

		switch($profileAccess)
		{
			case 0:
				break;
			case 1:
				if ($user->get('id')<1)
				{
					JError::raiseNotice(20, JText::_("Only Registered Users can see this profile"));
					$this->_showPreview($profile, $menuItems, $tpl);
					return;
				}
				break;
			case 2:

				if (!$isMe && !$model->isMyFriend($profile->id))
				{
					$requestLink = '';
					$tmpFriendship = true;
					if (COMMUNITY_GENERAL_ALLOW_FRIENDS)
					{
						$requestLink = " <a href='index.php?option=com_community&view=profile&layout=friend_request&user_id=".$profile->id."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID."'>".JText::_('Send a friend request')."</a>";
					}
					JError::raiseNotice(20, JText::_("This profile is accesible only for the friends of this user.").$requestLink);
					$this->_showPreview($profile, $menuItems, $tpl);

					return;
				}
				break;
			case 3:
				if ($user->get('id') != $profile->id)
				{
					JError::raiseNotice(20, JText::_("Only owner of the profile can access his/her profile"));
					$this->_showPreview($profile, $menuItems, $tpl);
					return;
				}
				break;
			default:
				break;
		}

		// Creating plugin menuItems
		$menus = array();
		$menus = CommunityHelperMenu::getPluginMenus($profile, $userParams);
		//--------------------------------------------------------------------------

		$current_template = $userParams->get('profile_template', (COMMUNITY_GENERAL_DEFAULT_PROFILE_TEMPLATE?COMMUNITY_GENERAL_DEFAULT_PROFILE_TEMPLATE:'default'));
		$templateParams = "";
		$tmpl_ini_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'views'.DS.'profile'.DS.'tmpl'.DS.'default_profile_'.$current_template.'.ini';
		$tmpl_ini = "";
		if(JFile::exists($tmpl_ini_file))
		{
			$tmpl_ini = JFile::read($tmpl_ini_file);
		}
		$tmpl_params = new JParameter($tmpl_ini);

		$profile->avatar = 'index2.php?option=com_community&controller=profile&task=avatar&user_id='.$profile->id.'&width='.$tmpl_params->get('avatar_width', 250).'&height='.$tmpl_params->get('avatar_height', 250).'&no_ajax=1';

		$relations = array();

		if (COMMUNITY_FRIENDS_ENABLE)
		{
			$relations = array();
			if ($user->id > 0 && $profile->id != $user->id && !$model->isMyFriend($profile->id))
			{
				$friend_path = $model->getFriendPath($user->id, $profile->id);
				foreach ($friend_path as $element)
				{
					if (!$element)
					{
						continue;
					}
					//$friend = new stdClass();
					$friend = JFactory::getUser($element);
					$friend->avatar = 'index2.php?option=com_community&controller=profile&task=avatar&user_id='.$friend->id.'&width='.$tmpl_params->get('avatar_width', 250).'&height='.$tmpl_params->get('avatar_height', 250).'&no_ajax=1';
					$relations[] = $friend;
				}
			}
		}
		if ($user->id == $profile->id)
		{
			JRequest::setVar('view-what', 'profile');
		}
		else
		{
			JRequest::setVar('view-what', 'user');
		}
		$history = array();

		if (COMMUNITY_HISTORY_PROFILE_ENABLE && COMMUNITY_HISTORY_ALL_ENABLE && (COMMUNITY_HISTORY_ACCESS <= $user->get('aid'))) {
			$historyModel = &JModel::getInstance('History', 'CommunityModel');
			$mainframe->setUserState($option.'.history.activity_type', Jtext::_('All Activity'));
			if($isMe) $var = 'friends'; else $var = 'my';
			JRequest::setVar('view_what', $var);
			JRequest::setVar('id', $profile->id);
			$history = &$historyModel->getData(COMMUNITY_HISTORY_PROFILE_LIMIT);
			JRequest::setVar('view_what', NULL);
			JRequest::setVar('id', NULL);
		}
		$model->addGuest($profile->id, $user->id);

		$status = JSCommunityApi::getUserStatusMessage($profile->id, $model->getIsMe());

		$this->assignRef('status',   $status);
		$this->assignRef('relation_path',   $relations);
		$this->assignRef('history',         $history);       	 // Data from the plugin that is wanted to be shown as core
		$this->assignRef("Itemid",          $Itemid);            // ItemId
		//$this->assignRef('profileParams',   $userParams);        // Profile Parameters
		$this->assignRef('menuItems',       $menuItems);         // Additional  menu items generated by plugins
		$this->assignRef('menus',           $menus);             // Additional  menu groups generated by plugins
		$this->assignRef('additional_data', $additional_data);   // user additional data
		$this->assignRef('user',            $profile);           // user core data with avatar
		$this->assign('is_me',           $model->getIsMe()); // is this is me
		$this->assignRef('tmpl_params',     $tmpl_params);       // Template Parameters
		$this->assignRef('coreData',        $core_data);       	 // Data from the plugin that is wanted to be shown as core
		$this->assignRef('cur_user',        JFactory::getUser());       	 // Data from the plugin that is wanted to be shown as core
		//$this->assignRef('request_url',	    $uri->toString());   // uri ; don't know why i need it
		parent::display($tpl);
	}


	/**
	 * Prepare info for Edit page
	 *
	 */
	function _editProf($tpl = null)
	{
		defined('COMMUNITY_GENERAL_USR_CHOOSE_TMPL') or define('COMMUNITY_GENERAL_USR_CHOOSE_TMPL', '');
		defined('COMMUNITY_GENERAL_USR_CHOOSE_SITE_TMPL') or define('COMMUNITY_GENERAL_USR_CHOOSE_SITE_TMPL', '');
		global $Itemid, $mainframe;

		$uri		= &JFactory::getURI();
		$user       = JFactory::getUser();
		/*
		 * Redirect the user if he is not logged in.
		 */
		if ($user->get('id') < 1)
		{
			CommunityHelperGeneral::redirectToLogin();

		}

		$document   = &JFactory::getDocument();

		$pathway	  =& $mainframe->getPathway();
		$activeMenu	= &JSite::getMenu();
		$editor = JFactory::getEditor();
		$document->addStyleSheet(JURI::root()."components/com_community/assets/taber_style.css");

		$menu	  = $activeMenu->getActive();
		$menu_params = new JParameter( @$menu->params );


		$document->addScript(JURI::root()."components/com_community/js/shadowbox/adapter/shadowbox-base.js");
		$document->addScript(JURI::root()."components/com_community/js/shadowbox/shadowbox.js");

		$document->setTitle($menu_params->get('page_title', $user->username." ".JText::_("Edit My Profile")) );


		$pathway->addItem($user->username, 'index.php?option=com_community&view=profile&user_id='.$user->id."&Itemid=".COMMUNITY_GENERAL_PROFILE_ITEMID);
		$pathway->addItem(JText::_("Edit Profile"));

		$dispacher = &JDispatcher::getInstance();
		$user->avatar = 'index2.php?option=com_community&controller=profile&task=avatar&user_id='.$user->id.'&width=250&height=250&no_ajax=1';

		//--------------------------------------------------------------------------
		//getting configuratons from the plugins
		$params = $this->_loadConfigurations($user->get('id'));
		$userBlocks   = CommunityHelperUserConfigs::getBlocks($user);
		//--------------------------------------------------------------------------

		$lists['templates'] = $this->getTemplates(COMMUNITY_GENERAL_USR_CHOOSE_TMPL, $params, 'profile_template');
		$lists['sitetemplates'] =  $this->getTemplates(COMMUNITY_GENERAL_USR_CHOOSE_SITE_TMPL, $params, 'profile_site_template');

		$this->assignRef('editor',          $editor);
		$this->assignRef('params',          $params);
		$this->assignRef('user',            $user);
		$this->assignRef('userBlocks', 		$userBlocks);
		$this->assignRef('lists',           $lists);
		$this->assignRef('uri',             $uri);
		parent::display($tpl);
	}

	function getTemplates($list, $params, $name)
	{
		if(!$list) return array();
		$templates =  explode('|', $list);

		$options[] = JHTML::_('select.option', '', $name == 'profile_site_template' ? JText::_('-Select Site Template-') : JText::_('-Select Profile Template-'));

		foreach ($templates as $tmpl)
		{
			$options[] = JHTML::_('select.option', $tmpl, $tmpl);
		}

		if (count($options) > 1)
		{
			return JHTML::_('select.genericlist',  $options, "params[{$name}]", 'class="inputbox"', 'value', 'text', $params->get($name));
		}
		return array();
	}
	function _showFriendRequest($tpl = null)
	{
		global $mainframe;
		if (!COMMUNITY_GENERAL_ALLOW_FRIENDS)
		{
			JError::raiseNotice(400, JText::_('Friendship is disabled'));
			return;
			//$mainframe->setRedirect();
		}
		$profile = $this->get('Data');
		$user = &JFactory::getUser();
		if($user->get('id') < 1)
		{
			CommunityHelperGeneral::redirectToLogin();
		}
		$uri = &JFactory::getUri();

		$this->assignRef('profile', $profile);
		$this->assignRef('user', $user);
		$this->assignRef('uri', $uri);
		parent::display($tpl);
	}


	function _showPluginConfig($tpl = null)
	{
		$user = JFactory::getUser();
		$plgid  = JRequest::getInt('plgid' , 0);
		$uid 	= $user->get('id', 0);
		$model = &JModel::getInstance('Profile', 'CommunityModel');

		if ($uid == 0 || $plgid == 0)
		{
			JError::raiseError(404 , JText::_('User or plugin not found'));
			return;
		}
		$uri = &JFactory::getUri();
		$block = CommunityHelperUserConfigs::userEditBlockCheckBlockExistence($uid, $plgid);
		if ($block === false)
		{
			JError::raiseNotice(100, JText::_("Could not create new instance of plug-in"));
		}
		$plugin = $model->getPluginCoreConfigurations($plgid);
		$table = &JTable::getInstance('Blocks', "CommunityTable");
		$table->load($block->id);

		$params = new JParameter($table->get('params', ''), JPATH_ROOT.DS.'plugins'.DS.'community'.DS.$block->element.'.xml');

		$param_form_string = $params->render($block->name, "Custom Parameters");

		$this->assignRef('block',   $table);
		$this->assignRef('plugin',  $plugin);
		$this->assignRef('params',  $params);
		$this->assignRef('uri',     $uri);
		parent::display($tpl);
	}



	/**
	 * Enter description here...
	 *
	 * @param unknown_type $tpl
	 */
	function _showInviteToCommunityForm($tpl = null)
	{
		global $mainframe;
		$uri              = &JFactory::getURI();
		$user             = &JFactory::getUser();
		$document         = &JFactory::getDocument();
		$pathway	      = &$mainframe->getPathway();

		$menus            = &JSite::getMenu();
		$menu             = $menus->getActive();
		$menu_params      = new JParameter( @$menu->params );



		$params = new JParameter('');
		$params->set('page_title', $menu_params->get("page_title", JText::_('Invite To Community')));
		$params->set('show_page_title', $menu_params->get('show_page_title', 1));
		$return = JRequest::getString('return', '');

		$document->setTitle($params->get("page_title"));



		$this->assignRef('return_url', $return);
		$this->assignRef('params', $params);
		$this->assignRef('user', $user);
		$this->assignRef('uri', $uri);
		parent::display($tpl);
	}



	/**
	 * Load User configurations
	 *
	 * @param  int $userid
	 * @return string
	 */
	function _loadConfigurations($userid)
	{
		$path = str_replace('\\', '/', COMMUNITY_GENERAL_USERCONFIG.DS.$userid.'.ini');
		$content = CommunityHelperUserConfigs::loadIni($path);
		return new JParameter($content, JPATH_COMPONENT.DS.'views'.DS.'profile'.DS.'user_params.xml');
	}


	/**
	 * this function renders param for the configurations page
	 *
	 * @param string $group_name
	 */
	function renderParamsGroup( $group_name )
	{
		// index 0 for the label, index 1 for the rendered value
		$paramsArray = $this->params->renderToArray('params', $group_name);


		?>

			<div class="contentpaneopen">
			<table width="100%" cellpadding="5" border="0">
			<?php foreach ($paramsArray as $key=> $param): ?>
			<?php if($key == 'user_editor' && !COMMUNITY_GENERAL_CHOOSE_EDITOR) {continue;} ?>
			<tr>
			<td class="key"><?php echo $param[0]; ?><br />
			<?php echo $param[1]; ?></td>
			</tr>
			<?php endforeach; ?>
			</table>
			</div>
			<?php
		}


	/**
	 * This function loads uesr block chosen by the profile's user
	 *
	 * @param mixed $profile object with the profile info of the user
	 * @return mixed array of block
	 */
	function loadBlocks($profile)
	{

		$db = &JFactory::getDBO();
		$userBlocks   = CommunityHelperUserConfigs::getBlocks($profile);
		$dispacher = &JDispatcher::getInstance();
		defined ('COMMUNITY_BLOCKS_HIDE_CONFIG') or define('COMMUNITY_BLOCKS_HIDE_CONFIG', '');
		$toHideTmp = explode("|",COMMUNITY_BLOCKS_HIDE_CONFIG);
		$tohide = "";
		if ($toHideTmp[0]!= '' && !empty($toHideTmp[0]))
		{
			$tohide = " AND plg.id NOT IN (".implode(" , ", $toHideTmp).") ";
		}
		unset($toHideTmp);
		$user = JFactory::getUser();

		$sql = "SELECT blck.*, plg.id, plg.element, plg.params AS plugin_params, plg.name AS plugintitle FROM #__community_blocks AS blck "
		."\n LEFT JOIN #__plugins AS plg ON blck.plugin_id = plg.id"
		."\n WHERE blck.user_id = {$profile->id} AND plg.published = 1  {$tohide}  GROUP BY blck.plugin_id ORDER BY `ordering`";

		$db->setQuery($sql);
		$blocksFromDb = $db->loadObjectList();
		$blocks = array();

		foreach ($blocksFromDb as $blk)
		{
			$plugin_params = new JParameter($blk->plugin_params);
			if (!$plugin_params->get('allow_publish'))
			{$published = $plugin_params->get('default_status', 1);}
			else
			{$published = $blk->published;}
			if (!$plugin_params->get('allow_accesschange'))
			{$access = $plugin_params->get('default_access ', 0);}
			else
			{$access = $blk->access;}

			//Check if plugin is published
			if (!$published){continue;}
			// If it is published then we check the access of the plugin
			// he he
			if ($access == 1)
			{
				if ($user->get('id')<1)
				{
					continue;
				}

			} else if ($access == 2)
			{
				$model = &$this->getModel('Profile');
				if (($user->get('id') != $profile->id) && (count($model->getFriends($user->get('id')))<1 || $user->get('id') < 1))
				{
					continue;
				}

			} else if ($access == 3 && ($user->get('id') != $profile->id))
			{
				continue;
			}
			$userParams = new JParameter((string)$blk->params);
			$return = $dispacher->trigger('onProfileExtra', array($profile, $userParams, $blk->element));

			$return = CommunityHelperGeneral::_cleanArray($return);
			foreach ($return as $ret)
			{
				$title = '';
				if (!empty($ret) && (is_object($ret) || is_array($ret)))
				{
					if (is_array($ret))
					{
						$ret = CommunityHelperGeneral::_cleanArray($ret);
						foreach ($ret as $r)
						{
							$blocks[] = $r;
						}
					}
					else
					{
						//plugintitle
						if ($plugin_params->get('allow_titlechange', 1))
						{
							$ret->title = $blk->title;
						}
						else
						{
							$ret->title = $blk->plugintitle;
						}
						$ret->description = $blk->description;
						$blocks[] = $ret;
					}

				}

			}
		}

		return $blocks;

	}

	function _showPreview(&$profile,&$menuItems, $tpl = null)
	{
		$this->setLayout('preview');
		$this->assignRef('user', $profile);
		$this->assignRef('menuItems', $menuItems);
		parent::display($tpl);
		return;
	}
	function getGroupTitle($id)
	{
		$db = & JFactory::getDBO();
		static $result = array();

		if(@$result[$id]) return $result[$id];

		$sql2 = " SELECT title FROM  #__community_communities WHERE id = $id";
		$db->setQuery($sql2);
		$result[$id] = $db->loadResult();

		return $result[$id];
	}


}
?>